IMPLEMENTATION MODULE CDate;

(*
 * 12.01.1997  -  DaysToDate implementiert (ob das so funktioniert ...? :)
 *             -  Bugfix: In DaysGone wurde grtenteils nur mit SHORTs
 *                gerechnet (Urks)
 * 24.01.1997  -  mglichen berlauf in DaysGone abfangen
 *)

FROM     SYSTEM         IMPORT   BYTE;
FROM     TimeNDate      IMPORT   Date;
FROM     Strings1       IMPORT   Assign;
IMPORT   ModReg;
(*
IMPORT   InOut;
*)

VAR      daysPerMonth:  ARRAY [1 .. 12] OF CARDINAL;
         daysTillBegin: ARRAY [1 .. 12] OF CARDINAL;
            (* bis zum Monatsanfang bereits vergangene Tage *)


PROCEDURE Legal(date: Date): BOOLEAN;
(*
 * TRUE, wenn date ein gltiges Datum ist,
 * FALSE sonst
 *)
VAR   result:  BOOLEAN;
BEGIN
   result := TRUE;
   (* allgemeine Bereichsprfung *)
   result := NOT((date.day=0) OR (date.day>daysPerMonth[date.month]) OR
                 (date.month=0) OR (date.month>12));
   (* Bereichsprfung fr Februar (Schalttag) *)
   IF result AND (date.month=2) AND (date.day>28) THEN
      result := FALSE;
      (* durch vier teilbar? *)
      IF (date.year MOD 4)=0 THEN
         (* Jahrhundert durch 400 teilbar? *)
         IF ((date.year MOD 100)#0) OR ((date.year MOD 400)=0) THEN
            (* Schaltjahr, es gibt einen 29. *)
            result := TRUE;
         END;
      END;
   END;
   RETURN result;
END Legal;

PROCEDURE DaysGone(date: Date): LONGCARD;
(*
 * liefert die Anzahl der seit dem Jahr Null vergangenen Tage.
 * Benutzt wird der gregorianische Kalender. Werte fr Tage vor der
 * Einfhrung desselben im Jahre 1582 sind daher nicht besonders sinnvoll. :)
 *)
VAR   result: LONGCARD;
BEGIN
   result := 0L;
   IF date.year<3000 THEN
      result := LONG(date.year)*365L+LONG(daysTillBegin[date.month])+LONG(date.day);
      IF date.year > 0 THEN
         (* Schaltjahre addieren *)
         DEC(date.year);
         INC(result, date.year DIV 4);
         DEC(result, date.year DIV 400);
         INC(date.year);
         (* falls der Februar vergangen ist, mu auch das aktuelle Jahr
            beachtet werden *)
         IF ((LONG(date.year) MOD 4L)=0L) AND ((LONG(date.year) MOD 400L)#0L) AND
            (date.month>2) THEN
            (* Schaltjahr, einen Tag addieren *)
            INC(result);
         END;
      END;
   END;
   RETURN result;
END DaysGone;

PROCEDURE DaysToDate(    days: LONGCARD;
                     VAR date: Date);
(*
 * Umkehrfunktion zu DaysGone. Liefert zu den seit dem Jahr Null vergangenen
 * Tagen das passende Datum.
 *)
VAR   daysgone:   LONGCARD;
BEGIN
   date.year := SHORT(days DIV 365L);
   date.month := 1;
   date.day := 0;
   daysgone := DaysGone(date);
   WHILE daysgone>days DO
      DEC(date.year);
      daysgone := DaysGone(date);
   END;
   WHILE (date.month<12) AND ((daysgone+LONG(daysTillBegin[date.month+1]))<days) DO
      INC(date.month);
   END;
   date.day := SHORT(days-daysgone-LONG(daysTillBegin[date.month]));
END DaysToDate;

PROCEDURE DayOfWeek(date: Date): Weekday;
(*
 * Gibt den Wochentag fr das angegebene Datum aus.
 * Gltigkeitsbereich siehe DaysGone.
 *)
BEGIN
   RETURN Weekday(CHR(SHORT((DaysGone(date)+2L) MOD 7L)));
END DayOfWeek;

PROCEDURE WeekdayToStr(day: Weekday; VAR str: ARRAY OF CHAR);
(*
 * Der Wochentag als Text. Z.Zt. ausschlielich in Deutsch.
 *)
BEGIN
   CASE day OF
   | Mo:
      Assign('Montag', str);
   | Di:
      Assign('Dienstag', str);
   | Mi:
      Assign('Mittwoch', str);
   | Do:
      Assign('Donnerstag', str);
   | Fr:
      Assign('Freitag', str);
   | Sa:
      Assign('Samstag', str);
   | So:
      Assign('Sonntag', str);
   END;
END WeekdayToStr;

BEGIN
   ModReg.Register('CDate',0,0,' ',1997,01,24,PROC(NIL));
   daysPerMonth[1] := 31;
   daysPerMonth[2] := 29;
   daysPerMonth[3] := 31;
   daysPerMonth[4] := 30;
   daysPerMonth[5] := 31;
   daysPerMonth[6] := 30;
   daysPerMonth[7] := 31;
   daysPerMonth[8] := 31;
   daysPerMonth[9] := 30;
   daysPerMonth[10] := 31;
   daysPerMonth[11] := 30;
   daysPerMonth[12] := 31;
   daysTillBegin[1] := 0;
   daysTillBegin[2] := 31;
   daysTillBegin[3] := 59;
   daysTillBegin[4] := 90;
   daysTillBegin[5] := 120;
   daysTillBegin[6] := 151;
   daysTillBegin[7] := 181;
   daysTillBegin[8] := 212;
   daysTillBegin[9] := 243;
   daysTillBegin[10] := 273;
   daysTillBegin[11] := 304;
   daysTillBegin[12] := 334;

END CDate.
