IMPLEMENTATION MODULE MausLibrary;

(*
 * 29.07.1995  AM    MausVarDat gendert: name an neuer Position
 *)

FROM     System         IMPORT   GetEnv;
FROM     Storage        IMPORT   ALLOCATE, DEALLOCATE;
FROM     Directories    IMPORT   GetCurDir, ChDir;
FROM     Strings        IMPORT   Copy, Assign, CompareStr, Pos, Concat,
                                 Delete, Length;
FROM     Strings1       IMPORT   RemoveTrailingSpaces, RemoveLeadingSpaces,
                                 Upper, CorrectPath, P2MString;
FROM     Files          IMPORT   Open, Close, READ, Read, Write;
FROM     InOut          IMPORT   RedirectInput, CloseInput, ReadLine, termCH,
                                 WriteString, WriteLine;
FROM     ASCII          IMPORT   EOF;
IMPORT   ModReg;


VAR      path:       String127;
         mausvars:   POINTER TO MausVarDat;

PROCEDURE IstInGruppe(gruppe: CARDINAL;
                      set:    tGruppenSet): BOOLEAN;
VAR   array,
      element,
      bitset,
      bit:     CARDINAL;
BEGIN
  (* INC(gruppe); *)
  array := gruppe DIV 256;
  element := gruppe MOD 256;
  bitset := element DIV (SIZE(BITSET)*8);
  bit := element MOD (SIZE(BITSET)*8);
  RETURN (bit IN set[array][bitset]);
END IstInGruppe;

PROCEDURE InclGruppe(gruppe:  CARDINAL;
                     VAR set: tGruppenSet);
VAR   array,
      element,
      bitset,
      bit:     CARDINAL;
BEGIN
  (* INC(gruppe); *)
  array := gruppe DIV 256;
  element := gruppe MOD 256;
  bitset := element DIV (SIZE(BITSET)*8);
  bit := element MOD (SIZE(BITSET)*8);
  INCL(set[array][bitset], bit);
END InclGruppe;

PROCEDURE ExclGruppe(gruppe:  CARDINAL;
                     VAR set: tGruppenSet);
VAR   array,
      element,
      bitset,
      bit:     CARDINAL;
BEGIN
  (* INC(gruppe); *)
  array := gruppe DIV 256;
  element := gruppe MOD 256;
  bitset := element DIV (SIZE(BITSET)*8);
  bit := element MOD (SIZE(BITSET)*8);
  EXCL(set[array][bitset], bit);
END ExclGruppe;

PROCEDURE ReadMausVarDat;
VAR   file:       INTEGER;
      filename:   ARRAY [0 .. 255] OF CHAR;
      read:       CARDINAL;
BEGIN
   MausName[0] := 0C;
   MausNr := 0;
   Concat(MausPath, 'MAUSVAR.DAT', filename);
   Open(file, filename, READ);
   IF file>=0 THEN
      (*debug
      WriteString(filename);
      WriteLine(" geffnet");
      debug*)
      ALLOCATE(mausvars, SIZE(MausVarDat));
      IF mausvars#NIL THEN
         Read(file, mausvars, SIZE(MausVarDat), read);
         IF ORD(mausvars^.name[0])>0 THEN
            P2MString(mausvars^.name, MausName);
         ELSE
            P2MString(mausvars^.namealt, MausName);
         END;
         MausNr := ORD(mausvars^.nr);
         (*debug
         IF MausNr#0 THEN
            WriteLine("MausNr gelesen");
         ELSE
            WriteLine("MausNr = 0!?");
         END;
         debug*)
         DEALLOCATE(mausvars, SIZE(MausVarDat));
      END;
      Close(file);
      (*debug
      WriteString(filename);
      WriteLine(" geschlossen");
      debug*)
   ELSE
      (*debug
      WriteString(filename);
      WriteLine(" konnte nicht geffnet werden!");
      debug*)
   END;
END ReadMausVarDat;

BEGIN
   ModReg.Register('MausLibrary',0,0,' ',1996,10,16,PROC(NIL));
   GetCurDir(0, path);
   GetEnv('MAUSPATH', MausPath);
   IF MausPath[0]=0C THEN
      GetCurDir(0, MausPath);
   END;
   CorrectPath(MausPath);
   ReadMausVarDat;

END MausLibrary.

