IMPLEMENTATION MODULE Quicksort;

FROM     SYSTEM            IMPORT   ADDRESS;
IMPORT   ModReg;


PROCEDURE Sort(    array:  ADDRESS;
               VAR index:  ARRAY OF CARDINAL;
                   start,
                   end:    CARDINAL;
                   less:   CompareProc);

VAR   i: CARDINAL;

   PROCEDURE FindPivot(    start, end: CARDINAL;
                       VAR pivot:      CARDINAL): BOOLEAN;
   VAR   j:       CARDINAL;

         str:     ARRAY [0 .. 8] OF CHAR;

   BEGIN
      pivot := index[start];
      (* IF start<end THEN *)
         FOR j := start+1 TO end DO
            IF less(array, index[start], index[j]) THEN
               pivot := index[j];
               RETURN TRUE;
            ELSIF less(array, index[j], index[start]) THEN
               RETURN TRUE;
            END;
         END;
      (* END; *)
      RETURN FALSE
   END FindPivot;

   PROCEDURE Part(start, end, pivot: CARDINAL): CARDINAL;
   VAR   left,
         right:   CARDINAL;
         tmp:     CARDINAL;
   BEGIN
      left := start;
      right := end;
      REPEAT
         tmp := index[left];
         index[left] := index[right];
         index[right] := tmp;
         WHILE less(array, index[left], pivot) DO
            INC(left);
         END;
         WHILE ~less(array, index[right], pivot) DO
            DEC(right);
         END;
      UNTIL left>right;
      RETURN left;
   END Part;

   PROCEDURE QSort(start, end: CARDINAL);
   VAR   pivot,
         part:    CARDINAL;
   BEGIN
      IF FindPivot(start, end, pivot) THEN
         part := Part(start, end, pivot);
         QSort(start, part-1);
         QSort(part, end);
      END;
   END QSort;

BEGIN
   (*
   FOR i := start TO end DO
      index[i] := i;
   END;
   *)
   QSort(start, end);
END Sort;

BEGIN
   ModReg.Register('Quicksort', 0,0,' ',1996,10,16,PROC(NIL));

END Quicksort.
