IMPLEMENTATION MODULE Strings1;

(*
 * 24.09.1996  -  Patch und Replace hinzugefgt
 * 26.12.1996  -  Replace liefert einen boolschen Wert zurck
 * 24.01.1997  -  Capital mochte keine leeren Strings
 *)


FROM     SYSTEM            IMPORT   ADR, ADDRESS;
FROM     System            IMPORT   Move;
FROM     Strings           IMPORT   Delete, Copy, Length, Concat, Pos,
                                    Append, Insert;
IMPORT   ModReg;


CONST    UPPERDIST   =  ORD('a')-ORD('A');


PROCEDURE Assign(    source: ARRAY OF CHAR;
                 VAR dest:   ARRAY OF CHAR);
VAR i, high: CARDINAL;
BEGIN
   high := Length(source)-1;
   IF HIGH(dest)<high THEN
      high := HIGH(dest);
   END;
   i := 0;
   WHILE (i<=high) AND (source[i]#0C) DO
      dest[i] := source[i];
      INC(i);
   END;
   IF i<HIGH(dest) THEN
      dest[i] := 0C;
   END;
END Assign;

PROCEDURE Fill(VAR string: ARRAY OF CHAR;
                   len:    CARDINAL;
                   char:   CHAR);
VAR   i: CARDINAL;
BEGIN
   i := Length(string);
   WHILE i<len DO
      string[i] := char;
      INC(i);
   END;
   IF SIZE(string)>=i THEN
      string[i] := 0C;
   END;
END Fill;

PROCEDURE RemoveLeadingSpaces(VAR string: ARRAY OF CHAR);
VAR   i: CARDINAL;
BEGIN
   i := 0;
   WHILE string[i]=' ' DO
      INC(i);
   END;
   Delete(string, 0, i);
END RemoveLeadingSpaces;

PROCEDURE RemoveTrailingSpaces(VAR string: ARRAY OF CHAR);
VAR   i: CARDINAL;
BEGIN
   IF Length(string)>0 THEN
      i := Length(string)-1;
      WHILE string[i]=' ' DO
         string[i] := 0C;
         IF i>0 THEN
            DEC(i);
         END;
      END;
   END;
END RemoveTrailingSpaces;

PROCEDURE Trim(VAR string: ARRAY OF CHAR);
VAR   i: CARDINAL;
BEGIN
   i := 0;
   WHILE string[i]=' ' DO
      INC(i);
   END;
   Delete(string, 0, i);
   IF Length(string)>0 THEN
      i := Length(string)-1;
      WHILE string[i]=' ' DO
         string[i] := 0C;
         IF i>0 THEN
            DEC(i);
         END;
      END;
   END;
END Trim;


PROCEDURE IsChar(char: CHAR): BOOLEAN;
(*
 * TRUE genau dann, wenn char ein Buchstabe von A-Z oder ein Umlaut ist
 *)
VAR   ord:  CARDINAL;
BEGIN
   ord := ORD(char);
   RETURN (((ord>=ORD('a')) AND (ord<=ORD('z'))) OR
           ((ord>=ORD('A')) AND (ord<=ORD('Z'))) OR
           (Pos(char, '')<=6));
END IsChar;

PROCEDURE Upper(VAR string: ARRAY OF CHAR);
VAR   i: CARDINAL;
BEGIN
   IF string[0]#0C THEN
      FOR i := 0 TO Length(string)-1 DO
         CASE string[i] OF
         | 'a' .. 'z':
            string[i] := CHR(ORD(string[i])-UPPERDIST);
         | '':
            string[i] := '';
         | '':
            string[i] := '';
         | '':
            string[i] := '';
         ELSE
         END;
      END;
   END;
END Upper;

PROCEDURE Lower(VAR string: ARRAY OF CHAR);
(*
 * in Kleinbuchstaben wandeln
 *)
VAR   i: CARDINAL;
BEGIN
   FOR i := 0 TO Length(string)-1 DO
      CASE string[i] OF
      | 'A' .. 'Z':
         string[i] := CHR(ORD(string[i])+UPPERDIST);
      | '':
         string[i] := '';
      | '':
         string[i] := '';
      | '':
         string[i] := '';
      ELSE
      END;
   END;
END Lower;

PROCEDURE Capital(VAR string: ARRAY OF CHAR);
(*
 * in Hauptwort (jeder erste Buchstabe gro, Rest klein) wandeln
 *)
VAR   i, len:  CARDINAL;
      begin:   BOOLEAN;
BEGIN
   begin := TRUE;
   len := Length(string);
   IF len>0 THEN
      FOR i := 0 TO len-1 DO
         IF IsChar(string[i]) THEN
            IF begin THEN
               begin := FALSE;
               CASE string[i] OF
               | 'a' .. 'z':
                  string[i] := CHR(ORD(string[i])-UPPERDIST);
               | '':
                  string[i] := '';
               | '':
                  string[i] := '';
               | '':
                  string[i] := '';
               ELSE
               END;
            ELSE
               CASE string[i] OF
               | 'A' .. 'Z':
                  string[i] := CHR(ORD(string[i])+UPPERDIST);
               | '':
                  string[i] := '';
               | '':
                  string[i] := '';
               | '':
                  string[i] := '';
               ELSE
               END;
            END;
         ELSE
            begin := TRUE;
         END;
      END;
   END;
END Capital;

PROCEDURE ConvUmlaute(VAR str: ARRAY OF CHAR);
(*
 * ersetzt ᎙ durch ihre ASCII-quivalente ae,oe,...
 *)
VAR   i: CARDINAL;
BEGIN
   i := 0;
   WHILE i<Length(str) DO
      CASE str[i] OF
      | '':
         Delete(str, i, 1);
         Insert('ae', str, i);
      | '':
         Delete(str, i, 1);
         Insert('oe', str, i);
      | '':
         Delete(str, i, 1);
         Insert('ue', str, i);
      | '':
         Delete(str, i, 1);
         Insert('ss', str, i);
      | '':
         Delete(str, i, 1);
         Insert('Ae', str, i);
      | '':
         Delete(str, i, 1);
         Insert('Oe', str, i);
      | '':
         Delete(str, i, 1);
         Insert('Ue', str, i);
      ELSE
      END;
      INC(i);
   END;
END ConvUmlaute;


PROCEDURE P2MString(    pstring: ARRAY OF CHAR;
                    VAR result:  ARRAY OF CHAR);
BEGIN
   Copy(pstring, 1, ORD(pstring[0]), result);
   IF HIGH(result)>=ORD(pstring[0]) THEN
      result[ORD(pstring[0])] := 0C;
   END;
END P2MString;

PROCEDURE M2PString(    mstring: ARRAY OF CHAR;
                    VAR result:  ARRAY OF CHAR);
BEGIN
   Concat(CHR(Length(mstring)), mstring, result);
END M2PString;

PROCEDURE CorrectPath(VAR path: ARRAY OF CHAR);
BEGIN
   IF path[0]#0C THEN
      IF path[Length(path)-1]#'\' THEN
         Append(path, '\');
      END;
   END;
END CorrectPath;

PROCEDURE Patch(VAR str:   ARRAY OF CHAR;
                    pos:   CARDINAL;
                    pat:   ARRAY OF CHAR);
   (*
    * berschreibt str ab Position pos mit pat.
    *)
VAR   len:  CARDINAL;
BEGIN
   IF Length(pat)<(HIGH(str)-pos) THEN
      len :=  Length(pat);
   ELSE
      len := HIGH(str)-pos;
   END;
   Move(ADR(pat), ADDRESS(LONGCARD(ADR(str))+LONG(pos)), len);
END Patch;

PROCEDURE Replace(VAR src: ARRAY OF CHAR;
                      old,
                      new: ARRAY OF CHAR): BOOLEAN;
VAR   result:  BOOLEAN;
      pos:     CARDINAL;
BEGIN
   result := FALSE;
   pos := Pos(old, src);
   IF pos<HIGH(src) THEN
      Delete(src, pos, Length(old));
      Insert(new, src, pos);
      result := TRUE;
   END;
   RETURN result;
END Replace;

BEGIN
   ModReg.Register('Strings1', 0,0, 0C, 1997,01,24,PROC(NIL));


END Strings1.
