IMPLEMENTATION MODULE TimeNDate;


IMPORT   TimeDate;
FROM     NumberConversion     IMPORT   CardToString, StringToCard;
FROM     Strings              IMPORT   Append, Copy, Delete, Pos;
IMPORT   ModReg;


PROCEDURE GetTime(VAR time: Time);
VAR   t: TimeDate.Time;
BEGIN
   TimeDate.GetTime(t);
   time.h := t.minute DIV 60;
   time.m := t.minute MOD 60;
   time.s := t.millisec DIV 1000;
END GetTime;

PROCEDURE GetDate(VAR date: Date);
VAR   t: TimeDate.Time;
BEGIN
   TimeDate.GetTime(t);
   date.year := 1900+(t.day DIV 512);
   date.month := (t.day MOD 512) DIV 32;
   date.day := t.day MOD 32;
END GetDate;


PROCEDURE SetTime(time: Time);
VAR   t: TimeDate.Time;
BEGIN
   TimeDate.GetTime(t);
   t.minute := time.h*60+time.m;
   t.millisec := time.s*1000;
   TimeDate.SetTime(t);
END SetTime;

PROCEDURE SetDate(date: Date);
VAR   t: TimeDate.Time;
BEGIN
   TimeDate.GetTime(t);
   t.day := ((date.year-1900)*16+date.month)*32+date.day;
   TimeDate.SetTime(t);
END SetDate;


PROCEDURE DateToStr(date:        Date;
                    format:      DateFormat;
                    seperator:   CHAR;
                    VAR str:     ARRAY OF CHAR);
VAR   s: ARRAY [0 .. 3] OF CHAR;
BEGIN
   CASE format OF
   | DDMMYY, DDMMYYYY:
      CardToString(date.day, str, 2);
      IF str[0]=' ' THEN str[0] := '0' END;
      Append(str, seperator);
      CardToString(date.month, s, 2);
      IF s[0]=' ' THEN s[0] := '0' END;
      Append(str, s);
      Append(str, seperator);
      IF format=DDMMYY THEN
         CardToString(date.year MOD 100, s, 2);
         IF s[0]=' ' THEN s[0] := '0' END;
      ELSE
         CardToString(date.year, s, 4);
         IF s[0]=' ' THEN s[0] := '0' END;
         IF s[1]=' ' THEN s[1] := '0' END;
         IF s[2]=' ' THEN s[2] := '0' END;
      END;
      Append(str, s);
   | MMDDYY, MMDDYYYY:
      CardToString(date.month, str, 2);
      IF str[0]=' ' THEN str[0] := '0' END;
      Append(str, seperator);
      CardToString(date.day, s, 2);
      IF s[0]=' ' THEN s[0] := '0' END;
      Append(str, s);
      Append(str, seperator);
      IF format=DDMMYY THEN
         CardToString(date.year MOD 100, s, 2);
         IF s[0]=' ' THEN s[0] := '0' END;
      ELSE
         CardToString(date.year, s, 4);
         IF s[0]=' ' THEN s[0] := '0' END;
         IF s[1]=' ' THEN s[1] := '0' END;
         IF s[2]=' ' THEN s[2] := '0' END;
      END;
      Append(str, s);
   ELSE
   END;
END DateToStr;

PROCEDURE TimeToStr(time:        Time;
                    format:      TimeFormat;
                    seperator:   CHAR;
                    VAR str:     ARRAY OF CHAR);
VAR   s: ARRAY [0 .. 1] OF CHAR;
BEGIN
   CASE format OF
   | H4MM, H4MMSS:
      CardToString(time.h, str, 2);
   | H2MM, H2MMSS:
      CardToString(time.h MOD 12, str, 2);
   ELSE
   END;
   IF str[0]=' ' THEN str[0] := '0' END;
   Append(str, seperator);
   CardToString(time.m, s, 2);
   IF s[0]=' ' THEN s[0] := '0' END;
   Append(str, s);
   CASE format OF
   | H4MMSS, H2MMSS:
      Append(str, seperator);
      CardToString(time.s, s, 2);
      IF s[0]=' ' THEN s[0] := '0' END;
      Append(str, s);
   ELSE
   END;
END TimeToStr;

BEGIN
   ModReg.Register('TimeNDate',0,0,' ',1996,10,16,PROC(NIL));


END TimeNDate.
