IMPLEMENTATION MODULE VoteCfoFunctions;

(*
 * 26.11.1996  -  aus VoteCfvFunctions abgeleitet
 * 27.11.1996  -  in andere Gruppen als GRPCFO nur lokal posten
 * 28.11.1996  -  Timeout-Datum wurde von DoEndCfo nicht in vTimeout
 *                eingesetzt
 *             -  Warnung falls bei DoNewCfo keine Abstimmungspunkte
 *                erkannt wurden
 *             -  CFO ohne Abstimmungspunkte kann nicht gestartet werden
 *             -  Variable fr Default-Gruppennamen benutzt
 * 29.11.1996  -  Bugfix: Bei DoNewCfo und DoChangeCfo konnte die Antwort
 *                an die falsche Adresse gehen!
 * 19.12.1996  -  in DoEndCfo wird vCopyto gesetzt
 * 12.01.1997  -  ReadCfo: berlauf bei mehr als 16 Abstimmungspunkten
 *                verhindern; vote-Array zu Beginn und am Ende mit einem
 *                leeren Eintrag abschlieen
 * 23.01.1997  -  beim ndern eines CFO cfv[].copyTo lschen
 *             -  der Ansprechpartner (REPLYTO) wird in den CFO-Text
 *                geschrieben
 *             -  der Header des CFO wird erst beim Start erzeugt
 *             -  Laufzeitangabe jetzt auch relativ mglich
 * 28.01.1997  -  Namensangabe beim Lschen eines CFO funktioniert
 *             -  bei abgelaufenem CFO wurden vTimeout und vReplyTo
 *                nicht gesetzt
 * 09.03.1997  -  beim Posten eines CFO Followup setzen
 * 29.03.1997  -  an neues DAT-Format angepat
 * 16.06.1997  -  bei Anlegen eines neuen CFO CFO-Name ins Log schreiben
 * 08.07.1997  -  Bugfixes in DoChangeCFO: Beim ndern wurde aus dem
 *                CFO ein CFV und die Default-Abstimmungsberechtigung
 *                war bei nderungen 'Lokal'
 * 16.08.1997  -  beim Anlegen eines CFO ggf. Default fr copyTo einsetzen
 *             -  falls Laufzeitangabe fehlt, Default einsetzen
 *)


IMPORT   InOut;
FROM     Strings           IMPORT   Append, Insert, Delete, Copy, Pos, Length,
                                    CompareStr;
FROM     Strings1          IMPORT   Assign, Trim, Fill, ConvUmlaute,
                                    RemoveLeadingSpaces, RemoveTrailingSpaces;
FROM     NumberConversion  IMPORT   CardToString, StringToCard;
IMPORT   FileIO;
FROM     FileIO            IMPORT   File, FileName, AccessMode, CreateMode,
                                    Open, Create, Close, EOF, Write,
                                    WriteString, WriteLn, WriteLine, CreateTmp,
                                    Read, ReadLine, Seek, Seek0, SeekMode,
                                    State, NOFILE;
IMPORT   Directories;
FROM     TimeNDate         IMPORT   Date, TimeFormat, DateFormat,
                                    GetDate, TimeToStr, DateToStr;
FROM     CDate             IMPORT   DaysGone, Legal;
FROM     RandomGen         IMPORT   RandomCard;
FROM     MausLibrary       IMPORT   MausName, String255;
IMPORT   ModReg;
IMPORT   void;
FROM     VoteGlobals       IMPORT   MAXTOPIC, BEGINTOPIC, ENDTOPIC,
                                    TOPICCHARS, MAXCFV, MAXVOTE, GRPNAMELEN,
                                    BLOCKSIZE, LINELEN, MAXCHEF, MINTIMEOUT,
                                    STDTIMEOUT,
                                    CFGFILE, VOTEFILE, LOGFILE, INFILE, OUTFILE,
                                    CHEFFILE,
                                    OKANSWERcfo, ERRANSWERcfo, NOACCANSWERcfo,
                                    TOANSWERcfo, ENDANSWERcfo,
                                    UNKANSWER, HELPANSWER, NIANSWER,
                                    BRKANSWERcfo, NOALANSWER, NOCFOANSWER,
                                    TIMEANSWERcfo, ERRCFOANSWER,
                                    NEWCFO, CHANGECFO, DELETECFO, STARTCFO,
                                    ENDCFO, TIMECFO, LISTCFO, LISTALL, VOTECFO,
                                    HELP, NEWAL, DELETEAL, LISTALS, ONCEAL,
                                    KEY, ACCESS, ACCWORLD, ACCMAUSNET,
                                    ACCLOCAL, ACCSYSOPS, ACCBETREIBER, TIMEOUT,
                                    GRUPPE, REPLYTO, VTYPE, TOMOV, TPERSON, VOTES,
                                    VVOTE, VTIMEOUT, VERRCAUSE, VACCESS, VRECEIVED,
                                    VBETREFF, VADDRESS, COPYTO, VTIME, VDAYS,
                                    VWEEKS, VMONTH,
                                    COPYRIGHT, PROGNAME,
                                    ACCESSSTR, ACCALLSTR, ACCMAUSNETSTR, ACCLOCALSTR,
                                    ACCSYSOPSTR, ACCBETREIBERSTR,
                                    VoteType, VoteTypeSet, VoteAccess,
                                    CFVState, Cfv,
                                    MessageRec, Message, VoteRec, Votes, Index,
                                    CfvResult, ChefType, logPath, confPath,
                                    muserFilename, cfgFilename, dataFilename,
                                    logFilename, tmpFilename, tmp2Filename,
                                    chefFilename,
                                    inFilename, outFilename, fileBuffer, cfgfile,
                                    datafile, logfile, infile, outfile, textfile,
                                    line, buffer, help, debug,
                                    date, time, dateStr, cfv, cfvResult, mes,
                                    answer, lastpos, votes, index, votehigh, newID,
                                    chefList, allowLocalCFVs, allowListALs,
                                    allowPreview,
                                    vVote, vTimeout, vErrcause, vAccess, vReceived,
                                    vReplyto, vCopyto, vBetreff, vAddress,
                                    grpCFO, copyToCFO, timeoutCFO, followupTo,
                                    LogTime, LogCopyright, LogString,
                                    LogLine, CompareNames,
                                    StringToDate, EtoDateTime, IstZahler,
                                    IsLocal, IsMausNet, IsSysop, BeginsWith,
                                    UPos, MausDomain, NewMail,
                                    ClearMail, DumpMail, ClearAnswer,
                                    SetVAccess, ReplaceWildcards;
FROM     VoteFiles         IMPORT   InfileLn, InfileString, InfileLine,
                                    InfileEndmail, InfileWriteHeader,
                                    FindChef, DeleteChef;
FROM     VoteFunctions     IMPORT   DoAnswerForm, ReadVotes, CountVotes,
                                    ListResult;
FROM     VoteCfxFunctions  IMPORT   WriteHeaderToInfile, SetTimeout;


PROCEDURE FindCfo(betreff: ARRAY OF CHAR): CARDINAL;
VAR   result:  CARDINAL;
      pos:     CARDINAL;
      str:     String255;
BEGIN
   pos := Pos(":", betreff);
   IF pos<HIGH(betreff) THEN
      Delete(betreff, 0, pos+1);
   END;
   Trim(betreff);
   ConvUmlaute(betreff);
   result := 0;
   IF (vCFO IN cfv[result].type) THEN
      Assign(cfv[result].name, str);
      ConvUmlaute(str);
   ELSE
      str[0] := 0C;
   END;
   WHILE (result<MAXCFV) AND (CompareStr(str, betreff)#0) DO
      INC(result);
      IF result<MAXCFV THEN
         IF (vCFO IN cfv[result].type) THEN
            Assign(cfv[result].name, str);
            ConvUmlaute(str);
         ELSE
            str[0] := 0C;
         END;
      END;
   END;
   RETURN result;
END FindCfo;

PROCEDURE GetCfoFile(VAR str: ARRAY OF CHAR);
VAR   i:    CARDINAL;
      ok:   BOOLEAN;
      name: FileName;
      file: File;
BEGIN
   ok := FALSE;
   i := 0;
   WHILE NOT ok DO
      CardToString(i, str, 1);
      IF i<10 THEN
         Insert('VD_CFO0', str, 0);
      ELSE
         Insert('VD_CFO', str, 0);
      END;
      Assign(str, name);
      Append(name, '.TXT');
      IF Open(file, name, aRead) THEN
         Close(file);
      ELSE
         ok := TRUE;
      END;
      INC(i);
   END;
END GetCfoFile;

PROCEDURE WriteCfoResult(this:   CARDINAL);
VAR   file:    File;
BEGIN
   ReadVotes(this);
   CountVotes(this);
   InfileLn;
   InfileLn;
   ListResult(this);
   InfileLn;
   InfileLn;
   IF (vOMOV IN cfv[this].type) THEN
      InfileLine("Auswertung pro Box:");
      InfileLn;
      IF NOT Open(file, tmp2Filename, aRead) THEN
         (* temporre Datei konnte nicht geffnet werden *)
         LogString(" * (WriteCfoResult): Konnte temporre Datei '");
         LogString(tmp2Filename);
         LogLine("' nicht ffnen!");
         InfileLine(" * Fehler: Konnte Liste der Ergebnisse pro Box nicht finden!");
      ELSE
         IF debug THEN
            LogString(" ' (WriteCfoResult): temporre Datei '");
            LogString(tmp2Filename);
            LogLine("' geffnet");
         END;
         WHILE NOT EOF(file) DO
            ReadLine(file, line);
            InfileLine(line);
         END;
         Close(file);
         Directories.Delete(tmp2Filename);
         IF debug THEN
            LogLine(" ' (WriteCfoResult): Datei geschlossen und gelscht");
         END;
      END;
      InfileLn;
      InfileLn;
      InfileLine("Die Liste der abgegebenen Stimmen (nach Box sortiert):");
   ELSE
      InfileLine("Die Liste der abgegebenen Stimmen in alphabetischer Reihenfolge:");
   END;
   InfileLn;
   IF NOT Open(file, tmpFilename, aRead) THEN
      (* temporre Datei konnte nicht geffnet werden *)
      LogString(" * (WriteCfoResult): Konnte temporre Datei '");
      LogString(tmpFilename);
      LogLine("' nicht ffnen!");
      InfileLine(" * Fehler: Konnte sortierte Liste der Stimmen nicht finden!");
   ELSE
      IF debug THEN
         LogString(" ' (WriteCfoResult): temporre Datei '");
         LogString(tmpFilename);
         LogLine("' geffnet");
      END;
      WHILE NOT EOF(file) DO
         ReadLine(file, line);
         InfileLine(line);
      END;
      Close(file);
      Directories.Delete(tmpFilename);
      IF debug THEN
         LogLine(" ' (WriteCfoResult): Datei geschlossen und gelscht");
      END;
   END;
END WriteCfoResult;

MODULE MakeCfo;

IMPORT   Seek, Seek0, ReadLine, Pos, UPos, Delete, Length, Trim, Assign,
         WriteString, WriteLn, WriteLine, StringToCard, CardToString,
         Append, LogString, LogLine, Copy, InfileString, InfileLine,
         InfileLn, DateToStr, GetDate, ClearAnswer, InfileWriteHeader, newID,
         DoAnswerForm, FindCfo, GetCfoFile, Create, Close, CreateMode,
         SeekMode, AccessMode, InfileEndmail, CreateTmp, Directories,
         Message, Cfv, File, Date, lastpos, outfile, infile, buffer,
         KEY, GRUPPE, REPLYTO, COPYTO, VTYPE, TPERSON, TOMOV, VOTES, ACCESS,
         ACCBETREIBER, ACCSYSOPS, ACCMAUSNET, ACCWORLD, grpCFO, vWorld,
         vMausNet, vLocal,
         vSysop, vBetreiber, vOMOV, vPerson, VoteTypeSet, ACCLOCAL,
         TIMEOUT, StringToDate, date, BEGINTOPIC, ENDTOPIC, EOF, cfv, void,
         dateStr, MAXTOPIC, DateFormat, Open, debug, line, Legal, vErrcause,
         DaysGone, MAXCHEF, FindChef, MINTIMEOUT, allowLocalCFVs, NOALANSWER,
         ERRCFOANSWER, IsLocal, MAXCFV, chefList, NEWCFO, RandomCard, cOnce,
         DeleteChef, answer, PROGNAME, CompareStr, tmpFilename, NOCFOANSWER,
         ACCESSSTR, ACCLOCALSTR, ACCALLSTR, ACCMAUSNETSTR, ACCSYSOPSTR,
         ACCBETREIBERSTR, MausName, RemoveLeadingSpaces, RemoveTrailingSpaces,
         IstZahler, vCFO, CompareNames, VDAYS, VWEEKS, VMONTH, VTIME,
         BeginsWith, WriteHeaderToInfile, InOut, followupTo, CFVState,
         copyToCFO, timeoutCFO;
EXPORT   DoNewCfo, DoChangeCfo;

VAR   topic,
      endpos,
      pos:        CARDINAL;
      numOK,
      errGruppe,
      errLocal,
      errTopicMax,
      done:       BOOLEAN;
      str:        ARRAY [0 .. 79] OF CHAR;
      i, j:       CARDINAL;
      chef:       CARDINAL;
      isChef:     BOOLEAN;

   PROCEDURE ReadCfo(    message:   Message;
                     VAR tmpCfo:    Cfv;
                         textfile:  File;
                         change:    BOOLEAN);
   VAR   vTime:   CARDINAL;
         timeSet: BOOLEAN;
   BEGIN
      timeSet := FALSE;
      topic := 0;
      (* ersten Eintrag lschen *)
      tmpCfo.vote[0].short[0] := 0C;
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            Delete(buffer, 0, 1);
            IF BeginsWith(KEY, buffer, pos) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               Assign(buffer, tmpCfo.key);
            ELSIF BeginsWith(GRUPPE, buffer, pos) THEN
               Delete(buffer, 0, pos+Length(GRUPPE));
               Trim(buffer);
               Assign(buffer, tmpCfo.gruppe);
            ELSIF isChef AND BeginsWith(REPLYTO, buffer, pos) THEN
               (* nur fr ALs *)
               Delete(buffer, 0, pos+Length(REPLYTO));
               Trim(buffer);
               Assign(buffer, tmpCfo.replyTo);
            ELSIF isChef AND BeginsWith(COPYTO, buffer, pos) THEN
               (* nur fr ALs *)
               Delete(buffer, 0, pos+Length(COPYTO));
               Trim(buffer);
               IF tmpCfo.copyTo[0]#0C THEN
                  Append(tmpCfo.copyTo, ', ');
               END;
               Append(tmpCfo.copyTo, buffer);
            ELSIF BeginsWith(VTYPE, buffer, void.cardinal) THEN
               IF UPos(TOMOV, buffer, void.cardinal)<HIGH(buffer) THEN
                  INCL(tmpCfo.type, vOMOV);
               END;
               IF UPos(TPERSON, buffer, void.cardinal)<HIGH(buffer) THEN
                  INCL(tmpCfo.type, vPerson);
               END;
            ELSIF BeginsWith(VOTES, buffer, pos) THEN
               Delete(buffer, 0, pos+Length(VOTES));
               Trim(buffer);
               StringToCard(buffer, tmpCfo.voteMax, numOK);
               IF NOT numOK THEN
                  tmpCfo.voteMax := MAX(CARDINAL);
               END;
            ELSIF BeginsWith(ACCESS, buffer, void.cardinal) THEN
               IF UPos(ACCLOCAL, buffer, void.cardinal)<HIGH(buffer) THEN
                  tmpCfo.access := vLocal;
               ELSIF UPos(ACCBETREIBER, buffer, void.cardinal)<HIGH(buffer) THEN
                  tmpCfo.access := vBetreiber;
               ELSIF UPos(ACCSYSOPS, buffer, void.cardinal)<HIGH(buffer) THEN
                  tmpCfo.access := vSysop;
               ELSIF UPos(ACCMAUSNET, buffer, void.cardinal)<HIGH(buffer) THEN
                  tmpCfo.access := vMausNet;
               ELSIF UPos(ACCWORLD, buffer, void.cardinal)<HIGH(buffer) THEN
                  tmpCfo.access := vWorld;
               ELSE
                  tmpCfo.access := vMausNet;
               END;
            ELSIF BeginsWith(TIMEOUT, buffer, void.cardinal) THEN
               IF timeSet THEN
                  LogString(" * (ReadCfo): mehrfache Laufzeitangabe: ");
                  LogLine(buffer);
               ELSE
                  pos := UPos(TIMEOUT, buffer, void.cardinal);
                  Delete(buffer, 0, pos+Length(TIMEOUT));
                  Trim(buffer);
                  (* String to Date *)
                  IF NOT StringToDate(buffer, '.', date) THEN
                     (* ungltige Datumsangabe *)
                     LogString(" * (ReadCfo): ungltige Datumsangabe: ");
                     LogLine(buffer);
                  ELSE
                     tmpCfo.timeout := date;
                     timeSet := TRUE;
                  END;
               END;
            ELSIF BeginsWith(VTIME, buffer, void.cardinal) THEN
               IF timeSet THEN
                  LogString(" * (ReadCfo): mehrfache Laufzeitangabe: ");
                  LogLine(buffer);
               ELSE
                  pos := UPos(VTIME, buffer, void.cardinal);
                  Delete(buffer, 0, pos+Length(VTIME));
                  Trim(buffer);
                  pos := Pos(' ', buffer);
                  IF pos<HIGH(buffer) THEN
                     Copy(buffer, 0, pos, str);
                     StringToCard(str, vTime, void.boolean);
                     Delete(buffer, 0, pos);
                     RemoveLeadingSpaces(buffer);
                     IF BeginsWith(VDAYS, buffer, void.cardinal) THEN
                     ELSIF BeginsWith(VWEEKS, buffer, void.cardinal) THEN
                        vTime := vTime*7;
                     ELSIF BeginsWith(VMONTH, buffer, void.cardinal) THEN
                        vTime := vTime*30;
                     ELSE (* Fehler *)
                        LogString(" * (ReadCfo): falsche Zeiteinheit: ");
                        LogLine(buffer);
                        vTime := 0;
                     END;
                  ELSE
                     LogLine(" ! (ReadCfo): Zeiteinheit fehlt - rechne mit Tagen");
                     StringToCard(buffer, vTime, void.boolean);
                  END;
                  tmpCfo.timeout.day := vTime;
                  tmpCfo.timeout.year := 9999;
                  tmpCfo.timeout.month := 99;
                  timeSet := TRUE;
               END;
            ELSE
               WriteLine(textfile, buffer);
               pos := Pos(BEGINTOPIC, buffer);
               WHILE pos<HIGH(buffer) DO
                  endpos := Pos(ENDTOPIC, buffer);
                  IF NOT(endpos<HIGH(buffer)) THEN
                     (* keine Endeklammer - Abbruch *)
                     pos := HIGH(buffer);
                  ELSE
                     IF (endpos-pos-1)>4 THEN
                        (* Fehler: Kennung zu lang *)
                        LogString(" * (ReadCfo): Kennung zu lang: ");
                        LogLine(buffer);
                     ELSE
                        IF topic<MAXTOPIC THEN
                           Copy(buffer, pos+1, endpos-pos-1, tmpCfo.vote[topic].short);
                           tmpCfo.vote[topic].count := 0.0;
                           INC(topic);
                        ELSE
                           LogString(" * (ReadCfo): zu viele Abstimmungspunkte: ");
                           LogLine(buffer);
                           errTopicMax := TRUE;
                        END;
                     END;
                     Delete(buffer, 0, endpos+1);
                     pos := Pos(BEGINTOPIC, buffer);
                  END;
               END;
               (* das Array mit einem leeren Eintrag abschlieen *)
               IF topic<MAXTOPIC THEN
                  tmpCfo.vote[topic].short[0] := 0C;
               END;
            END;
         END;
      UNTIL done OR EOF(outfile);
      (* falls keine Laufzeit angegeben, Default einsetzen *)
      IF NOT timeSet THEN
         tmpCfo.timeout.day := timeoutCFO;
         tmpCfo.timeout.year := 9999;
         tmpCfo.timeout.month := 99;
         timeSet := TRUE;
      END;
      (* falls keine Adresse fr Auswertung angegeben, Default einsetzen *)
      IF tmpCfo.copyTo[0]=0C THEN
         (* Sender *)
         Assign(tmpCfo.sender, tmpCfo.copyTo);
         (* + vorkonfigurierte Adressen *)
         IF copyToCFO[0]#0C THEN
            Append(tmpCfo.copyTo, ', ');
            Append(tmpCfo.copyTo, copyToCFO);
         END;
      END;
      (* Gruppe fr ffentliches Posting des CFO *)
      IF tmpCfo.gruppe[0]=0C THEN
         Assign(grpCFO, tmpCfo.gruppe);
      END;
      (* in andere Gruppen nur von ALs oder lokal posten *)
      IF NOT isChef AND (CompareNames(tmpCfo.gruppe, grpCFO)#0) THEN
         IF IsLocal(message^.von) THEN
            (* nur lokaler CFO erlaubt! *)
            IF tmpCfo.access#vLocal THEN
               tmpCfo.access := vLocal;
               Assign(ACCESSSTR, buffer);
               Append(buffer, ACCLOCALSTR);
               Append(buffer, MausName);
               errLocal := TRUE;
            END;
         ELSE
            (* Gruppe nicht erlaubt! *)
            Assign(grpCFO, tmpCfo.gruppe);
            errGruppe := TRUE;
         END;
      END;
   END ReadCfo;

   PROCEDURE WriteCfoToInfile(this: CARDINAL);
   VAR textfile: File;
   BEGIN
      InfileString("Titel: ");
      InfileLine(cfv[this].name);
      InfileLn;
      IF errLocal THEN
         InfileLine("In dieser Gruppe drfen Sie nur lokale CFOs starten!");
      END;
      IF errGruppe THEN
         InfileLine("In der gewnschten Gruppe drfen Sie keinen CFO starten!");
      END;
      CASE cfv[this].access OF
      | vWorld:
         InfileLine("Abstimmungsberechtigt ist jeder, der eine PM an den Dmon schicken kann.");
      | vMausNet:
         InfileLine("Abstimmungsberechtigt sind alle zahlenden User des MausNet.");
      | vLocal:
         InfileLine("Abstimmungsberechtigt sind alle zahlenden User der lokalen MAUS.");
      | vSysop:
         InfileLine("Abstimmungsberechtigt sind alle im ISB aufgefhrten Sysops des MausNet.");
      | vBetreiber:
         InfileLine("Abstimmungsberechtigt sind alle im ISB aufgefhrten Betreiber des MausNet.");
      ELSE
         (* kann gar nicht sein ... *)
      END;
      InfileLn;
      InfileString(VTYPE);
      IF (vOMOV IN cfv[this].type) THEN
         InfileString(' ');
         InfileString(TOMOV);
      END;
      IF (vPerson IN cfv[this].type) THEN
         InfileString(' ');
         InfileString(TPERSON);
      END;
      IF (cfv[this].type=VoteTypeSet{vCFO}) THEN
         InfileString(' Normal');
      END;
      InfileLn;
      InfileLn;
      IF cfv[this].voteMax#MAX(CARDINAL) THEN
         InfileString(VOTES);
         CardToString(cfv[this].voteMax, str, 3);
         InfileLine(str);
         InfileLn;
      END;
      IF cfv[this].timeout.year=9999 THEN
         InfileString("Die Laufzeit des CFO betrgt ");
         CardToString(cfv[this].timeout.day, str, 1);
         InfileString(str);
         InfileLine(" Tage.");
      ELSE
         InfileString("Die Stimmen mssen bis sptestens ");
         DateToStr(cfv[this].timeout, DDMMYYYY, '.', dateStr);
         InfileString(dateStr);
         InfileLine(" beim Abstimmungsdmon angekommen sein.");
      END;
      InfileLn;
      InfileString("Verffentlicht wird der CFO in der Gruppe ");
      InfileLine(cfv[this].gruppe);
      InfileLn;
      InfileString("Verantwortlich fr den CFO ist ");
      InfileLine(cfv[this].replyTo);
      InfileLn;
      InfileString("Die Auswertung geht an ");
      InfileLine(cfv[this].copyTo);
      InfileLn;
      IF cfv[this].vote[0].short[0]=0C THEN
         InfileLine("*Es wurden keine Abstimmungspunkte erkannt!*");
      ELSE
         InfileLine("Folgende Punkte stehen zur Abstimmung:");
         InfileString("          ");
         i := 0;
         j := 0;
         WHILE (i<MAXTOPIC) AND (cfv[this].vote[i].short[0]#0C) DO
            InfileString(cfv[this].vote[i].short);
            InfileString(", ");
            INC(i);
            INC(j);
            IF j>=10 THEN
               j := 0;
               InfileLn;
               InfileString("          ");
            END;
         END;
      END;
      InfileLn;
      InfileLn;
      InfileString("Der fr nderungen notwendige Schlssel lautet: ");
      InfileLine(cfv[this].key);
      InfileLn;
      InfileLine("--- Text des CFO folgt: ---");
      IF NOT Open(textfile, cfv[this].textfile, aRead) THEN
         (* Fehler *)
         LogString(" * (WriteCfoToInfile): Datei mit CFO-Text '");
         LogString(cfv[this].textfile);
         LogLine("' konnte nicht geffnet werden!");
      ELSE
         IF debug THEN
            LogString(" ' (WriteCfoToInfile): CFO-Text '");
            LogString(cfv[this].textfile);
            LogLine("' geffnet");
         END;
         WriteHeaderToInfile(this);
         WHILE NOT EOF(textfile) DO
            ReadLine(textfile, line);
            InfileLine(line);
         END;
      END;
      Close(textfile);
      IF debug THEN
         LogLine(" ' (WriteCfoToInfile): Datei geschlossen");
      END;
      InfileLine("--- Ende des CFO-Textes ---");
   END WriteCfoToInfile;

   PROCEDURE CheckCfo(VAR cfv: Cfv): BOOLEAN;
   VAR   result:  BOOLEAN;
         today:   Date;
   BEGIN
      result := TRUE;
      GetDate(today);
      IF cfv.timeout.year=9999 THEN
         IF cfv.timeout.day<MINTIMEOUT THEN
            Assign("Ein CFO mu mindestens ", vErrcause);
            CardToString(MINTIMEOUT, str, 1);
            Append(vErrcause, str);
            Append(vErrcause, " Tage laufen.");
            result := FALSE;
         END;
      ELSE
         IF NOT Legal(cfv.timeout) THEN
            Assign("Sie haben kein gltiges Datum fr die letzte Stimmabgabe angegeben.", vErrcause);
            result := FALSE;
         ELSIF cfv.timeout.year=0 THEN
            Assign("Sie haben kein gltiges Datum fr die letzte Stimmabgabe angegeben.", vErrcause);
            result := FALSE;
         ELSIF (DaysGone(today)+LONG(MINTIMEOUT))>DaysGone(cfv.timeout) THEN
            Assign("Ein CFO mu mindestens ", vErrcause);
            CardToString(MINTIMEOUT, str, 1);
            Append(vErrcause, str);
            Append(vErrcause, " Tage laufen.");
            result := FALSE;
         END;
      END;
      IF errTopicMax THEN
         Assign("Sie haben zu viele Abstimmungspunkte angegeben (Maximum: ", vErrcause);
         CardToString(MAXTOPIC, str, 1);
         Append(vErrcause, str);
         Append(vErrcause, ").");
         result := FALSE;
      END;
      RETURN result;
   END CheckCfo;

   PROCEDURE IsOK(von: ARRAY OF CHAR): BOOLEAN;
   VAR   result:  BOOLEAN;
         name:    ARRAY [0 .. 79] OF CHAR;
         pos:     CARDINAL;
   BEGIN
      result := FALSE;
      IF IsLocal(von) THEN
         pos := Pos('@', von);
         IF pos<128 THEN
            Copy(von, 0, pos, name);
            RemoveTrailingSpaces(name);
            result := IstZahler(name);
         END;
      ELSE
         result := TRUE;
      END;
      RETURN result;
   END IsOK;

   PROCEDURE DoNewCfo(message: Message);
   (*
    * neuer CFO
    *)
   VAR   i:          CARDINAL;
         this:       CARDINAL;
         exists:     BOOLEAN;
         textfile,
         votefile:   File;
   BEGIN
      ClearAnswer(message);
      (* Berechtigung prfen *)
      chef := MAXCHEF;
      isChef := FindChef(message^.von, chef);
      IF NOT (isChef OR IsOK(message^.von)) THEN
         DoAnswerForm(message, NOALANSWER);
         LogLine("   Absender ist nicht berechtigt einen CFO anzulegen");
      ELSE
         (* CFO suchen *)
         exists := FALSE;
         this := 0;
         WHILE (this<MAXCFV) AND (cfv[this].name[0]#0C) DO
            INC(this);
         END;
         IF FindCfo(message^.betreff)<MAXCFV THEN
            (* keine zwei CFOs mit gleichem Namen zulassen *)
            exists := TRUE;
            this := MAXCFV;
         END;
         IF this<MAXCFV THEN
            Assign(message^.betreff, cfv[this].name);
            Assign(message^.von, cfv[this].sender);
            Assign(message^.von, cfv[this].replyTo);
            cfv[this].copyTo[0] := 0C;
            cfv[this].access := vMausNet;
            cfv[this].type := VoteTypeSet{vCFO};
            cfv[this].voteMax := MAX(CARDINAL);
            errLocal := FALSE;
            errGruppe := FALSE;
            errTopicMax := FALSE;
            cfv[this].gruppe[0] := 0C;
            cfv[this].key[0] := 0C;
            cfv[this].state := csNew;
            cfv[this].timeout.year := 0;
            cfv[this].mausid[0] := 0C;
            cfv[this].id[0] := 0C;
            Delete(cfv[this].name, 0, Length(NEWCFO));
            Trim(cfv[this].name);
            GetCfoFile(str);
            Assign(str, cfv[this].textfile);
            Append(cfv[this].textfile, '.TXT');
            (* Textfile ffnen *)
            IF NOT Create(textfile, cfv[this].textfile, aWrite, cClobber) THEN
               (* Fehler *)
               LogString(" * (DoNewCfo): Datei fr CFO-Text '");
               LogString(cfv[this].textfile);
               LogLine("' konnte nicht angelegt werden!");
            ELSE
               IF debug THEN
                  LogString(" ' (DoNewCfo): Datei fr CFO-Text '");
                  LogString(cfv[this].textfile);
                  LogLine("' wurde angelegt");
               END;
            END;
            Assign(str, cfv[this].votefile);
            Append(cfv[this].votefile, '.VOT');
            IF NOT Create(votefile, cfv[this].votefile, aWrite, cClobber) THEN
               (* Fehler *)
               LogString(" * (DoNewCfo): Datei fr Stimmzhlung '");
               LogString(cfv[this].votefile);
               LogLine("' konnte nicht angelegt werden!");
            ELSE
               Close(votefile);
            END;
            ReadCfo(message, cfv[this], textfile, FALSE);
            IF NOT CheckCfo(cfv[this]) THEN
               DoAnswerForm(message, ERRCFOANSWER);
               cfv[this].name[0] := 0C;
               Directories.Delete(cfv[this].textfile);
               Directories.Delete(cfv[this].votefile);
               LogLine("   falsche oder unvollstndige Angaben");
            ELSE
               (* Schlssel fr nderungen des CFO *)
               IF cfv[this].key[0]=0C THEN
                  (* zuflligen Schlssel erzeugen - case-insensitiv *)
                  FOR i := 0 TO 15 DO
                     cfv[this].key[i] := CHR(RandomCard(ORD("A"), ORD("Z")));
                  END;
                  cfv[this].key[16] := 0C;
               END;
               (* Textfile schlieen *)
               Close(textfile);
               IF debug THEN
                  LogLine(" ' (DoNewCfo): Datei geschlossen");
               END;
               (* Einmal-Chefs lschen
               IF chef<MAXCHEF THEN
                  IF chefList[chef].type = cOnce THEN
                     DeleteChef(chef);
                  END;
               END;
               *)
               (* Besttigung verschicken *)
               ClearAnswer(message);
               InfileWriteHeader(answer, newID);
               InfileLn;
               InfileLine("Folgender CFO wurde angenommen:");
               InfileLn;
               WriteCfoToInfile(this);
               InfileEndmail;
               LogString("   Neuer CFO wurde angelegt: ");
               LogLine(cfv[this].name);
            END;
         ELSE
            (* zu viele CFOs! *)
            IF exists THEN
               Assign("Es existiert bereits ein CFO unter gleichem Namen.", vErrcause);
               DoAnswerForm(message, ERRCFOANSWER);
               LogLine("   CFO existiert bereits");
            ELSE
               Assign("Es laufen schon ", vErrcause);
               CardToString(MAXCFV, str, 1);
               Append(vErrcause, str);
               Append(vErrcause, " CFOs bzw. CFVs. Mehr kann ");
               Append(vErrcause, PROGNAME);
               Append(vErrcause, " nicht gleichzeitig verwalten.");
               DoAnswerForm(message, ERRCFOANSWER);
               LogLine("   Zu viele CFOs/CFVs");
            END;
         END;
      END;
   END DoNewCfo;

   PROCEDURE DoChangeCfo(message: Message);
   (*
    * CFO ndern
    *)
   VAR   tmpfile:    File;
         tmpCfo:     Cfv;
         this:       CARDINAL;
   BEGIN
      ClearAnswer(message);
      (* CFO suchen *)
      this := FindCfo(message^.betreff);
      IF this<MAXCFV THEN
         IF (cfv[this].state=csRunning) THEN
            Assign("Der CFO luft bereits.", vErrcause);
            DoAnswerForm(message, ERRCFOANSWER);
            LogLine("   CFO luft bereits.");
         ELSIF (cfv[this].state=csEnded) THEN
            Assign("Der CFO ist bereits beendet.", vErrcause);
            DoAnswerForm(message, ERRCFOANSWER);
            LogLine("   CFO bereits beendet.");
         ELSE
            isChef := FindChef(message^.von, chef);
            (* temporres Textfile ffnen *)
            tmpFilename[0] := 0C;   (* _nicht_ im TMP-Pfad! *)
            IF NOT CreateTmp(tmpfile, tmpFilename, aWrite) THEN
               (* Fehler *)
               LogString(" * (DoChangeCfo): temporre Datei fr CFO-Text '");
               LogString(tmpFilename);
               LogLine("' konnte nicht angelegt werden!");
            ELSE
               IF debug THEN
                  LogString(" ' (DoChangeCfo): temporre Datei fr CFO-Text '");
                  LogString(tmpFilename);
                  LogLine("' wurde angelegt");
               END;
               errLocal := FALSE;
               errGruppe := FALSE;
               errTopicMax := FALSE;
               tmpCfo := cfv[this];
               tmpCfo.access := vMausNet;
               tmpCfo.type := VoteTypeSet{vCFO};
               tmpCfo.voteMax := MAX(CARDINAL);
               tmpCfo.timeout.year := 0;
               tmpCfo.gruppe[0] := 0C;
               tmpCfo.copyTo[0] := 0C;
               ReadCfo(message, tmpCfo, tmpfile, FALSE);
               (* Textfile schlieen *)
               Close(tmpfile);
               IF debug THEN
                  LogLine(" ' (DoChangeCfo): temporre Datei geschlossen");
               END;
               IF NOT CheckCfo(tmpCfo) THEN
                  DoAnswerForm(message, ERRCFOANSWER);
                  Directories.Delete(tmpFilename);
                  LogLine("   falsche oder unvollstndige Angaben");
               ELSE
                  IF (CompareStr(cfv[this].key, tmpCfo.key)#0) THEN
                     (* falscher Schlssel *)
                     Assign("Sie haben nicht den korrekten Schlssel angegeben.", vErrcause);
                     DoAnswerForm(message, ERRCFOANSWER);
                     Directories.Delete(tmpFilename);
                     LogLine("   falscher Schlssel");
                  ELSE
                     (* Schlssel OK *)
                     cfv[this] := tmpCfo;
                     Directories.Delete(cfv[this].textfile);
                     Directories.Rename(tmpFilename, cfv[this].textfile);
                     (* Besttigung verschicken *)
                     ClearAnswer(message);
                     InfileWriteHeader(answer, newID);
                     InfileLn;
                     InfileLine("Der CFO wurde wie folgt gendert:");
                     WriteCfoToInfile(this);
                     InfileEndmail;
                    LogLine("   CFO wurde gendert");
                  END;
               END;
            END;
         END;
      ELSE
         (* Cfo nicht gefunden *)
         DoAnswerForm(message, NOCFOANSWER);
         LogLine("   CFO nicht gefunden");
      END;
   END DoChangeCfo;

END MakeCfo;

PROCEDURE DoDeleteCfo(message: Message);
VAR   this:    CARDINAL;
      done:    BOOLEAN;
      keyOK:   BOOLEAN;
      pos:     CARDINAL;
      j:       CARDINAL;
BEGIN
   ClearAnswer(message);
   this := FindCfo(message^.betreff);
   IF this<MAXCFV THEN
      keyOK := FALSE;
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         (* debug *
         InOut.WriteLine(buffer);
          *       *)
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            IF UPos(KEY, buffer, pos)<HIGH(buffer) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               keyOK := (CompareStr(buffer, cfv[this].key)=0);
            END;
         END;
      UNTIL done OR EOF(outfile);
   ELSE
      (* CFO nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   IF this<MAXCFV THEN
      InfileWriteHeader(answer, newID);
      InfileLn;
      IF NOT keyOK THEN
         InfileLine("Sie haben nicht den korrekten Schlssel angegeben.");
         LogLine("   falscher Schlssel");
      ELSE
         IF cfv[this].state=csRunning THEN
            InfileLine("Der CFO kann nicht gelscht werden, da er momentan luft.");
            InfileLn;
            InfileLine("Mit 'Beende CFO:' knnen Sie ihn vorzeitig beenden.");
            LogLine("   CFO luft");
         ELSE
            LogString("   CFO gelscht: ");
            LogLine(cfv[this].name);
            Directories.Delete(cfv[this].textfile);
            Directories.Delete(cfv[this].votefile);
            j := this;
            WHILE j<(MAXCFV-1) DO
               cfv[j] := cfv[j+1];
               INC(j);
            END;
            InfileLine("OK. Der CFO wurde gelscht");
            cfv[MAXCFV-1].name[0] := 0C;
         END;
      END;
      InfileEndmail;
   ELSE
      DoAnswerForm(message, NOCFOANSWER);
      LogLine("   CFO nicht gefunden");
   END;
END DoDeleteCfo;

PROCEDURE RunCfo(this:  CARDINAL);
VAR   mes:  Message;
BEGIN
   (* CFO posten *)
   mes := NewMail();
   Assign(cfv[this].name, mes^.betreff);
   Assign(followupTo, mes^.followup);
   Insert(' ', mes^.betreff, 0);
   Insert(VOTECFO, mes^.betreff, 0);
   Assign(cfv[this].gruppe, mes^.gruppe);
   IF cfv[this].access = vLocal THEN
      mes^.distribution := 'L';
   END;
   InfileWriteHeader(mes, cfv[this].mausid);
   IF NOT Open(textfile, cfv[this].textfile, aRead) THEN
      (* Fehler *)
      LogString(" * (RunCfo): Datei mit CFO-Text '");
      LogString(cfv[this].textfile);
      LogLine("' konnte nicht geffnet werden!");
   ELSE
      IF debug THEN
         LogString(" ' (RunCfo): CFO-Text '");
         LogString(cfv[this].textfile);
         LogLine("' geffnet");
      END;
      SetTimeout(this);
      WriteHeaderToInfile(this);
      (* CFO-Text: *)
      WHILE NOT EOF(textfile) DO
         ReadLine(textfile, line);
         InfileLine(line);
      END;
   END;
   Close(textfile);
   IF debug THEN
      LogLine(" ' (RunCfo): Datei geschlossen");
   END;
   InfileEndmail;
   DumpMail(mes);
   cfv[this].state := csRunning;
END RunCfo;

PROCEDURE DoStartCfo(message: Message);
VAR   this:    CARDINAL;
      done:    BOOLEAN;
      keyOK:   BOOLEAN;
      pos:     CARDINAL;
BEGIN
   ClearAnswer(message);
   this := FindCfo(message^.betreff);
   IF this<MAXCFV THEN
      keyOK := FALSE;
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         (* debug *
         InOut.WriteLine(buffer);
          *       *)
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            IF UPos(KEY, buffer, pos)<HIGH(buffer) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               keyOK := (CompareStr(buffer, cfv[this].key)=0);
            END;
         END;
      UNTIL done OR EOF(outfile);
   ELSE
      (* CFO nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   InfileWriteHeader(answer, newID);
   InfileLn;
   IF this<MAXCFV THEN
      IF NOT keyOK THEN
         InfileLine("Sie haben nicht den korrekten Schlssel angegeben.");
         InfileEndmail;
         LogLine("   falscher Schlssel!");
      ELSE
         IF cfv[this].state=csRunning THEN
            InfileLine("Der CFO kann nicht gestartet werden, da er bereits luft.");
            InfileEndmail;
            LogLine("   CFO luft bereits");
         ELSIF cfv[this].state=csEnded THEN
            InfileLine("Der CFO kann nicht gestartet werden, da er bereits beendet ist.");
            InfileEndmail;
            LogLine("   CFO bereits beendet");
         ELSIF cfv[this].vote[0].short[0]=0C THEN
            InfileLine("Der CFO kann nicht gestartet werden,");
            InfileLine("da keine Abstimmungspunkte erkannt wurden.");
            InfileEndmail;
            LogLine("   keine Abstimmungspunkte erkannt");
         ELSE
            InfileLine("OK. Der CFO wurde gestartet");
            InfileEndmail;
            RunCfo(this);
            LogString("   CFO gestartet: ");
            LogLine(cfv[this].name);
         END;
      END;
   ELSE
      DoAnswerForm(message, NOCFOANSWER);
      LogLine("   CFO nicht gefunden");
   END;
END DoStartCfo;

PROCEDURE DoVoteCfo(message: Message);
VAR   this:       CARDINAL;
      today:      Date;
      timedOut,
      done,
      access,
      voteOK,
      sysopCFO:   BOOLEAN;
      voteCount,
      pos,
      endpos:     CARDINAL;
      box,
      vote:       ARRAY [0 .. 7] OF CHAR;

   PROCEDURE TopicExists(): BOOLEAN;
   VAR   result:  BOOLEAN;
         i:       CARDINAL;
   BEGIN
      result := FALSE;
      i := 0;
      WHILE NOT result AND (i < MAXTOPIC) DO
         result := (CompareStr(vote, cfv[this].vote[i].short)=0);
         INC(i);
      END;
      RETURN result;
   END TopicExists;

   PROCEDURE SaveVote;
   VAR   file:    File;
   BEGIN
      IF NOT Open(file, cfv[this].votefile, aWrite) THEN
      ELSE
         IF debug THEN
            LogString(" ' (DoVoteCfo.SaveVote): Votefile '");
            LogString(cfv[this].votefile);
            LogLine("' geffnet");
         END;
         void.longcard := Seek(file, sEnd, 0L);
         EtoDateTime(message^.datum, date, time);
         DateToStr(date, DDMMYYYY, '.', dateStr);
         Assign(dateStr, line);
         Append(line, ' ');
         TimeToStr(time, H4MMSS, ':', dateStr);
         Append(line, dateStr);
         Append(line, ' | ');
         IF sysopCFO THEN
            Append(line, box);
            Fill(line, 25, ' ');
            Append(line, ': ');
         END;
         Append(line, message^.von);
         Fill(line, 70, ' ');
         Append(line, ' | ');
         Append(line, vVote);
         WriteLine(file, line);
         Close(file);
         IF debug THEN
            LogLine(" ' (DoVoteCfo.SaveVote): Datei geschlossen");
         END;
      END;
   END SaveVote;

BEGIN
   ClearAnswer(message);
   timedOut := FALSE;
   access := FALSE;
   voteOK := FALSE;
   voteCount := 0;
   sysopCFO := FALSE;
   this := FindCfo(message^.betreff);
   IF this<MAXCFV THEN
      DateToStr(cfv[this].timeout, DDMMYYYY, '.', vTimeout);
      Assign(cfv[this].replyTo, vReplyto);
      IF (cfv[this].state#csRunning) THEN
         (* luft noch nicht oder nicht mehr *)
         GetDate(today);
         IF DaysGone(cfv[this].timeout)<DaysGone(today) THEN
            (* abgelaufen *)
            timedOut := TRUE;
         ELSE
            (* noch nicht gestartet *)
         END;
         this := MAXCFV;
      END;
   END;
   IF this<MAXCFV THEN
      SetVAccess(this);
      (* Berechtigung prfen *)
      access := FALSE;
      CASE cfv[this].access OF
      | vWorld:
         access := TRUE;
      | vMausNet:
         access := IsMausNet(message^.von);
      | vLocal:
         access := IsLocal(message^.von);
      | vSysop:
         access := IsSysop(message^.von, FALSE, box);
         sysopCFO := TRUE;
      | vBetreiber:
         access := IsSysop(message^.von, TRUE, box);
         sysopCFO := TRUE;
      ELSE
         (* kann gar nicht sein ... *)
      END;
      IF access THEN
         (* Mailtext lesen *)
         voteOK := TRUE;
         done := FALSE;
         lastpos := Seek(outfile, sBegin, lastpos);
         REPEAT
            lastpos := Seek0(outfile);
            ReadLine(outfile, buffer);
            (* debug *
            InOut.WriteLine(buffer);
             *       *)
            IF buffer[0]#':' THEN
               done := TRUE;
            ELSE
               pos := Pos(BEGINTOPIC, buffer);
               WHILE pos<HIGH(buffer) DO
                  endpos := Pos(ENDTOPIC, buffer);
                  IF NOT(endpos<HIGH(buffer)) THEN
                     (* keine Endeklammer - Abbruch *)
                     pos := HIGH(buffer);
                  ELSE
                     IF (endpos-pos-1)>4 THEN
                        (* Fehler: Kennung zu lang *)
                        LogString(" * (DoVoteCfo): Kennung zu lang: ");
                        LogLine(buffer);
                     ELSE
                        Copy(buffer, pos+1, endpos-pos-1, vote);
                        IF NOT TopicExists() THEN
                           Assign(vote, vErrcause);
                           Append(vErrcause, " ist kein gltiger Abstimmungspunkt.");
                           done := TRUE;
                           voteOK := FALSE;
                        ELSE
                           IF NOT(vPerson IN cfv[this].type) AND
                              (UPos(vote[0], vVote, void.cardinal)<HIGH(vVote)) THEN
                              Assign("Sie haben zwei sich gegenseitig ausschlieende Punkte gewhlt.",
                                     vErrcause);
                              done := TRUE;
                              voteOK := FALSE;
                           ELSE
                              INC(voteCount);
                              IF voteCount>cfv[this].voteMax THEN
                                 Assign("Sie haben mehr Punkte gewhlt, als bei dieser Abstimmung zugelassen sind.",
                                        vErrcause);
                                 done := TRUE;
                                 voteOK := FALSE;
                              ELSE
                                 IF vVote[0]#0C THEN
                                    Append(vVote, ', ');
                                 END;
                                 Append(vVote, vote);
                              END;
                           END;
                        END;
                     END;
                     Delete(buffer, 0, endpos+1);
                     pos := Pos(BEGINTOPIC, buffer);
                  END;
               END;
            END;
         UNTIL done OR EOF(outfile);
         IF vVote[0]=0C THEN
            Assign("Sie haben keinen Abstimmungspunkt angegeben.",
                   vErrcause);
            voteOK := FALSE;
         END;
      END;
   ELSE
      (* CFO nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   IF this<MAXCFV THEN
      IF voteOK THEN
         (* Stimme sichern *)
         SaveVote;
         DoAnswerForm(message, OKANSWERcfo);
         LogLine("   Stimme gezhlt");
      ELSE
         IF access THEN
            Assign('* ungltig', vVote);
            SaveVote;
            DoAnswerForm(message, ERRANSWERcfo);
            LogLine("   Stimme ungltig");
         ELSE
            Assign('* nicht abstimmungsberechtigt', vVote);
            SaveVote;
            DoAnswerForm(message, NOACCANSWERcfo);
            LogLine("   Absender nicht abstimmungsberechtigt");
         END;
      END;
   ELSE
      IF timedOut THEN
         DoAnswerForm(message, TOANSWERcfo);
         LogLine("   CFO abgelaufen");
      ELSE
         DoAnswerForm(message, NOCFOANSWER);
         LogLine("   CFO nicht gefunden");
      END;
   END;
END DoVoteCfo;

PROCEDURE DoTimeCfo(message: Message);
VAR   this:    CARDINAL;
      changed,
      done,
      keyOK:   BOOLEAN;
      pos:     CARDINAL;
      file:    File;
      newDate: Date;
      error:   ARRAY [0 .. 79]OF CHAR;
BEGIN
   ClearAnswer(message);
   this := FindCfo(message^.betreff);
   IF this<MAXCFV THEN
      keyOK := FALSE;
      changed := FALSE;
      Assign("Keine neue Datumsangabe gefunden.", error);
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         (* debug *
         InOut.WriteLine(buffer);
          *       *)
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            IF UPos(KEY, buffer, pos)<HIGH(buffer) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               keyOK := (CompareStr(buffer, cfv[this].key)=0);
            ELSIF UPos(TIMEOUT, buffer, void.cardinal)<HIGH(buffer) THEN
               Delete(buffer, 0, 1);
               pos := UPos(TIMEOUT, buffer, void.cardinal);
               Delete(buffer, 0, pos+Length(TIMEOUT));
               Trim(buffer);
               (* String to Date *)
               IF NOT StringToDate(buffer, '.', newDate) THEN
                  (* ungltige Datumsangabe *)
                  LogString(" * (DoTimeCfo): ungltige Datumsangabe: ");
                  LogLine(buffer);
                  Assign("Ungltige Datumsangabe!", error);
               ELSE
                  changed := TRUE;
               END;
            END;
         END;
      UNTIL done OR EOF(outfile);
   ELSE
      (* CFO nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   IF this<MAXCFV THEN
      InfileWriteHeader(answer, newID);
      InfileLn;
      IF NOT keyOK THEN
         InfileLine("Sie haben nicht den korrekten Schlssel angegeben.");
         InfileEndmail;
         LogLine("   falscher Schlssel!");
      ELSE
         IF cfv[this].state#csRunning THEN
            InfileLine("Der CFO kann nicht verlngert werden, da er nicht luft.");
            InfileEndmail;
            LogLine("   CFO luft nicht");
         ELSE
            IF changed THEN
               IF DaysGone(newDate)<=DaysGone(cfv[this].timeout) THEN
                  Assign("Neues Datum kleiner oder gleich altem Datum!", error);
                  changed := FALSE;
               ELSE
                  cfv[this].timeout := newDate;
               END;
            END;
            IF NOT changed THEN
               InfileLine(error);
               InfileLine("Datum fr letzte Stimmabgabe nicht gendert.");
               InfileEndmail;
               LogLine("   Datum nicht gendert");
            ELSE
               InfileString(TIMEOUT);
               InfileString(' ');
               DateToStr(cfv[this].timeout, DDMMYYYY, '.', dateStr);
               InfileLine(dateStr);
               InfileEndmail;
               (* und noch eine Mail in die betreffende Gruppe ... *)
               ClearAnswer(message);
               answer^.an[0] := 0C;
               SetVAccess(this);
               Assign(cfv[this].replyTo, vReplyto);
               DateToStr(cfv[this].timeout, DDMMYYYY, '.', vTimeout);
               Assign(cfv[this].gruppe, answer^.gruppe);
               Assign('CFO verlngert: ', answer^.betreff);
               Append(answer^.betreff, cfv[this].name);
               Assign(cfv[this].mausid, answer^.mausrid);
               Assign(cfv[this].id, answer^.rid);
               DoAnswerForm(NIL, TIMEANSWERcfo);
            END;
         END;
      END;
   ELSE
      DoAnswerForm(message, NOCFOANSWER);
      LogLine("   CFO nicht gefunden");
   END;
END DoTimeCfo;

PROCEDURE DoListCfo(message: Message);
VAR   this:    CARDINAL;
      allowed,
      done,
      keyOK:   BOOLEAN;
      pos:     CARDINAL;
      file:    File;
BEGIN
   ClearAnswer(message);
   this := FindCfo(message^.betreff);
   IF this<MAXCFV THEN
      keyOK := FALSE;
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         (* debug *
         InOut.WriteLine(buffer);
          *       *)
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            IF UPos(KEY, buffer, pos)<HIGH(buffer) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               keyOK := (CompareStr(buffer, cfv[this].key)=0);
            END;
         END;
      UNTIL done OR EOF(outfile);
   ELSE
      (* CFO nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   IF this<MAXCFV THEN
      InfileWriteHeader(answer, newID);
      InfileLn;
      IF NOT keyOK THEN
         InfileLine("Sie haben nicht den korrekten Schlssel angegeben.");
         LogLine("   falscher Schlssel!");
      ELSE
         allowed := TRUE;
         CASE cfv[this].state OF
           csNew:
            InfileLine("Der CFO luft noch nicht.");
         | csRunning:
            InfileLine("Der CFO luft zur Zeit.");
            allowed := allowPreview;
         | csStopped:
            InfileLine("Der CFO wurde gestoppt.");
         | csEnded:
            InfileLine("Der CFO ist beendet.");
         END;
         IF NOT allowed THEN
            InfileLn;
            InfileLine("Die Ausgabe des Zwischenstands eines laufenden CFO ist gesperrt.");
            InfileLn;
            LogLine("   Zwischenstand verweigert");
         ELSE
            WriteCfoResult(this);
            LogLine("   Zwischenstand zugestellt");
         END;
      END;
      InfileEndmail;
   ELSE
      DoAnswerForm(message, NOCFOANSWER);
      LogLine("   CFO nicht gefunden");
   END;
END DoListCfo;

PROCEDURE DoEndCfo(message: Message);
VAR   this:    CARDINAL;
      done:    BOOLEAN;
      keyOK:   BOOLEAN;
      pos:     CARDINAL;
      j:       CARDINAL;
      copyTo:  ARRAY [0 .. 255] OF CHAR;
BEGIN
   ClearAnswer(message);
   this := FindCfo(message^.betreff);
   IF this<MAXCFV THEN
      keyOK := FALSE;
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         (* debug *
         InOut.WriteLine(buffer);
          *       *)
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            IF UPos(KEY, buffer, pos)<HIGH(buffer) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               keyOK := (CompareStr(buffer, cfv[this].key)=0);
            END;
         END;
      UNTIL done OR EOF(outfile);
   ELSE
      (* CFO nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   IF this<MAXCFV THEN
      IF NOT keyOK THEN
         InfileWriteHeader(answer, newID);
         InfileLn;
         InfileLine("Sie haben nicht den korrekten Schlssel angegeben.");
         InfileEndmail;
         LogLine("   falscher Schlssel!");
      ELSE
         IF cfv[this].state#csRunning THEN
            InfileWriteHeader(answer, newID);
            InfileLn;
            InfileLine("Der CFO kann nicht beendet werden, da er nicht luft.");
            InfileEndmail;
            LogLine("   CFO luft nicht");
         ELSE
            cfv[this].state := csStopped;
            (* Antwortmail schreiben *)
            InfileWriteHeader(answer, newID);
            InfileLn;
            InfileLine("OK, der CFO wurde abgebrochen.");
            InfileEndmail;
            (*
            (* Auswertung an den Initiator des CFO ... *)
            ClearAnswer(message);
            Assign(cfv[this].replyTo, answer^.an);
            Assign('CFO abgebrochen: ', answer^.betreff);
            Append(answer^.betreff, cfv[this].name);
            InfileWriteHeader(answer, newID);
            InfileLn;
            InfileString(message^.von);
            InfileLine(" hat den CFO abgebrochen!");
            InfileLn;
            WriteCfoResult(this);
            InfileEndmail;
            *)
            (* ... und an die brigen Adressen *)
            Assign(cfv[this].copyTo, copyTo);
            IF copyTo[0]=0C THEN
               Assign(cfv[this].sender, copyTo);
            END;
            WHILE copyTo[0]#0C DO
               ClearAnswer(message);
               IF UPos(',', copyTo, pos)<HIGH(copyTo) THEN
                  Copy(copyTo, 0, pos, answer^.an);
                  Delete(copyTo, 0, pos+1);
               ELSE
                  Assign(copyTo, answer^.an);
                  copyTo[0] := 0C;
               END;
               Trim(answer^.an);
               IF UPos('@', answer^.an, void.cardinal)>=HIGH(answer^.an) THEN
                  Assign(answer^.an, answer^.gruppe);
                  answer^.an[0] := 0C;
               END;
               Assign('CFO abgebrochen: ', answer^.betreff);
               Append(answer^.betreff, cfv[this].name);
               InfileWriteHeader(answer, newID);
               InfileLn;
               InfileString(message^.von);
               InfileLine(" hat den CFO abgebrochen!");
               InfileLn;
               WriteCfoResult(this);
               InfileEndmail;
            END;
            (* und noch eine Mail in die betreffende Gruppe ... *)
            ClearAnswer(message);
            answer^.an[0] := 0C;
            SetVAccess(this);
            Assign(cfv[this].replyTo, vReplyto);
            Assign(cfv[this].copyTo, vCopyto);
            DateToStr(cfv[this].timeout, DDMMYYYY, '.', vTimeout);
            Assign(cfv[this].gruppe, answer^.gruppe);
            Assign('CFO abgebrochen: ', answer^.betreff);
            Append(answer^.betreff, cfv[this].name);
            Assign(cfv[this].mausid, answer^.mausrid);
            Assign(cfv[this].id, answer^.rid);
            DoAnswerForm(NIL, BRKANSWERcfo);
            LogString("   CFO abgebrochen: ");
            LogLine(cfv[this].name);
         END;
      END;
   ELSE
      DoAnswerForm(message, NOCFOANSWER);
      LogLine("   CFO nicht gefunden");
   END;
END DoEndCfo;

BEGIN
   ModReg.Register('VoteCfoFunctions',0,0,' ', 1997,08,16, PROC(NIL));


END VoteCfoFunctions.