IMPLEMENTATION MODULE VoteCfvFunctions;

(*
 * 07.10.1996  -  aus VoteDevil ausgelagert
 * 11.10.1996  -  extra Formular fr 'CFV nicht gefunden'
 * 16.10.1996  -  benutzt ModReg.Register
 *         /2  -  DoTimeCfv implementiert
 * 17.10.1996  -  bei verschiedenen Antworten fehlte die Verkettung
 * 18.10.1996  -  DoChangeCfv implementiert
 * 20.10.1996  -  benutze UPos statt Pos
 *             -  ffentliche Kommentare zu einem CFV werden mit dem Aufruf
 *                verkettet
 * 26.10.1996  -  Bugfix in DoTimeCfv: Fehler bei Datumsvergleich
 * 27.10.1996  -  beim Einlesen des Schlssels auf maximal 32 Zeichen krzen
 *             -  Abstimmungsberechtigung und Datum werden nicht mehr aus der
 *                'Neuer CFV:'-Mail bernommen, sondern vom Programm in den
 *                CFV-Text geschrieben
 * 28.10.1996  -  'Reply to' durch 'Rckfragen an' ersetzt
 *             -  'Auswertung an' ergnzt
 * 29.10.1996  -  Schlssel wird darf jetzt maximal 30 Zeichen lang sein -
 *                damit mte auch das Vergleichen immer klappen
 * 31.10.1996  -  vor dem Krzen mssen natrlich die fhrenden Leerzeichen
 *                entfernt werden ...
 * 06.11.1996  -  VoteCfvFunctions aus VoteFunctions ausgegliedert
 * 26.11.1996  -  CFOs werden untersttzt
 *             -  Fehlermeldung bei abgelaufenem CFV
 *             -  doppelten Footer bei Fehlermeldung in DoDeleteCfv entfernt
 * 28.11.1996  -  Timeout-Datum wurde von DoEndCfv nicht in vTimeout
 *                eingesetzt
 *             -  Warnung falls bei DoNewCfv keine Abstimmungspunkte
 *                erkannt wurden
 *             -  CFV ohne Abstimmungspunkte kann nicht gestartet werden
 *             -  Variablen fr Default-Gruppennamen benutzt
 * 29.11.1996  -  Bugfix: Bei DoNewCfv und DoChangeCfv konnte die Antwort
 *                an die falsche Adresse gehen!
 * 14.12.1996  -  DoVoteCfv: Bei nicht vorhandenem CFV konnte eine falsche
 *                Fehlermeldung (CFV abgelaufen) verschickt werden
 * 19.12.1996  -  in DoEndCfv wird vCopyto gesetzt
 * 12.01.1997  -  ReadCfv: berlauf bei mehr als 16 Abstimmungspunkten
 *                verhindern; vote-Array zu Beginn und am Ende mit einem
 *                leeren Eintrag abschlieen
 * 23.01.1997  -  beim ndern eines CFV cfv[].copyTo lschen
 *             -  der Ansprechpartner (REPLYTO) wird in den CFV-Text
 *                geschrieben
 *             -  der Header des CFV wird erst beim Start erzeugt
 *             -  Laufzeitangabe jetzt auch relativ mglich
 * 28.01.1997  -  Namensangabe beim Lschen eines CFV funktioniert
 *             -  bei abgelaufenem CFV wurden vTimeout und vReplyTo
 *                nicht gesetzt
 * 09.03.1997  -  beim Posten eines CFV Followup setzen
 * 29.03.1997  -  an neues DAT-Format angepat
 * 14.04.1997  -  Bugfix in ReadCfv: Durch nichtinitialisierte Variable
 *                konnte flschlicherweise 'mehrfache Laufzeitangabe'
 *                gemeldet werden
 * 16.06.1997  -  bei Anlegen eines neuen CFV CFV-Name ins Log schreiben
 * 08.07.1997  -  Bugfix in DoChangeCFV: Beim ndern war die Default-
 *                Abstimmungsberechtigung 'Lokal' statt 'MausNet'
 * 16.08.1997  -  beim Anlegen eines CFV ggf. Default fr copyTo einsetzen
 *             -  falls Laufzeitangabe fehlt, Default einsetzen
 *)


IMPORT   InOut;
FROM     Strings           IMPORT   Append, Insert, Delete, Copy, Pos, Length,
                                    CompareStr;
FROM     Strings1          IMPORT   Assign, Trim, Fill, ConvUmlaute,
                                    RemoveLeadingSpaces, RemoveTrailingSpaces;
FROM     NumberConversion  IMPORT   CardToString, StringToCard;
IMPORT   FileIO;
FROM     FileIO            IMPORT   File, FileName, AccessMode, CreateMode,
                                    Open, Create, Close, EOF, Write,
                                    WriteString, WriteLn, WriteLine, CreateTmp,
                                    Read, ReadLine, Seek, Seek0, SeekMode,
                                    State, NOFILE;
IMPORT   Directories;
FROM     TimeNDate         IMPORT   Date, TimeFormat, DateFormat,
                                    GetDate, TimeToStr, DateToStr;
FROM     CDate             IMPORT   DaysGone, Legal;
FROM     RandomGen         IMPORT   RandomCard;
FROM     MausLibrary       IMPORT   MausName, String255;
IMPORT   ModReg;
IMPORT   void;
FROM     VoteGlobals       IMPORT   MAXTOPIC, BEGINTOPIC, ENDTOPIC,
                                    TOPICCHARS, MAXCFV, MAXVOTE, GRPNAMELEN,
                                    BLOCKSIZE, LINELEN, MAXCHEF, MINTIMEOUT,
                                    STDTIMEOUT,
                                    CFGFILE, VOTEFILE, LOGFILE, INFILE, OUTFILE,
                                    CHEFFILE,
                                    OKANSWER, ERRANSWER, NOACCANSWER,
                                    TOANSWER, ENDANSWER,
                                    UNKANSWER, HELPANSWER, NIANSWER,
                                    BRKANSWER, NOALANSWER, NOCFVANSWER,
                                    TIMEANSWER, ERRCFVANSWER,
                                    NEWCFV, CHANGECFV, DELETECFV, STARTCFV,
                                    ENDCFV, TIMECFV, LISTCFV, LISTALL, VOTE,
                                    HELP, NEWAL, DELETEAL, LISTALS, ONCEAL,
                                    KEY, ACCESS, ACCWORLD, ACCMAUSNET,
                                    ACCLOCAL, ACCSYSOPS, ACCBETREIBER, TIMEOUT,
                                    GRUPPE, REPLYTO, VTYPE, TOMOV, TPERSON, VOTES,
                                    VVOTE, VTIMEOUT, VERRCAUSE, VACCESS, VRECEIVED,
                                    VBETREFF, VADDRESS, COPYTO, VTIME, VDAYS,
                                    VWEEKS, VMONTH,
                                    COPYRIGHT, PROGNAME,
                                    ACCESSSTR, ACCALLSTR, ACCMAUSNETSTR, ACCLOCALSTR,
                                    ACCSYSOPSTR, ACCBETREIBERSTR,
                                    VoteType, VoteTypeSet, VoteAccess,
                                    CFVState, Cfv,
                                    MessageRec, Message, VoteRec, Votes, Index,
                                    CfvResult, ChefType, logPath, confPath,
                                    muserFilename, cfgFilename, dataFilename,
                                    logFilename, tmpFilename, tmp2Filename,
                                    chefFilename,
                                    inFilename, outFilename, fileBuffer, cfgfile,
                                    datafile, logfile, infile, outfile, textfile,
                                    line, buffer, help, debug,
                                    date, time, dateStr, cfv, cfvResult, mes,
                                    answer, lastpos, votes, index, votehigh, newID,
                                    chefList, allowLocalCFVs, allowListALs,
                                    allowPreview, followupTo,
                                    vVote, vTimeout, vErrcause, vAccess, vReceived,
                                    vReplyto, vCopyto, vBetreff, vAddress,
                                    grpCFO, grpALL, grpLOCAL, grpMAUSNET,
                                    grpSYSOP, grpBETREIBER,
                                    copyToALL, copyToLOCAL, copyToMAUSNET,
                                    copyToSYSOP, copyToBETREIBER, timeoutCFV,
                                    LogTime, LogCopyright, LogString,
                                    LogLine,
                                    StringToDate, EtoDateTime, IstZahler,
                                    IsLocal, IsMausNet, IsSysop, BeginsWith,
                                    UPos, MausDomain, NewMail,
                                    ClearMail, DumpMail, ClearAnswer,
                                    SetVAccess, ReplaceWildcards;
FROM     VoteFiles         IMPORT   InfileLn, InfileString, InfileLine,
                                    InfileEndmail, InfileWriteHeader,
                                    FindChef, DeleteChef;
FROM     VoteFunctions     IMPORT   DoAnswerForm, ReadVotes, CountVotes,
                                    ListResult;
FROM     VoteCfxFunctions  IMPORT   WriteHeaderToInfile, SetTimeout;


PROCEDURE FindCfv(betreff: ARRAY OF CHAR): CARDINAL;
VAR   result:  CARDINAL;
      pos:     CARDINAL;
      str:     String255;
BEGIN
   pos := Pos(":", betreff);
   IF pos<HIGH(betreff) THEN
      Delete(betreff, 0, pos+1);
   END;
   Trim(betreff);
   ConvUmlaute(betreff);
   result := 0;
   IF NOT(vCFO IN cfv[result].type) THEN
      Assign(cfv[result].name, str);
      ConvUmlaute(str);
   ELSE
      str[0] := 0C;
   END;
   WHILE (result<MAXCFV) AND (CompareStr(str, betreff)#0) DO
      INC(result);
      IF result<MAXCFV THEN
         IF NOT(vCFO IN cfv[result].type) THEN
            Assign(cfv[result].name, str);
            ConvUmlaute(str);
         ELSE
            str[0] := 0C;
         END;
      END;
   END;
   RETURN result;
END FindCfv;

PROCEDURE GetCfvFile(VAR str: ARRAY OF CHAR);
VAR   i:    CARDINAL;
      ok:   BOOLEAN;
      name: FileName;
      file: File;
BEGIN
   ok := FALSE;
   i := 0;
   WHILE NOT ok DO
      CardToString(i, str, 1);
      IF i<10 THEN
         Insert('VD_CFV0', str, 0);
      ELSE
         Insert('VD_CFV', str, 0);
      END;
      Assign(str, name);
      Append(name, '.TXT');
      IF Open(file, name, aRead) THEN
         Close(file);
      ELSE
         ok := TRUE;
      END;
      INC(i);
   END;
END GetCfvFile;

PROCEDURE WriteCfvResult(this:   CARDINAL);
VAR   file:    File;
BEGIN
   ReadVotes(this);
   CountVotes(this);
   InfileLn;
   InfileLn;
   ListResult(this);
   InfileLn;
   InfileLn;
   IF (vOMOV IN cfv[this].type) THEN
      InfileLine("Auswertung pro Box:");
      InfileLn;
      IF NOT Open(file, tmp2Filename, aRead) THEN
         (* temporre Datei konnte nicht geffnet werden *)
         LogString(" * (WriteCfvResult): Konnte temporre Datei '");
         LogString(tmp2Filename);
         LogLine("' nicht ffnen!");
         InfileLine(" * Fehler: Konnte Liste der Ergebnisse pro Box nicht finden!");
      ELSE
         IF debug THEN
            LogString(" ' (WriteCfvResult): temporre Datei '");
            LogString(tmp2Filename);
            LogLine("' geffnet");
         END;
         WHILE NOT EOF(file) DO
            ReadLine(file, line);
            InfileLine(line);
         END;
         Close(file);
         Directories.Delete(tmp2Filename);
         IF debug THEN
            LogLine(" ' (WriteCfvResult): Datei geschlossen und gelscht");
         END;
      END;
      InfileLn;
      InfileLn;
      InfileLine("Die Liste der abgegebenen Stimmen (nach Box sortiert):");
   ELSE
      InfileLine("Die Liste der abgegebenen Stimmen in alphabetischer Reihenfolge:");
   END;
   InfileLn;
   IF NOT Open(file, tmpFilename, aRead) THEN
      (* temporre Datei konnte nicht geffnet werden *)
      LogString(" * (WriteCfvResult): Konnte temporre Datei '");
      LogString(tmpFilename);
      LogLine("' nicht ffnen!");
      InfileLine(" * Fehler: Konnte sortierte Liste der Stimmen nicht finden!");
   ELSE
      IF debug THEN
         LogString(" ' (WriteCfvResult): temporre Datei '");
         LogString(tmpFilename);
         LogLine("' geffnet");
      END;
      WHILE NOT EOF(file) DO
         ReadLine(file, line);
         InfileLine(line);
      END;
      Close(file);
      Directories.Delete(tmpFilename);
      IF debug THEN
         LogLine(" ' (WriteCfvResult): Datei geschlossen und gelscht");
      END;
   END;
END WriteCfvResult;

MODULE MakeCfv;

IMPORT   Seek, Seek0, ReadLine, Pos, UPos, Delete, Length, Trim, Assign,
         WriteString, WriteLn, WriteLine, StringToCard, CardToString,
         Append, LogString, LogLine, Copy, InfileString, InfileLine,
         InfileLn, DateToStr, GetDate, ClearAnswer, InfileWriteHeader, newID,
         DoAnswerForm, FindCfv, GetCfvFile, Create, Close, CreateMode,
         SeekMode, AccessMode, InfileEndmail, CreateTmp, Directories,
         Message, Cfv, File, Date, lastpos, outfile, infile, buffer,
         KEY, GRUPPE, REPLYTO, COPYTO, VTYPE, TPERSON, TOMOV, VOTES, ACCESS,
         ACCBETREIBER, ACCSYSOPS, ACCMAUSNET, ACCWORLD, grpALL, grpLOCAL,
         grpMAUSNET, grpSYSOP, grpBETREIBER, vWorld, vMausNet, vLocal,
         vSysop, vBetreiber, vOMOV, vPerson, VoteTypeSet, ACCLOCAL,
         TIMEOUT, StringToDate, date, BEGINTOPIC, ENDTOPIC, EOF, cfv, void,
         dateStr, MAXTOPIC, DateFormat, Open, debug, line, Legal, vErrcause,
         DaysGone, MAXCHEF, FindChef, MINTIMEOUT, allowLocalCFVs, NOALANSWER,
         ERRCFVANSWER, IsLocal, MAXCFV, chefList, NEWCFV, RandomCard, cOnce,
         DeleteChef, answer, PROGNAME, CompareStr, tmpFilename, NOCFVANSWER,
         ACCESSSTR, ACCLOCALSTR, ACCALLSTR, ACCMAUSNETSTR, ACCSYSOPSTR,
         ACCBETREIBERSTR, MausName, RemoveLeadingSpaces, RemoveTrailingSpaces,
         VTIME, BeginsWith, WriteHeaderToInfile, VDAYS, VWEEKS, VMONTH,
         followupTo, CFVState, copyToALL, copyToMAUSNET, copyToSYSOP,
         copyToBETREIBER, copyToLOCAL, timeoutCFV;
EXPORT   DoNewCfv, DoChangeCfv;

VAR   topic,
      endpos,
      pos:        CARDINAL;
      timeSet,
      numOK,
      errLocal,
      errTopicMax,
      done:       BOOLEAN;
      str:        ARRAY [0 .. 79] OF CHAR;
      i, j:       CARDINAL;
      vTime,
      chef:       CARDINAL;

   PROCEDURE ReadCfv(    message:   Message;
                     VAR tmpCfv:    Cfv;
                         textfile:  File;
                         change:    BOOLEAN);
   VAR   copyTo:  ARRAY [0 .. 127] OF CHAR;
   BEGIN
      timeSet := FALSE;
      topic := 0;
      (* ersten Eintrag lschen *)
      tmpCfv.vote[0].short[0] := 0C;
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            Delete(buffer, 0, 1);
            IF BeginsWith(KEY, buffer, pos) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               Assign(buffer, tmpCfv.key);
            ELSIF BeginsWith(GRUPPE, buffer, pos) THEN
               Delete(buffer, 0, pos+Length(GRUPPE));
               Trim(buffer);
               Assign(buffer, tmpCfv.gruppe);
            ELSIF BeginsWith(REPLYTO, buffer, pos) THEN
               Delete(buffer, 0, pos+Length(REPLYTO));
               Trim(buffer);
               Assign(buffer, tmpCfv.replyTo);
            ELSIF BeginsWith(COPYTO, buffer, pos) THEN
               Delete(buffer, 0, pos+Length(COPYTO));
               Trim(buffer);
               IF tmpCfv.copyTo[0]#0C THEN
                  Append(tmpCfv.copyTo, ', ');
               END;
               Append(tmpCfv.copyTo, buffer);
            ELSIF BeginsWith(VTYPE, buffer, void.cardinal) THEN
               IF UPos(TOMOV, buffer, void.cardinal)<HIGH(buffer) THEN
                  INCL(tmpCfv.type, vOMOV);
               END;
               IF UPos(TPERSON, buffer, void.cardinal)<HIGH(buffer) THEN
                  INCL(tmpCfv.type, vPerson);
               END;
            ELSIF BeginsWith(VOTES, buffer, pos) THEN
               Delete(buffer, 0, pos+Length(VOTES));
               Trim(buffer);
               StringToCard(buffer, tmpCfv.voteMax, numOK);
               IF NOT numOK THEN
                  tmpCfv.voteMax := MAX(CARDINAL);
               END;
            ELSIF BeginsWith(ACCESS, buffer, void.cardinal) THEN
               IF UPos(ACCLOCAL, buffer, void.cardinal)<HIGH(buffer) THEN
                  tmpCfv.access := vLocal;
               ELSIF UPos(ACCBETREIBER, buffer, void.cardinal)<HIGH(buffer) THEN
                  tmpCfv.access := vBetreiber;
               ELSIF UPos(ACCSYSOPS, buffer, void.cardinal)<HIGH(buffer) THEN
                  tmpCfv.access := vSysop;
               ELSIF UPos(ACCMAUSNET, buffer, void.cardinal)<HIGH(buffer) THEN
                  tmpCfv.access := vMausNet;
               ELSIF UPos(ACCWORLD, buffer, void.cardinal)<HIGH(buffer) THEN
                  tmpCfv.access := vWorld;
               ELSE
                  tmpCfv.access := vMausNet;
               END;
               IF chef=MAXCHEF THEN
                  (* nur lokaler CFV erlaubt! *)
                  IF tmpCfv.access#vLocal THEN
                     tmpCfv.access := vLocal;
                     Assign(ACCESSSTR, buffer);
                     Append(buffer, ACCLOCALSTR);
                     Append(buffer, MausName);
                     errLocal := TRUE;
                  END;
               END;
            ELSIF BeginsWith(TIMEOUT, buffer, void.cardinal) THEN
               IF timeSet THEN
                  LogString(" * (ReadCfv): mehrfache Laufzeitangabe: ");
                  LogLine(buffer);
               ELSE
                  pos := UPos(TIMEOUT, buffer, void.cardinal);
                  Delete(buffer, 0, pos+Length(TIMEOUT));
                  Trim(buffer);
                  (* String to Date *)
                  IF NOT StringToDate(buffer, '.', date) THEN
                     (* ungltige Datumsangabe *)
                     LogString(" * (ReadCfv): ungltige Datumsangabe: ");
                     LogLine(buffer);
                  ELSE
                     tmpCfv.timeout := date;
                     timeSet := TRUE;
                  END;
               END;
            ELSIF BeginsWith(VTIME, buffer, void.cardinal) THEN
               IF timeSet THEN
                  LogString(" * (ReadCfv): mehrfache Laufzeitangabe: ");
                  LogLine(buffer);
               ELSE
                  pos := UPos(VTIME, buffer, void.cardinal);
                  Delete(buffer, 0, pos+Length(VTIME));
                  Trim(buffer);
                  pos := Pos(' ', buffer);
                  IF pos<HIGH(buffer) THEN
                     Copy(buffer, 0, pos, str);
                     StringToCard(str, vTime, void.boolean);
                     Delete(buffer, 0, pos);
                     RemoveLeadingSpaces(buffer);
                     IF BeginsWith(VDAYS, buffer, void.cardinal) THEN
                     ELSIF BeginsWith(VWEEKS, buffer, void.cardinal) THEN
                        vTime := vTime*7;
                     ELSIF BeginsWith(VMONTH, buffer, void.cardinal) THEN
                        vTime := vTime*30;
                     ELSE (* Fehler *)
                        LogString(" * (ReadCfv): falsche Zeiteinheit: ");
                        LogLine(buffer);
                        vTime := 0;
                     END;
                  ELSE
                     LogLine(" ! (ReadCfv): Zeiteinheit fehlt - rechne mit Tagen");
                     StringToCard(buffer, vTime, void.boolean);
                  END;
                  IF debug THEN
                     LogLine(" ' (ReadCfv): setzte Laufzeit");
                  END;
                  tmpCfv.timeout.day := vTime;
                  tmpCfv.timeout.year := 9999;
                  tmpCfv.timeout.month := 99;
                  timeSet := TRUE;
               END;
            ELSE
               WriteLine(textfile, buffer);
               pos := Pos(BEGINTOPIC, buffer);
               WHILE pos<HIGH(buffer) DO
                  endpos := Pos(ENDTOPIC, buffer);
                  IF NOT(endpos<HIGH(buffer)) THEN
                     (* keine Endeklammer - Abbruch *)
                     pos := HIGH(buffer);
                  ELSE
                     IF (endpos-pos-1)>4 THEN
                        (* Fehler: Kennung zu lang *)
                        LogString(" * (ReadCfv): Kennung zu lang: ");
                        LogLine(buffer);
                     ELSE
                        IF topic<MAXTOPIC THEN
                           Copy(buffer, pos+1, endpos-pos-1, tmpCfv.vote[topic].short);
                           tmpCfv.vote[topic].count := 0.0;
                           INC(topic);
                        ELSE
                           LogString(" * (ReadCfv): zu viele Abstimmungspunkte: ");
                           LogLine(buffer);
                           errTopicMax := TRUE;
                        END;
                     END;
                     Delete(buffer, 0, endpos+1);
                     pos := Pos(BEGINTOPIC, buffer);
                  END;
               END;
               (* das Array mit einem leeren Eintrag abschlieen *)
               IF topic<MAXTOPIC THEN
                  tmpCfv.vote[topic].short[0] := 0C;
               END;
            END;
         END;
      UNTIL done OR EOF(outfile);
      (* falls keine Laufzeit angegeben, Default einsetzen *)
      IF NOT timeSet THEN
         tmpCfv.timeout.day := timeoutCFV;
         tmpCfv.timeout.year := 9999;
         tmpCfv.timeout.month := 99;
         timeSet := TRUE;
      END;
      (* Gruppe fr ffentliches Posting des CFV *)
      (* (auerdem Default fr copyTo setzen)    *)
      IF tmpCfv.gruppe[0]=0C THEN
         (* Default-Gruppe je nach Art des CFV einstellen *)
         CASE tmpCfv.access OF
         | vWorld:
            Assign(grpALL, tmpCfv.gruppe);
            Assign(copyToALL, copyTo);
         | vMausNet:
            Assign(grpMAUSNET, tmpCfv.gruppe);
            Assign(copyToMAUSNET, copyTo);
         | vLocal:
            Assign(grpLOCAL, tmpCfv.gruppe);
            Assign(copyToLOCAL, copyTo);
         | vSysop:
            Assign(grpSYSOP, tmpCfv.gruppe);
            Assign(copyToSYSOP, copyTo);
         | vBetreiber:
            Assign(grpBETREIBER, tmpCfv.gruppe);
            Assign(copyToBETREIBER, copyTo);
         ELSE
            (* kann gar nicht sein ... *)
            copyTo[0] := 0C;
         END;
      END;
      (* falls keine Adresse fr Auswertung angegeben, Default einsetzen *)
      IF tmpCfv.copyTo[0]=0C THEN
         (* Sender *)
         Assign(tmpCfv.sender, tmpCfv.copyTo);
         (* + vorkonfigurierte Adressen *)
         IF copyTo[0]#0C THEN
            Append(tmpCfv.copyTo, ', ');
            Append(tmpCfv.copyTo, copyTo);
         END;
      END;
   END ReadCfv;

   PROCEDURE WriteCfvToInfile(this: CARDINAL);
   VAR textfile: File;
   BEGIN
      InfileString("Titel: ");
      InfileLine(cfv[this].name);
      InfileLn;
      IF errLocal THEN
         InfileLine("Sie drfen nur lokale CFVs starten!");
      END;
      CASE cfv[this].access OF
      | vWorld:
         InfileLine("Abstimmungsberechtigt ist jeder, der eine PM an den Dmon schicken kann.");
      | vMausNet:
         InfileLine("Abstimmungsberechtigt sind alle zahlenden User des MausNet.");
      | vLocal:
         InfileLine("Abstimmungsberechtigt sind alle zahlenden User der lokalen MAUS.");
      | vSysop:
         InfileLine("Abstimmungsberechtigt sind alle im ISB aufgefhrten Sysops des MausNet.");
      | vBetreiber:
         InfileLine("Abstimmungsberechtigt sind alle im ISB aufgefhrten Betreiber des MausNet.");
      ELSE
         (* kann gar nicht sein ... *)
      END;
      InfileLn;
      InfileString(VTYPE);
      IF (vOMOV IN cfv[this].type) THEN
         InfileString(' ');
         InfileString(TOMOV);
      END;
      IF (vPerson IN cfv[this].type) THEN
         InfileString(' ');
         InfileString(TPERSON);
      END;
      IF (cfv[this].type=VoteTypeSet{}) THEN
         InfileString(' Normal');
      END;
      InfileLn;
      InfileLn;
      IF cfv[this].voteMax#MAX(CARDINAL) THEN
         InfileString(VOTES);
         CardToString(cfv[this].voteMax, str, 3);
         InfileLine(str);
         InfileLn;
      END;
      IF cfv[this].timeout.year=9999 THEN
         InfileString("Die Laufzeit des CFV betrgt ");
         CardToString(cfv[this].timeout.day, str, 1);
         InfileString(str);
         InfileLine(" Tage.");
      ELSE
         InfileString("Die Stimmen mssen bis sptestens ");
         DateToStr(cfv[this].timeout, DDMMYYYY, '.', dateStr);
         InfileString(dateStr);
         InfileLine(" beim Abstimmungsdmon angekommen sein.");
      END;
      InfileLn;
      InfileString("Verffentlicht wird der CFV in der Gruppe ");
      InfileLine(cfv[this].gruppe);
      InfileLn;
      InfileString("Verantwortlich fr den CFV ist ");
      InfileLine(cfv[this].replyTo);
      InfileLn;
      InfileString("Die Auswertung geht an ");
      InfileLine(cfv[this].copyTo);
      InfileLn;
      IF cfv[this].vote[0].short[0]=0C THEN
         InfileLine("*Es wurden keine Abstimmungspunkte erkannt!*");
      ELSE
         InfileLine("Folgende Punkte stehen zur Abstimmung:");
         InfileString("          ");
         i := 0;
         j := 0;
         WHILE (i<MAXTOPIC) AND (cfv[this].vote[i].short[0]#0C) DO
            InfileString(cfv[this].vote[i].short);
            InfileString(", ");
            INC(i);
            INC(j);
            IF j>=10 THEN
               j := 0;
               InfileLn;
               InfileString("          ");
            END;
         END;
      END;
      InfileLn;
      InfileLn;
      InfileString("Der fr nderungen notwendige Schlssel lautet: ");
      InfileLine(cfv[this].key);
      InfileLn;
      InfileLine("--- Text des CFV folgt: ---");
      IF NOT Open(textfile, cfv[this].textfile, aRead) THEN
         (* Fehler *)
         LogString(" * (WriteCfvToInfile): Datei mit CFV-Text '");
         LogString(cfv[this].textfile);
         LogLine("' konnte nicht geffnet werden!");
      ELSE
         IF debug THEN
            LogString(" ' (WriteCfvToInfile): CFV-Text '");
            LogString(cfv[this].textfile);
            LogLine("' geffnet");
         END;
         WriteHeaderToInfile(this);
         WHILE NOT EOF(textfile) DO
            ReadLine(textfile, line);
            InfileLine(line);
         END;
      END;
      Close(textfile);
      IF debug THEN
         LogLine(" ' (WriteCfvToInfile): Datei geschlossen");
      END;
      InfileLine("--- Ende des CFV-Textes ---");
   END WriteCfvToInfile;

   PROCEDURE CheckCfv(VAR cfv: Cfv): BOOLEAN;
   VAR   result:  BOOLEAN;
         today:   Date;
   BEGIN
      result := TRUE;
      GetDate(today);
      IF cfv.timeout.year=9999 THEN
         IF cfv.timeout.day<MINTIMEOUT THEN
            Assign("Ein CFV mu mindestens ", vErrcause);
            CardToString(MINTIMEOUT, str, 1);
            Append(vErrcause, str);
            Append(vErrcause, " Tage laufen.");
            result := FALSE;
         END;
      ELSE
         IF NOT Legal(cfv.timeout) THEN
            Assign("Sie haben kein gltiges Datum fr die letzte Stimmabgabe angegeben.", vErrcause);
            result := FALSE;
         ELSIF cfv.timeout.year=0 THEN
            Assign("Sie haben kein gltiges Datum fr die letzte Stimmabgabe angegeben.", vErrcause);
            result := FALSE;
         ELSIF (DaysGone(today)+LONG(MINTIMEOUT))>DaysGone(cfv.timeout) THEN
            Assign("Ein CFV mu mindestens ", vErrcause);
            CardToString(MINTIMEOUT, str, 1);
            Append(vErrcause, str);
            Append(vErrcause, " Tage laufen.");
            result := FALSE;
         END;
      END;
      IF errTopicMax THEN
         Assign("Sie haben zu viele Abstimmungspunkte angegeben (Maximum: ", vErrcause);
         CardToString(MAXTOPIC, str, 1);
         Append(vErrcause, str);
         Append(vErrcause, ").");
         result := FALSE;
      END;
      RETURN result;
   END CheckCfv;

   PROCEDURE DoNewCfv(message: Message);
   (*
    * neuer CFV
    *)
   VAR   i:          CARDINAL;
         this:       CARDINAL;
         exists:     BOOLEAN;
         textfile,
         votefile:   File;
   BEGIN
      ClearAnswer(message);
      (* Berechtigung prfen *)
      chef := MAXCHEF;
      IF NOT(FindChef(message^.von, chef) OR
         (allowLocalCFVs AND IsLocal(message^.von))) THEN
         DoAnswerForm(message, NOALANSWER);
         LogLine("   Absender ist nicht berechtigt einen CFV anzulegen");
      ELSE
         (* CFV suchen *)
         exists := FALSE;
         this := 0;
         WHILE (this<MAXCFV) AND (cfv[this].name[0]#0C) DO
            INC(this);
         END;
         IF FindCfv(message^.betreff)<MAXCFV THEN
            (* keine zwei CFVs mit gleichem Namen zulassen *)
            exists := TRUE;
            this := MAXCFV;
         END;
         IF this<MAXCFV THEN
            Assign(message^.betreff, cfv[this].name);
            Assign(message^.von, cfv[this].sender);
            Assign(message^.von, cfv[this].replyTo);
            cfv[this].copyTo[0] := 0C;
            cfv[this].access := vLocal;
            cfv[this].type := VoteTypeSet{};
            cfv[this].voteMax := MAX(CARDINAL);
            errLocal := FALSE;
            errTopicMax := FALSE;
            cfv[this].gruppe[0] := 0C;
            cfv[this].key[0] := 0C;
            cfv[this].state := csNew;
            cfv[this].timeout.year := 0;
            cfv[this].mausid[0] := 0C;
            cfv[this].id[0] := 0C;
            Delete(cfv[this].name, 0, Length(NEWCFV));
            Trim(cfv[this].name);
            GetCfvFile(str);
            Assign(str, cfv[this].textfile);
            Append(cfv[this].textfile, '.TXT');
            (* Textfile ffnen *)
            IF NOT Create(textfile, cfv[this].textfile, aWrite, cClobber) THEN
               (* Fehler *)
               LogString(" * (DoNewCfv): Datei fr CFV-Text '");
               LogString(cfv[this].textfile);
               LogLine("' konnte nicht angelegt werden!");
            ELSE
               IF debug THEN
                  LogString(" ' (DoNewCfv): Datei fr CFV-Text '");
                  LogString(cfv[this].textfile);
                  LogLine("' wurde angelegt");
               END;
            END;
            Assign(str, cfv[this].votefile);
            Append(cfv[this].votefile, '.VOT');
            IF NOT Create(votefile, cfv[this].votefile, aWrite, cClobber) THEN
               (* Fehler *)
               LogString(" * (DoNewCfv): Datei fr Stimmzhlung '");
               LogString(cfv[this].votefile);
               LogLine("' konnte nicht angelegt werden!");
            ELSE
               Close(votefile);
            END;
            ReadCfv(message, cfv[this], textfile, FALSE);
            IF NOT CheckCfv(cfv[this]) THEN
               DoAnswerForm(message, ERRCFVANSWER);
               cfv[this].name[0] := 0C;
               Directories.Delete(cfv[this].textfile);
               Directories.Delete(cfv[this].votefile);
               LogLine("   falsche oder unvollstndige Angaben");
            ELSE
               (* Schlssel fr nderungen des CFV *)
               IF cfv[this].key[0]=0C THEN
                  (* zuflligen Schlssel erzeugen - case-insensitiv *)
                  FOR i := 0 TO 15 DO
                     cfv[this].key[i] := CHR(RandomCard(ORD("A"), ORD("Z")));
                  END;
                  cfv[this].key[16] := 0C;
               END;
               (* Textfile schlieen *)
               Close(textfile);
               IF debug THEN
                  LogLine(" ' (DoNewCfv): Datei geschlossen");
               END;
               (* Einmal-Chefs lschen *)
               IF chef<MAXCHEF THEN
                  IF chefList[chef].type = cOnce THEN
                     DeleteChef(chef);
                  END;
               END;
               (* Besttigung verschicken *)
               ClearAnswer(message);
               InfileWriteHeader(answer, newID);
               InfileLn;
               InfileLine("Folgender CFV wurde angenommen:");
               InfileLn;
               WriteCfvToInfile(this);
               InfileEndmail;
               LogString("   Neuer CFV wurde angelegt: ");
               LogLine(cfv[this].name);
            END;
         ELSE
            (* zu viele CFVs! *)
            IF exists THEN
               Assign("Es existiert bereits ein CFV unter gleichem Namen.", vErrcause);
               DoAnswerForm(message, ERRCFVANSWER);
               LogLine("   CFV existiert bereits");
            ELSE
               Assign("Es laufen schon ", vErrcause);
               CardToString(MAXCFV, str, 1);
               Append(vErrcause, str);
               Append(vErrcause, " CFVs bzw. CFOs. Mehr kann ");
               Append(vErrcause, PROGNAME);
               Append(vErrcause, " nicht gleichzeitig verwalten.");
               DoAnswerForm(message, ERRCFVANSWER);
               LogLine("   Zu viele CFVs/CFOs");
            END;
         END;
      END;
   END DoNewCfv;

   PROCEDURE DoChangeCfv(message: Message);
   (*
    * CFV ndern
    *)
   VAR   tmpfile:    File;
         tmpCfv:     Cfv;
         this:       CARDINAL;
   BEGIN
      ClearAnswer(message);
      (* CFV suchen *)
      this := FindCfv(message^.betreff);
      IF this<MAXCFV THEN
         IF (cfv[this].state=csRunning) THEN
            Assign("Der CFV luft bereits.", vErrcause);
            DoAnswerForm(message, ERRCFVANSWER);
            LogLine("   CFV luft bereits.");
         ELSIF (cfv[this].state=csEnded) THEN
            Assign("Der CFV ist bereits beendet.", vErrcause);
            DoAnswerForm(message, ERRCFVANSWER);
            LogLine("   CFV bereits beendet.");
         ELSE
            void.boolean := FindChef(message^.von, chef);
            (* temporres Textfile ffnen *)
            tmpFilename[0] := 0C;   (* _nicht_ im TMP-Pfad! *)
            IF NOT CreateTmp(tmpfile, tmpFilename, aWrite) THEN
               (* Fehler *)
               LogString(" * (DoChangeCfv): temporre Datei fr CFV-Text '");
               LogString(tmpFilename);
               LogLine("' konnte nicht angelegt werden!");
            ELSE
               IF debug THEN
                  LogString(" ' (DoChangeCfv): temporre Datei fr CFV-Text '");
                  LogString(tmpFilename);
                  LogLine("' wurde angelegt");
               END;
               errLocal := FALSE;
               errTopicMax := FALSE;
               tmpCfv := cfv[this];
               tmpCfv.access := vMausNet;
               tmpCfv.type := VoteTypeSet{};
               tmpCfv.voteMax := MAX(CARDINAL);
               tmpCfv.timeout.year := 0;
               tmpCfv.gruppe[0] := 0C;
               tmpCfv.copyTo[0] := 0C;
               ReadCfv(message, tmpCfv, tmpfile, FALSE);
               (* Textfile schlieen *)
               Close(tmpfile);
               IF debug THEN
                  LogLine(" ' (DoChangeCfv): temporre Datei geschlossen");
               END;
               IF NOT CheckCfv(tmpCfv) THEN
                  DoAnswerForm(message, ERRCFVANSWER);
                  Directories.Delete(tmpFilename);
                  LogLine("   falsche oder unvollstndige Angaben");
               ELSE
                  IF (CompareStr(cfv[this].key, tmpCfv.key)#0) THEN
                     (* falscher Schlssel *)
                     Assign("Sie haben nicht den korrekten Schlssel angegeben.", vErrcause);
                     DoAnswerForm(message, ERRCFVANSWER);
                     Directories.Delete(tmpFilename);
                     LogLine("   falscher Schlssel");
                  ELSE
                     (* Schlssel OK *)
                     cfv[this] := tmpCfv;
                     Directories.Delete(cfv[this].textfile);
                     Directories.Rename(tmpFilename, cfv[this].textfile);
                     (* Besttigung verschicken *)
                     ClearAnswer(message);
                     InfileWriteHeader(answer, newID);
                     InfileLn;
                     InfileLine("Der CFV wurde wie folgt gendert:");
                     WriteCfvToInfile(this);
                     InfileEndmail;
                     LogLine("   CFV wurde gendert");
                  END;
               END;
            END;
         END;
      ELSE
         (* Cfv nicht gefunden *)
         DoAnswerForm(message, NOCFVANSWER);
         LogLine("   CFV nicht gefunden");
      END;
   END DoChangeCfv;

END MakeCfv;

PROCEDURE DoDeleteCfv(message: Message);
VAR   this:    CARDINAL;
      done:    BOOLEAN;
      keyOK:   BOOLEAN;
      pos:     CARDINAL;
      j:       CARDINAL;
BEGIN
   ClearAnswer(message);
   this := FindCfv(message^.betreff);
   IF this<MAXCFV THEN
      keyOK := FALSE;
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         (* debug *
         InOut.WriteLine(buffer);
          *       *)
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            IF UPos(KEY, buffer, pos)<HIGH(buffer) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               keyOK := (CompareStr(buffer, cfv[this].key)=0);
            END;
         END;
      UNTIL done OR EOF(outfile);
   ELSE
      (* CFV nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   IF this<MAXCFV THEN
      InfileWriteHeader(answer, newID);
      InfileLn;
      IF NOT keyOK THEN
         InfileLine("Sie haben nicht den korrekten Schlssel angegeben.");
         LogLine("   falscher Schlssel");
      ELSE
         IF cfv[this].state=csRunning THEN
            InfileLine("Der CFV kann nicht gelscht werden, da er bereits luft.");
            InfileLn;
            InfileLine("Mit 'Beende CFV:' knnen Sie ihn vorzeitig beenden.");
            LogLine("   CFV luft bereits");
         ELSE
            LogString("   CFV gelscht: ");
            LogLine(cfv[this].name);
            Directories.Delete(cfv[this].textfile);
            Directories.Delete(cfv[this].votefile);
            j := this;
            WHILE j<(MAXCFV-1) DO
               cfv[j] := cfv[j+1];
               INC(j);
            END;
            cfv[MAXCFV-1].name[0] := 0C;
            InfileLine("OK. Der CFV wurde gelscht");
         END;
      END;
      InfileEndmail;
   ELSE
      DoAnswerForm(message, NOCFVANSWER);
      LogLine("   CFV nicht gefunden");
   END;
END DoDeleteCfv;

PROCEDURE RunCfv(this:  CARDINAL);
VAR   mes:  Message;
BEGIN
   (* CFV posten *)
   mes := NewMail();
   Assign(cfv[this].name, mes^.betreff);
   Assign(followupTo, mes^.followup);
   Insert(' ', mes^.betreff, 0);
   Insert(VOTE, mes^.betreff, 0);
   Assign(cfv[this].gruppe, mes^.gruppe);
   IF cfv[this].access = vLocal THEN
      mes^.distribution := 'L';
   END;
   InfileWriteHeader(mes, cfv[this].mausid);
   IF NOT Open(textfile, cfv[this].textfile, aRead) THEN
      (* Fehler *)
      LogString(" * (RunCfv): Datei mit CFV-Text '");
      LogString(cfv[this].textfile);
      LogLine("' konnte nicht geffnet werden!");
   ELSE
      IF debug THEN
         LogString(" ' (RunCfv): CFV-Text '");
         LogString(cfv[this].textfile);
         LogLine("' geffnet");
      END;
      SetTimeout(this);
      WriteHeaderToInfile(this);
      (* CFV-Text: *)
      WHILE NOT EOF(textfile) DO
         ReadLine(textfile, line);
         InfileLine(line);
      END;
   END;
   Close(textfile);
   IF debug THEN
      LogLine(" ' (RunCfv): Datei geschlossen");
   END;
   InfileEndmail;
   DumpMail(mes);
   cfv[this].state := csRunning;
END RunCfv;

PROCEDURE DoStartCfv(message: Message);
VAR   this:    CARDINAL;
      done:    BOOLEAN;
      keyOK:   BOOLEAN;
      pos:     CARDINAL;
BEGIN
   ClearAnswer(message);
   this := FindCfv(message^.betreff);
   IF this<MAXCFV THEN
      keyOK := FALSE;
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         (* debug *
         InOut.WriteLine(buffer);
          *       *)
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            IF UPos(KEY, buffer, pos)<HIGH(buffer) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               keyOK := (CompareStr(buffer, cfv[this].key)=0);
            END;
         END;
      UNTIL done OR EOF(outfile);
   ELSE
      (* CFV nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   InfileWriteHeader(answer, newID);
   InfileLn;
   IF this<MAXCFV THEN
      IF NOT keyOK THEN
         InfileLine("Sie haben nicht den korrekten Schlssel angegeben.");
         InfileEndmail;
         LogLine("   falscher Schlssel!");
      ELSE
         IF cfv[this].state=csRunning THEN
            InfileLine("Der CFV kann nicht gestartet werden, da er bereits luft.");
            InfileEndmail;
            LogLine("   CFV luft bereits");
         ELSIF cfv[this].state=csEnded THEN
            InfileLine("Der CFV kann nicht gestartet werden, da er bereits beendet ist.");
            InfileEndmail;
            LogLine("   CFV bereits beendet");
         ELSIF cfv[this].vote[0].short[0]=0C THEN
            InfileLine("Der CFV kann nicht gestartet werden,");
            InfileLine("da keine Abstimmungspunkte erkannt wurden.");
            InfileEndmail;
            LogLine("   keine Abstimmungspunkte erkannt");
         ELSE
            InfileLine("OK. Der CFV wurde gestartet");
            InfileEndmail;
            RunCfv(this);
            LogString("   CFV gestartet: ");
            LogLine(cfv[this].name);
         END;
      END;
   ELSE
      DoAnswerForm(message, NOCFVANSWER);
      LogLine("   CFV nicht gefunden");
   END;
END DoStartCfv;

PROCEDURE DoVoteCfv(message: Message);
VAR   this:       CARDINAL;
      today:      Date;
      timedOut:   BOOLEAN;
      done,
      access,
      voteOK,
      sysopCFV:   BOOLEAN;
      voteCount,
      pos,
      endpos:     CARDINAL;
      box,
      vote:       ARRAY [0 .. 7] OF CHAR;

   PROCEDURE TopicExists(): BOOLEAN;
   VAR   result:  BOOLEAN;
         i:       CARDINAL;
   BEGIN
      result := FALSE;
      i := 0;
      WHILE NOT result AND (i < MAXTOPIC) DO
         result := (CompareStr(vote, cfv[this].vote[i].short)=0);
         INC(i);
      END;
      RETURN result;
   END TopicExists;

   PROCEDURE SaveVote;
   VAR   file:    File;
   BEGIN
      IF NOT Open(file, cfv[this].votefile, aWrite) THEN
      ELSE
         IF debug THEN
            LogString(" ' (SaveVote): Votefile '");
            LogString(cfv[this].votefile);
            LogLine("' geffnet");
         END;
         void.longcard := Seek(file, sEnd, 0L);
         EtoDateTime(message^.datum, date, time);
         (* GetDate(date); *)
         DateToStr(date, DDMMYYYY, '.', dateStr);
         Assign(dateStr, line);
         Append(line, ' ');
         (* GetTime(time); *)
         TimeToStr(time, H4MMSS, ':', dateStr);
         Append(line, dateStr);
         Append(line, ' | ');
         IF sysopCFV THEN
            Append(line, box);
            Fill(line, 25, ' ');
            Append(line, ': ');
         END;
         Append(line, message^.von);
         Fill(line, 70, ' ');
         Append(line, ' | ');
         Append(line, vVote);
         WriteLine(file, line);
         Close(file);
         IF debug THEN
            LogLine(" ' (SaveVote): Datei geschlossen");
         END;
      END;
   END SaveVote;

BEGIN
   ClearAnswer(message);
   timedOut := FALSE;
   access := FALSE;
   voteOK := FALSE;
   voteCount := 0;
   sysopCFV := FALSE;
   this := FindCfv(message^.betreff);
   IF this<MAXCFV THEN
      DateToStr(cfv[this].timeout, DDMMYYYY, '.', vTimeout);
      Assign(cfv[this].replyTo, vReplyto);
      IF (cfv[this].state#csRunning) THEN
         (* luft noch nicht oder nicht mehr *)
         GetDate(today);
         IF DaysGone(cfv[this].timeout)<DaysGone(today) THEN
            (* abgelaufen *)
            timedOut := TRUE;
         ELSE
            (* noch nicht gestartet *)
         END;
         this := MAXCFV;
      END;
   END;
   IF this<MAXCFV THEN
      SetVAccess(this);
      (* Berechtigung prfen *)
      access := FALSE;
      CASE cfv[this].access OF
      | vWorld:
         access := TRUE;
      | vMausNet:
         access := IsMausNet(message^.von);
      | vLocal:
         access := IsLocal(message^.von);
      | vSysop:
         access := IsSysop(message^.von, FALSE, box);
         sysopCFV := TRUE;
      | vBetreiber:
         access := IsSysop(message^.von, TRUE, box);
         sysopCFV := TRUE;
      ELSE
         (* kann gar nicht sein ... *)
      END;
      IF access THEN
         (* Mailtext lesen *)
         voteOK := TRUE;
         done := FALSE;
         lastpos := Seek(outfile, sBegin, lastpos);
         REPEAT
            lastpos := Seek0(outfile);
            ReadLine(outfile, buffer);
            (* debug *
            InOut.WriteLine(buffer);
             *       *)
            IF buffer[0]#':' THEN
               done := TRUE;
            ELSE
               pos := Pos(BEGINTOPIC, buffer);
               WHILE pos<HIGH(buffer) DO
                  endpos := Pos(ENDTOPIC, buffer);
                  IF NOT(endpos<HIGH(buffer)) THEN
                     (* keine Endeklammer - Abbruch *)
                     pos := HIGH(buffer);
                  ELSE
                     IF (endpos-pos-1)>4 THEN
                        (* Fehler: Kennung zu lang *)
                        LogString(" * (DoVote): Kennung zu lang: ");
                        LogLine(buffer);
                     ELSE
                        Copy(buffer, pos+1, endpos-pos-1, vote);
                        IF NOT TopicExists() THEN
                           Assign(vote, vErrcause);
                           Append(vErrcause, " ist kein gltiger Abstimmungspunkt.");
                           done := TRUE;
                           voteOK := FALSE;
                        ELSE
                           IF NOT(vPerson IN cfv[this].type) AND
                              (UPos(vote[0], vVote, void.cardinal)<HIGH(vVote)) THEN
                              Assign("Sie haben zwei sich gegenseitig ausschlieende Punkte gewhlt.",
                                     vErrcause);
                              done := TRUE;
                              voteOK := FALSE;
                           ELSE
                              INC(voteCount);
                              IF voteCount>cfv[this].voteMax THEN
                                 Assign("Sie haben mehr Punkte gewhlt, als bei dieser Abstimmung zugelassen sind.",
                                        vErrcause);
                                 done := TRUE;
                                 voteOK := FALSE;
                              ELSE
                                 IF vVote[0]#0C THEN
                                    Append(vVote, ', ');
                                 END;
                                 Append(vVote, vote);
                              END;
                           END;
                        END;
                     END;
                     Delete(buffer, 0, endpos+1);
                     pos := Pos(BEGINTOPIC, buffer);
                  END;
               END;
            END;
         UNTIL done OR EOF(outfile);
         IF vVote[0]=0C THEN
            Assign("Sie haben keinen Abstimmungspunkt angegeben.",
                   vErrcause);
            voteOK := FALSE;
         END;
      END;
   ELSE
      (* CFV nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   IF this<MAXCFV THEN
      IF voteOK THEN
         (* Stimme sichern *)
         SaveVote;
         DoAnswerForm(message, OKANSWER);
         LogLine("   Stimme gezhlt");
      ELSE
         IF access THEN
            Assign('* ungltig', vVote);
            SaveVote;
            DoAnswerForm(message, ERRANSWER);
            LogLine("   Stimme ungltig");
         ELSE
            Assign('* nicht abstimmungsberechtigt', vVote);
            SaveVote;
            DoAnswerForm(message, NOACCANSWER);
            LogLine("   Absender nicht abstimmungsberechtigt");
         END;
      END;
   ELSE
      IF timedOut THEN
         DoAnswerForm(message, TOANSWER);
         LogLine("   CFV abgelaufen");
      ELSE
         DoAnswerForm(message, NOCFVANSWER);
         LogLine("   CFV nicht gefunden");
      END;
   END;
END DoVoteCfv;

PROCEDURE DoTimeCfv(message: Message);
VAR   this:    CARDINAL;
      changed,
      done,
      keyOK:   BOOLEAN;
      pos:     CARDINAL;
      file:    File;
      newDate: Date;
      error:   ARRAY [0 .. 79]OF CHAR;
BEGIN
   ClearAnswer(message);
   this := FindCfv(message^.betreff);
   IF this<MAXCFV THEN
      keyOK := FALSE;
      changed := FALSE;
      Assign("Keine neue Datumsangabe gefunden.", error);
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         (* debug *
         InOut.WriteLine(buffer);
          *       *)
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            IF UPos(KEY, buffer, pos)<HIGH(buffer) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               keyOK := (CompareStr(buffer, cfv[this].key)=0);
            ELSIF UPos(TIMEOUT, buffer, void.cardinal)<HIGH(buffer) THEN
               Delete(buffer, 0, 1);
               pos := UPos(TIMEOUT, buffer, void.cardinal);
               Delete(buffer, 0, pos+Length(TIMEOUT));
               Trim(buffer);
               (* String to Date *)
               IF NOT StringToDate(buffer, '.', newDate) THEN
                  (* ungltige Datumsangabe *)
                  LogString(" * (DoTimeCfv): ungltige Datumsangabe: ");
                  LogLine(buffer);
                  Assign("Ungltige Datumsangabe!", error);
               ELSE
                  changed := TRUE;
               END;
            END;
         END;
      UNTIL done OR EOF(outfile);
   ELSE
      (* CFV nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   IF this<MAXCFV THEN
      InfileWriteHeader(answer, newID);
      InfileLn;
      IF NOT keyOK THEN
         InfileLine("Sie haben nicht den korrekten Schlssel angegeben.");
         InfileEndmail;
         LogLine("   falscher Schlssel!");
      ELSE
         IF cfv[this].state#csRunning THEN
            InfileLine("Der CFV kann nicht verlngert werden, da er nicht luft.");
            InfileEndmail;
            LogLine("   CFV luft nicht");
         ELSE
            IF changed THEN
               IF DaysGone(newDate)<=DaysGone(cfv[this].timeout) THEN
                  Assign("Neues Datum kleiner oder gleich altem Datum!", error);
                  changed := FALSE;
               ELSE
                  cfv[this].timeout := newDate;
               END;
            END;
            IF NOT changed THEN
               InfileLine(error);
               InfileLine("Datum fr letzte Stimmabgabe nicht gendert.");
               InfileEndmail;
               LogLine("   Datum nicht gendert");
            ELSE
               InfileString(TIMEOUT);
               InfileString(' ');
               DateToStr(cfv[this].timeout, DDMMYYYY, '.', dateStr);
               InfileLine(dateStr);
               InfileEndmail;
               (* und noch eine Mail in die betreffende Gruppe ... *)
               ClearAnswer(message);
               answer^.an[0] := 0C;
               SetVAccess(this);
               Assign(cfv[this].replyTo, vReplyto);
               DateToStr(cfv[this].timeout, DDMMYYYY, '.', vTimeout);
               Assign(cfv[this].gruppe, answer^.gruppe);
               Assign('CFV verlngert: ', answer^.betreff);
               Append(answer^.betreff, cfv[this].name);
               Assign(cfv[this].mausid, answer^.mausrid);
               Assign(cfv[this].id, answer^.rid);
               DoAnswerForm(NIL, TIMEANSWER);
            END;
         END;
      END;
   ELSE
      DoAnswerForm(message, NOCFVANSWER);
      LogLine("   CFV nicht gefunden");
   END;
END DoTimeCfv;

PROCEDURE DoListCfv(message: Message);
VAR   this:    CARDINAL;
      allowed,
      done,
      keyOK:   BOOLEAN;
      pos:     CARDINAL;
      file:    File;
BEGIN
   ClearAnswer(message);
   this := FindCfv(message^.betreff);
   IF this<MAXCFV THEN
      keyOK := FALSE;
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         (* debug *
         InOut.WriteLine(buffer);
          *       *)
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            IF UPos(KEY, buffer, pos)<HIGH(buffer) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               keyOK := (CompareStr(buffer, cfv[this].key)=0);
            END;
         END;
      UNTIL done OR EOF(outfile);
   ELSE
      (* CFV nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   IF this<MAXCFV THEN
      InfileWriteHeader(answer, newID);
      InfileLn;
      IF NOT keyOK THEN
         InfileLine("Sie haben nicht den korrekten Schlssel angegeben.");
         LogLine("   falscher Schlssel!");
      ELSE
         allowed := TRUE;
         CASE cfv[this].state OF
           csNew:
            InfileLine("Der CFV luft noch nicht.");
         | csRunning:
            InfileLine("Der CFV luft zur Zeit.");
            allowed := allowPreview;
         | csStopped:
            InfileLine("Der CFV wurde gestoppt.");
         | csEnded:
            InfileLine("Der CFV ist beendet.");
         END;
         IF NOT allowed THEN
            InfileLn;
            InfileLine("Die Ausgabe des Zwischenstands eines laufenden CFV ist gesperrt.");
            InfileLn;
            LogLine("   Zwischenstand verweigert");
         ELSE
            WriteCfvResult(this);
            LogLine("   Zwischenstand zugestellt");
         END;
      END;
      InfileEndmail;
   ELSE
      DoAnswerForm(message, NOCFVANSWER);
      LogLine("   CFV nicht gefunden");
   END;
END DoListCfv;

PROCEDURE DoEndCfv(message: Message);
VAR   this:    CARDINAL;
      done:    BOOLEAN;
      keyOK:   BOOLEAN;
      pos:     CARDINAL;
      j:       CARDINAL;
      copyTo:  ARRAY [0 .. 255] OF CHAR;
BEGIN
   ClearAnswer(message);
   this := FindCfv(message^.betreff);
   IF this<MAXCFV THEN
      keyOK := FALSE;
      (* Mailtext lesen *)
      done := FALSE;
      lastpos := Seek(outfile, sBegin, lastpos);
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         (* debug *
         InOut.WriteLine(buffer);
          *       *)
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            IF UPos(KEY, buffer, pos)<HIGH(buffer) THEN
               Delete(buffer, 0, pos+Length(KEY));
               RemoveLeadingSpaces(buffer);
               buffer[30] := 0C;
               RemoveTrailingSpaces(buffer);
               keyOK := (CompareStr(buffer, cfv[this].key)=0);
            END;
         END;
      UNTIL done OR EOF(outfile);
   ELSE
      (* CFV nicht gefunden *)
   END;
   (* Antwortmail schreiben *)
   IF this<MAXCFV THEN
      IF NOT keyOK THEN
         InfileWriteHeader(answer, newID);
         InfileLn;
         InfileLine("Sie haben nicht den korrekten Schlssel angegeben.");
         InfileEndmail;
         LogLine("   falscher Schlssel!");
      ELSE
         IF cfv[this].state#csRunning THEN
            InfileWriteHeader(answer, newID);
            InfileLn;
            InfileLine("Der CFV kann nicht beendet werden, da er nicht luft.");
            InfileEndmail;
            LogLine("   CFV luft nicht");
         ELSE
            cfv[this].state := csStopped;
            (* Antwortmail schreiben *)
            InfileWriteHeader(answer, newID);
            InfileLn;
            InfileLine("OK, der CFV wurde abgebrochen.");
            InfileEndmail;
            (*
            (* Auswertung an den Initiator des CFV ... *)
            ClearAnswer(message);
            Assign(cfv[this].replyTo, answer^.an);
            Assign('CFV abgebrochen: ', answer^.betreff);
            Append(answer^.betreff, cfv[this].name);
            InfileWriteHeader(answer, newID);
            InfileLn;
            InfileString(message^.von);
            InfileLine(" hat den CFV abgebrochen!");
            InfileLn;
            WriteCfvResult(this);
            InfileEndmail;
            *)
            (* ... und an die brigen Adressen *)
            Assign(cfv[this].copyTo, copyTo);
            IF copyTo[0]=0C THEN
               Assign(cfv[this].sender, copyTo);
            END;
            WHILE copyTo[0]#0C DO
               ClearAnswer(message);
               IF UPos(',', copyTo, pos)<HIGH(copyTo) THEN
                  Copy(copyTo, 0, pos, answer^.an);
                  Delete(copyTo, 0, pos+1);
               ELSE
                  Assign(copyTo, answer^.an);
                  copyTo[0] := 0C;
               END;
               Trim(answer^.an);
               IF UPos('@', answer^.an, void.cardinal)>=HIGH(answer^.an) THEN
                  Assign(answer^.an, answer^.gruppe);
                  answer^.an[0] := 0C;
               END;
               Assign('CFV abgebrochen: ', answer^.betreff);
               Append(answer^.betreff, cfv[this].name);
               InfileWriteHeader(answer, newID);
               InfileLn;
               InfileString(message^.von);
               InfileLine(" hat den CFV abgebrochen!");
               InfileLn;
               WriteCfvResult(this);
               InfileEndmail;
            END;
            (* und noch eine Mail in die betreffende Gruppe ... *)
            ClearAnswer(message);
            answer^.an[0] := 0C;
            SetVAccess(this);
            Assign(cfv[this].replyTo, vReplyto);
            Assign(cfv[this].copyTo, vCopyto);
            DateToStr(cfv[this].timeout, DDMMYYYY, '.', vTimeout);
            Assign(cfv[this].gruppe, answer^.gruppe);
            Assign('CFV abgebrochen: ', answer^.betreff);
            Append(answer^.betreff, cfv[this].name);
            Assign(cfv[this].mausid, answer^.mausrid);
            Assign(cfv[this].id, answer^.rid);
            DoAnswerForm(NIL, BRKANSWER);
            LogString("   CFV abgebrochen: ");
            LogLine(cfv[this].name);
         END;
      END;
   ELSE
      DoAnswerForm(message, NOCFVANSWER);
      LogLine("   CFV nicht gefunden");
   END;
END DoEndCfv;

BEGIN
   ModReg.Register('VoteCfvFunctions',0,0,' ', 1997,08,16, PROC(NIL));


END VoteCfvFunctions.