IMPLEMENTATION MODULE VoteCfxFunctions;

(*
 * 23.01.1997  -  erste Version
 *)


FROM     Strings           IMPORT   Append, Insert, Delete, Copy, Pos, Length,
                                    CompareStr;
FROM     Strings1          IMPORT   Assign, Trim, Fill, ConvUmlaute,
                                    RemoveLeadingSpaces, RemoveTrailingSpaces;
FROM     NumberConversion  IMPORT   CardToString, StringToCard;
IMPORT   FileIO;
FROM     FileIO            IMPORT   File, FileName, AccessMode, CreateMode,
                                    Open, Create, Close, EOF, Write,
                                    WriteString, WriteLn, WriteLine, CreateTmp,
                                    Read, ReadLine, Seek, Seek0, SeekMode,
                                    State, NOFILE;
IMPORT   Directories;
FROM     TimeNDate         IMPORT   Date, TimeFormat, DateFormat,
                                    GetDate, TimeToStr, DateToStr;
FROM     CDate             IMPORT   DaysGone, Legal, DaysToDate;
FROM     RandomGen         IMPORT   RandomCard;
FROM     MausLibrary       IMPORT   MausName, String255;
IMPORT   ModReg;
IMPORT   void;
FROM     VoteGlobals       IMPORT   MAXTOPIC, BEGINTOPIC, ENDTOPIC,
                                    TOPICCHARS, MAXCFV, MAXVOTE, GRPNAMELEN,
                                    BLOCKSIZE, LINELEN, MAXCHEF, MINTIMEOUT,
                                    STDTIMEOUT,
                                    CFGFILE, VOTEFILE, LOGFILE, INFILE, OUTFILE,
                                    CHEFFILE,
                                    OKANSWER, ERRANSWER, NOACCANSWER,
                                    TOANSWER, ENDANSWER,
                                    UNKANSWER, HELPANSWER, NIANSWER,
                                    BRKANSWER, NOALANSWER, NOCFVANSWER,
                                    TIMEANSWER, ERRCFVANSWER,
                                    NEWCFV, CHANGECFV, DELETECFV, STARTCFV,
                                    ENDCFV, TIMECFV, LISTCFV, LISTALL, VOTE,
                                    HELP, NEWAL, DELETEAL, LISTALS, ONCEAL,
                                    KEY, ACCESS, ACCWORLD, ACCMAUSNET,
                                    ACCLOCAL, ACCSYSOPS, ACCBETREIBER, TIMEOUT,
                                    GRUPPE, REPLYTO, VTYPE, TOMOV, TPERSON, VOTES,
                                    VVOTE, VTIMEOUT, VERRCAUSE, VACCESS, VRECEIVED,
                                    VBETREFF, VADDRESS, COPYTO, VTIME,
                                    COPYRIGHT, PROGNAME,
                                    ACCESSSTR, ACCALLSTR, ACCMAUSNETSTR, ACCLOCALSTR,
                                    ACCSYSOPSTR, ACCBETREIBERSTR,
                                    VoteType, VoteTypeSet, VoteAccess, Cfv,
                                    MessageRec, Message, VoteRec, Votes, Index,
                                    CfvResult, ChefType, logPath, confPath,
                                    muserFilename, cfgFilename, dataFilename,
                                    logFilename, tmpFilename, tmp2Filename,
                                    chefFilename,
                                    inFilename, outFilename, fileBuffer, cfgfile,
                                    datafile, logfile, infile, outfile, textfile,
                                    line, buffer, help, debug,
                                    date, time, dateStr, cfv, cfvResult, mes,
                                    answer, lastpos, votes, index, votehigh, newID,
                                    chefList, allowLocalCFVs, allowListALs,
                                    allowPreview,
                                    vVote, vTimeout, vErrcause, vAccess, vReceived,
                                    vReplyto, vCopyto, vBetreff, vAddress,
                                    grpCFO, grpALL, grpLOCAL, grpMAUSNET,
                                    grpSYSOP, grpBETREIBER,
                                    LogTime, LogCopyright, LogString,
                                    LogLine,
                                    StringToDate, EtoDateTime, IstZahler,
                                    IsLocal, IsMausNet, IsSysop, BeginsWith,
                                    UPos, MausDomain, NewMail,
                                    ClearMail, DumpMail, ClearAnswer,
                                    SetVAccess, ReplaceWildcards;
FROM     VoteFiles         IMPORT   InfileLn, InfileString, InfileLine,
                                    InfileEndmail, InfileWriteHeader,
                                    FindChef, DeleteChef;


PROCEDURE WriteHeaderToInfile(this: CARDINAL);
VAR   str:  ARRAY [0 .. 8] OF CHAR;
BEGIN
   (* Header zusammenstellen *)
   InfileLn;
   (* abstimmungsberechtigt: *)
   InfileString(ACCESSSTR);
   CASE cfv[this].access OF
   | vWorld:
      InfileLine(ACCALLSTR);
   | vMausNet:
      InfileLine(ACCMAUSNETSTR);
   | vLocal:
      InfileString(ACCLOCALSTR);
      InfileLine(MausName);
   | vSysop:
      InfileLine(ACCSYSOPSTR);
   | vBetreiber:
      InfileLine(ACCBETREIBERSTR);
   ELSE
      (* kann gar nicht sein ... *)
   END;
   (* Abstimmungstyp: *)
   InfileString(VTYPE);
   IF vOMOV IN cfv[this].type THEN
      InfileString(' ');
      InfileString(TOMOV);
   END;
   IF vPerson IN cfv[this].type THEN
      InfileString(' ');
      InfileString(TPERSON);
   END;
   IF (cfv[this].type-VoteTypeSet{vCFO})=VoteTypeSet{} THEN
      InfileString(' Normal');
   END;
   InfileLn;
   (* Anzahl der Stimmen: *)
   IF cfv[this].voteMax#MAX(CARDINAL) THEN
      InfileString(VOTES);
      CardToString(cfv[this].voteMax, str, 3);
      InfileLine(str);
   END;
   (* letzte Stimmabgabe: *)
   IF cfv[this].timeout.year = 9999 THEN
      InfileString(VTIME);
      CardToString(cfv[this].timeout.day, str, 1);
      InfileString(' ');
      InfileString(str);
      InfileLine(' Tage');
   ELSE
      DateToStr(cfv[this].timeout, DDMMYYYY, '.', dateStr);
      InfileString(TIMEOUT);
      InfileString(' ');
      InfileLine(dateStr);
   END;
   (* Rckfragen an: *)
   InfileString(REPLYTO);
   InfileString(' ');
   InfileLine(cfv[this].replyTo);
   InfileLn;
END WriteHeaderToInfile;

PROCEDURE SetTimeout(this: CARDINAL);
VAR   date: Date;
      days: LONGCARD;
BEGIN
   IF cfv[this].timeout.year = 9999 THEN
      GetDate(date);
      days := DaysGone(date);
      INC(days, cfv[this].timeout.day);
      DaysToDate(days, cfv[this].timeout);
   END;
END SetTimeout;


BEGIN
   ModReg.Register('VoteCfxFunctions',0,0,' ',1997,01,23,PROC(NIL));


END VoteCfxFunctions.
