MODULE VoteDevil;

(*
 * Abstimmungsdmon fr das MausNet
 *
 * 23.09.1996  -  Beginn der Entwicklung
 * 28.09.1996  -  erste compilefhige Version
 * 30.09.1996  -  erste Pre-Alpha-Version :) fr einen Online-Test
 * 13.10.1996  -  Versionsnummer 0.1 alpha
 * 16.10.1996  -  ModReg integriert
 *         /2  -  DoTimeCfv implementiert
 * 20.10.1996  -  CFV-Ergebnis wird mit CFV-Ankndigung verkettet
 * 28.10.1996  -  'Reply to' durch 'Rckfragen an' ersetzt
 *             -  'Auswertung an' ergnzt
 * 06.11.1996  -  VoteCfvFunctions aus VoteFunctions ausgegliedert
 *             -  freie Hilfetexte ergnzt
 * 09.11.1996  -  Signature ergnzt
 * 12.11.1996  -  UserPath (Pfad auf MUSER.DAT) aus CFG lesen
 * 26.11.1996  -  CFOs werden untersttzt
 * 28.11.1996  -  Default-Gruppennamen aus CFG lesen
 * 01.12.1996  -  neue CFG-Variable MaxMessageSize
 * 02.12.1996  -  Pfade fr Hilfetexte und Templates ergnzt
 * 03.12.1996  -  Kommando und Textzeile fr Hilfe-Liste konfigurierbar
 * 04.12.1996  -  VOTEHELP.CFG wird ab sofort im HelpPath gesucht bzw.
 *                angelegt
 *             -  Wahl-Funktionen abschaltbar
 *             -  auf lokale Funktion beschrnkbar
 * 07.12.1996  -  neue CFG-Variablen VerticalSplitting, MailLimitNet,
 *                MailLimitMausNet, MailLimitLocal
 * 19.12.1996  -  CFV/O-Auswertungen mit Aufruf verketten
 *             -  vCopyto wird gesetzt
 * 05.01.1997  -  SetDefaults und ReadConfig nach VoteGlobals verschoben
 * 11.01.1997  -  LogToStdOut funktioniert wieder
 *             -  'CFO beendet:' statt 'CFV beendet:' bei CFO-Ende als
 *                Betreff beim Kommentar zum Aufruf
 * 28.01.1997  -  beim Lschen von CFVs/CFOs werden auch die Textfiles
 *                mit gelscht; ins Log eintragen
 * 17.02.1997  -  Bugfix: CFx mit Laufzeitangabe wurde vorzeitig gelscht
 * 09.03.1997  -  Mails von Programmen werden ignoriert
 * 29.03.1997  -  an neues DAT-Format angepat
 * 09.04.1997  -  -q (quiet) implementiert
 * 17.04.1997  -  FindHelpfile durch FindHelp ersetzt 
 * 16.08.1997  -  'Ergebnis CFx:' durch 'Auszhlung CFx:' ersetzt
 *)


FROM     SYSTEM            IMPORT   ADDRESS, ADR, BYTE;
FROM     System            IMPORT   GetArg;
FROM     Storage           IMPORT   ALLOCATE, DEALLOCATE;
IMPORT   InOut;
IMPORT   Directories;
FROM     Strings           IMPORT   Append, Delete, Copy, CompareStr;
FROM     Strings1          IMPORT   Assign, Trim, Upper;
FROM     FileIO            IMPORT   File, PathName, AccessMode, CreateMode,
                                    Open, Create, Close, EOF, CloseAll;
FROM     TimeNDate         IMPORT   TimeFormat, DateFormat,
                                    GetTime, GetDate, TimeToStr, DateToStr;
FROM     CDate             IMPORT   DaysGone;
FROM     RandomGen         IMPORT   Randomize;
IMPORT   Lists;
FROM     Lists             IMPORT   List;
IMPORT   ConfigFile;
IMPORT   ModReg;
IMPORT   void;

FROM     VoteGlobals       IMPORT   MAXCFV, MAXVOTE, MAXCHEF,
                                    ENDANSWER, ENDANSWERcfo,
                                    VOTECFO, NEWCFO, CHANGECFO, DELETECFO,
                                    STARTCFO, ENDCFO, TIMECFO, LISTCFO,
                                    NEWCFV, CHANGECFV, DELETECFV, STARTCFV,
                                    ENDCFV, TIMECFV, LISTCFV, LISTALL, VOTE,
                                    HELP, NEWAL, DELETEAL, LISTALS, NEWHELP,
                                    CHANGEHELP, DELETEHELP, LISTHELP, ONCEAL,
                                    COPYRIGHT, PROGNAME,
                                    VoteType, CFVState, PtrHelpRec,
                                    cfgFilename, dataFilename, logFilename,
                                    inFilename, outFilename,
                                    datafile, logfile, infile, outfile,
                                    legalExit, remoteAccess, voteFunctions,
                                    help, debug, logToStdOut, quiet, newID,
                                    date, time, dateStr, cfv, mes, answer,
                                    lastpos, votes, index, chefList,
                                    helpList, destList, helpListCmd,
                                    vTimeout, vReplyto, vCopyto,
                                    SetDefaults, ReadConfig, LogTime,
                                    LogCopyright, LogString, LogLine,
                                    UPos, IsLocal, IsDemon, BeginsWith,
                                    NewMail, ClearMail, DumpMail,
                                    SetVAccess, DisposeDestRec;
FROM     VoteFiles         IMPORT   InfileLn, InfileString,
                                    InfileLine, InfileEndmail,
                                    InfileWriteHeader, WriteDatafile,
                                    ReadDatafile, ReadChefs, WriteChefs,
                                    DisposeChefs, FindChef, AddChef,
                                    DeleteChef, ReadHelpfiles, WriteHelpfiles,
                                    DisposeHelpfiles, FindHelp,
                                    DeleteHelpfile, AddHelpfile,
                                    DisposeHelpRec;
FROM     VoteFunctions     IMPORT   DoAnswerForm, DoUnknownError, DoHelp,
                                    DoListAll, DoNotImplemented, DoNewAL,
                                    DoDeleteAL, DoListALs, DoNewHelp,
                                    DoChangeHelp, DoDeleteHelp, DoListHelp,
                                    ClearVotes, ReadVotes, CountVotes,
                                    ListResult, ReadHeader;
FROM     VoteCfvFunctions  IMPORT   FindCfv, GetCfvFile, WriteCfvResult,
                                    DoNewCfv, DoDeleteCfv, DoStartCfv,
                                    DoVoteCfv, DoTimeCfv, DoListCfv, DoEndCfv,
                                    DoChangeCfv;
FROM     VoteCfoFunctions  IMPORT   FindCfo, GetCfoFile, WriteCfoResult,
                                    DoNewCfo, DoDeleteCfo, DoStartCfo,
                                    DoVoteCfo, DoTimeCfo, DoListCfo, DoEndCfo,
                                    DoChangeCfo;


PROCEDURE ReadOutfile;
VAR   helpfile:   PathName;
      help:       PtrHelpRec;
      done:       BOOLEAN;
BEGIN
   LogString(" - lese ");
   LogLine(outFilename);
   lastpos := 0L;
   WHILE NOT EOF(outfile) DO
      IF ReadHeader(mes) THEN
         LogString(" < MId: ");
         LogString(mes^.id);
         LogString(" von ");
         LogString(mes^.von);
         LogString(": ");
         IF NOT(remoteAccess OR IsLocal(mes^.von)) THEN
            LogLine(" *Zugriff von auen abgewiesen*");
         ELSIF IsDemon(mes^.von) THEN
            LogLine(" *Mail von Programm  ignoriert*");
         ELSE
            IF mes^.an[0]#0C THEN
               done := FALSE;
               IF voteFunctions THEN
                  done := TRUE;
                  IF BeginsWith(VOTE, mes^.betreff, void.cardinal) THEN
                     LogLine("Stimmabgabe");
                     DoVoteCfv(mes);
                  ELSIF BeginsWith(VOTECFO, mes^.betreff, void.cardinal) THEN
                     LogLine("Stimmabgabe CFO");
                     DoVoteCfo(mes);
                  ELSIF BeginsWith(LISTCFV, mes^.betreff, void.cardinal) THEN
                     LogLine(LISTCFV);
                     DoListCfv(mes);
                  ELSIF BeginsWith(LISTCFO, mes^.betreff, void.cardinal) THEN
                     LogLine(LISTCFO);
                     DoListCfo(mes);
                  ELSIF BeginsWith(LISTALL, mes^.betreff, void.cardinal) THEN
                     LogLine(LISTALL);
                     DoListAll(mes);
                  ELSIF BeginsWith(NEWCFV, mes^.betreff, void.cardinal) THEN
                     LogLine(NEWCFV);
                     DoNewCfv(mes);
                  ELSIF BeginsWith(NEWCFO, mes^.betreff, void.cardinal) THEN
                     LogLine(NEWCFO);
                     DoNewCfo(mes);
                  ELSIF BeginsWith(CHANGECFV, mes^.betreff, void.cardinal) THEN
                     LogLine(CHANGECFV);
                     DoChangeCfv(mes);
                  ELSIF BeginsWith(CHANGECFO, mes^.betreff, void.cardinal) THEN
                     LogLine(CHANGECFO);
                     DoChangeCfo(mes);
                  ELSIF BeginsWith(DELETECFV, mes^.betreff, void.cardinal) THEN
                     LogLine(DELETECFV);
                     DoDeleteCfv(mes);
                  ELSIF BeginsWith(DELETECFO, mes^.betreff, void.cardinal) THEN
                     LogLine(DELETECFO);
                     DoDeleteCfo(mes);
                  ELSIF BeginsWith(STARTCFV, mes^.betreff, void.cardinal) THEN
                     LogLine(STARTCFV);
                     DoStartCfv(mes);
                  ELSIF BeginsWith(STARTCFO, mes^.betreff, void.cardinal) THEN
                     LogLine(STARTCFO);
                     DoStartCfo(mes);
                  ELSIF BeginsWith(ENDCFV, mes^.betreff, void.cardinal) THEN
                     LogLine(ENDCFV);
                     DoEndCfv(mes);
                  ELSIF BeginsWith(ENDCFO, mes^.betreff, void.cardinal) THEN
                     LogLine(ENDCFO);
                     DoEndCfo(mes);
                  ELSIF BeginsWith(TIMECFV, mes^.betreff, void.cardinal) THEN
                     LogLine(TIMECFV);
                     DoTimeCfv(mes); (* Verlngern *)
                  ELSIF BeginsWith(TIMECFO, mes^.betreff, void.cardinal) THEN
                     LogLine(TIMECFO);
                     DoTimeCfo(mes); (* Verlngern *)
                  ELSE
                     done := FALSE;
                  END;
               END;
               IF NOT done THEN
                  IF BeginsWith(NEWAL, mes^.betreff, void.cardinal) THEN
                     LogLine(NEWAL);
                     DoNewAL(mes);
                  ELSIF BeginsWith(DELETEAL, mes^.betreff, void.cardinal) THEN
                     LogLine(DELETEAL);
                     DoDeleteAL(mes);
                  ELSIF BeginsWith(LISTALS, mes^.betreff, void.cardinal) THEN
                     LogLine(LISTALS);
                     DoListALs(mes);
                  ELSIF BeginsWith(NEWHELP, mes^.betreff, void.cardinal) THEN
                     LogLine(NEWHELP);
                     DoNewHelp(mes);
                  ELSIF BeginsWith(DELETEHELP, mes^.betreff, void.cardinal) THEN
                     LogLine(DELETEHELP);
                     DoDeleteHelp(mes);
                  ELSIF BeginsWith(CHANGEHELP, mes^.betreff, void.cardinal) THEN
                     LogLine(CHANGEHELP);
                     DoChangeHelp(mes);
                  ELSIF BeginsWith(LISTHELP, mes^.betreff, void.cardinal) THEN
                     LogLine(LISTHELP);
                     DoListHelp(mes);
                  ELSIF BeginsWith(helpListCmd, mes^.betreff, void.cardinal) THEN
                     LogLine(helpListCmd);
                     DoListHelp(mes);
                  ELSIF FindHelp(mes^.betreff, help, helpfile) THEN
                     LogLine(mes^.betreff);
                     DoHelp(mes, help, helpfile);
                  ELSE
                     LogString("unbekanntes Kommando: ");
                     LogLine(mes^.betreff);
                     DoUnknownError(mes);
                  END;
               END;
            ELSE
               (* keine persnliche Nachricht *)
               IF mes^.gruppe[0]#0C THEN
                  LogString(" ' ffentliche Nachricht fr Gruppe ");
                  LogLine(mes^.gruppe);
               ELSE
                  LogLine(" ? Fehler: Weder Empfnger noch Gruppe angegeben");
               END;
            END;
            ClearMail(mes);
         END;
      ELSE
         (* SkipBlock; *)
      END;
   END;
   LogLine(" - Outfile gelesen");
END ReadOutfile;

PROCEDURE WriteInfile;
BEGIN
END WriteInfile;

PROCEDURE CheckCFVs;
VAR   i, j:    CARDINAL;
      file:    File;
      pos:     CARDINAL;
      copyTo:  ARRAY [0 .. 255] OF CHAR;
BEGIN
   i := 0;
   WHILE (i<MAXCFV) DO
      IF cfv[i].name[0]#0C THEN
         IF (cfv[i].state=csRunning) AND
            (DaysGone(date)>DaysGone(cfv[i].timeout)) THEN
            (* CFV abgelaufen - auswerten *)
            cfv[i].state := csEnded;
            (*
            (* Auswertung an den Initiator des CFV ... *)
            ClearMail(answer);
            Assign(cfv[i].replyTo, answer^.an);
            IF vCFO IN cfv[i].type THEN
               Assign('Ergebnis CFO: ', answer^.betreff);
            ELSE
               Assign('Ergebnis CFV: ', answer^.betreff);
            END;
            Append(answer^.betreff, cfv[i].name);
            Assign(PROGNAME, answer^.realname);
            Assign(cfv[i].mausid, answer^.mausrid);
            Assign(cfv[i].id, answer^.rid);
            InfileWriteHeader(answer, newID);
            InfileLn;
            IF vCFO IN cfv[i].type THEN
               WriteCfoResult(i);
            ELSE
               WriteCfvResult(i);
            END;
            InfileEndmail;
            *)
            (* ... und an die brigen Adressen *)
            Assign(cfv[i].copyTo, copyTo);
            IF copyTo[0]=0C THEN
               Assign(cfv[i].sender, copyTo);
            END;
            WHILE copyTo[0]#0C DO
               ClearMail(answer);
               IF UPos(',', copyTo, pos)<HIGH(copyTo) THEN
                  Copy(copyTo, 0, pos, answer^.an);
                  Delete(copyTo, 0, pos+1);
               ELSE
                  Assign(copyTo, answer^.an);
                  copyTo[0] := 0C;
               END;
               Trim(answer^.an);
               IF UPos('@', answer^.an, void.cardinal)>=HIGH(answer^.an) THEN
                  Assign(answer^.an, answer^.gruppe);
                  answer^.an[0] := 0C;
               END;
               IF vCFO IN cfv[i].type THEN
                  Assign('Auszhlung CFO: ', answer^.betreff);
               ELSE
                  Assign('Auszhlung CFV: ', answer^.betreff);
               END;
               Append(answer^.betreff, cfv[i].name);
               Assign(cfv[i].mausid, answer^.mausrid);
               Assign(cfv[i].id, answer^.rid);
               InfileWriteHeader(answer, newID);
               InfileLn;
               IF vCFO IN cfv[i].type THEN
                  WriteCfoResult(i);
               ELSE
                  WriteCfvResult(i);
               END;
               InfileEndmail;
            END;
            (* und noch eine Mail in die betreffende Gruppe ... *)
            ClearMail(answer);
            SetVAccess(i);
            Assign(cfv[i].replyTo, vReplyto);
            Assign(cfv[i].copyTo, vCopyto);
            DateToStr(date, DDMMYYYY, '.', vTimeout);
            Assign(cfv[i].gruppe, answer^.gruppe);
            Assign(PROGNAME, answer^.realname);
            Assign(cfv[i].mausid, answer^.mausrid);
            Assign(cfv[i].id, answer^.rid);
            IF vCFO IN cfv[i].type THEN
               Assign('CFO beendet: ', answer^.betreff);
               Append(answer^.betreff, cfv[i].name);
               DoAnswerForm(NIL, ENDANSWERcfo);
               LogString(" - CFO abgelaufen: ");
            ELSE
               Assign('CFV beendet: ', answer^.betreff);
               Append(answer^.betreff, cfv[i].name);
               DoAnswerForm(NIL, ENDANSWER);
               LogString(" - CFV abgelaufen: ");
            END;
            LogLine(cfv[i].name);
         END;
         IF (cfv[i].timeout.year # 9999) AND
            (DaysGone(date)>(DaysGone(cfv[i].timeout)+30L)) THEN
            (* CFV seit 30 Tagen beendet - lschen *)
            IF vCFO IN cfv[i].type THEN
               LogString(" - CFO 30 Tage abgelaufen; wird gelscht: ");
            ELSE
               LogString(" - CFV 30 Tage abgelaufen; wird gelscht: ");
            END;
            LogLine(cfv[i].name);
            Directories.Delete(cfv[i].textfile);
            Directories.Delete(cfv[i].votefile);
            j := i;
            WHILE j<(MAXCFV-1) DO
               cfv[j] := cfv[j+1];
               INC(j);
            END;
            cfv[MAXCFV-1].name[0] := 0C;
         END;
      END;
      INC(i);
   END;
END CheckCFVs;

PROCEDURE OpenFiles(): BOOLEAN;
VAR   result: BOOLEAN;
BEGIN
   result := FALSE;
   IF NOT Create(logfile, logFilename, aWrite, cAppend) THEN
      (* Fehler: Konnte Logfile nicht ffnen/anlegen *)
      InOut.WriteString(" * Konnte Logfile '");
      InOut.WriteString(logFilename);
      InOut.WriteLine("' nicht ffnen!");
   ELSE
      LogCopyright;
      IF NOT Open(datafile, dataFilename, aRW) THEN
         IF NOT Create(datafile, dataFilename, aRW, cNew) THEN
            (* Fehler: Konnte Datenfile nicht ffnen oder neu anlegen *)
            LogString(" * Konnte Datenfile '");
            LogString(dataFilename);
            LogLine("' nicht ffnen oder neu anlegen!");
         ELSE
            Close(datafile);
            result := TRUE;
         END;
      ELSE
         Close(datafile);
         result := TRUE;
      END;
      IF result THEN
         result := FALSE;
         IF NOT Open(outfile, outFilename, aRead) THEN
            (* Fehler: Outfile nicht gefunden *)
            LogString(" * Konnte Outfile '");
            LogString(outFilename);
            LogLine("' nicht ffnen!");
         ELSE
            IF NOT Create(infile, inFilename, aWrite, cClobber) THEN
               (* Fehler: Konnte Infile nicht erzeugen *)
               LogString(" * Konnte Ausgabe-Infile '");
               LogString(inFilename);
               LogLine("' nicht erzeugen!");
            ELSE
               result := TRUE;
            END;
         END;
      END;
   END;
   RETURN result;
END OpenFiles;

PROCEDURE CloseFiles;
BEGIN
   Close(infile);
   Close(outfile);
   LogString(" schliee Logfile ");
   LogTime;
   Close(logfile);
END CloseFiles;

PROCEDURE Main;
VAR   i: CARDINAL;
BEGIN
   InOut.WriteLine(" ... OpenFiles");
   IF NOT OpenFiles() THEN
      InOut.WriteLine(" * Programmabbruch");
      CloseFiles;
   ELSE
      InOut.WriteLine(" ... allocate global memory");
      mes := NewMail();
      answer := NewMail();
      void.boolean := Lists.Create(helpList, DisposeHelpRec, Lists.CopyEntry);
      void.boolean := Lists.Create(destList, DisposeDestRec, Lists.CopyEntry);
      IF voteFunctions THEN
         NEW(votes);
         NEW(index);
         FOR i := 0 TO MAXVOTE-1 DO
            votes^[i] := NIL;
         END;
      END;
      FOR i := 0 TO MAXCHEF-1 DO
         chefList[i].name := NIL;
      END;
      InOut.WriteLine(" ... ReadHelpfiles");
      ReadHelpfiles;
      InOut.WriteLine(" ... ReadChefs");
      ReadChefs;
      IF voteFunctions THEN
         InOut.WriteLine(" ... ReadDatafile");
         ReadDatafile;
         IF quiet THEN
            InOut.WriteLine(" ... quiet-mode: CheckCFVs skipped");
         ELSE
            InOut.WriteLine(" ... CheckCFVs");
            CheckCFVs;
         END;
      END;
      InOut.WriteLine(" ... ReadOutfile");
      ReadOutfile;
      InOut.WriteLine(" ... WriteInfile");
      WriteInfile;
      IF voteFunctions THEN
         InOut.WriteLine(" ... WriteDatafile");
         WriteDatafile;
      END;
      InOut.WriteLine(" ... WriteChefs");
      WriteChefs;
      DisposeChefs;
      InOut.WriteLine(" ... WriteHelpfiles");
      WriteHelpfiles;
      DisposeHelpfiles;
      InOut.WriteLine(" ... CloseFiles");
      CloseFiles;
      InOut.WriteLine(" ... free global memory");
      IF voteFunctions THEN
         DISPOSE(index);
         DISPOSE(votes);
      END;
      void.boolean := Lists.Delete(destList);
      void.boolean := Lists.Delete(helpList);
      DumpMail(answer);
      DumpMail(mes);
      InOut.WriteLine(" ... END Main");
   END;
END Main;

PROCEDURE Help;
BEGIN
   InOut.WriteLine(" syntax:  votedevi [/i<Infile>] [/o<Outfile>] [/c<Cfgfile>]");
   InOut.WriteLine("                   [/h]");
   InOut.WriteLn;
   InOut.WriteLine(' /i<Infile>:    wird von Vote Devil erzeugt');
   InOut.WriteLine(' /o<Outfile>:   wird ausgewertet');
   InOut.WriteLine(' /c<Cfgfile>:   zu benutzende Konfigurationsdatei');
   InOut.WriteLn;
   InOut.WriteLine(" /q:            keine automatischen Ausgaben machen");
   InOut.WriteLn;
   InOut.WriteLine(" /h:            dieser Hilfetext wird ausgegeben");
   InOut.WriteLn;
   InOut.WriteLine(" Beispiel:  votedevi /iinfile1.txt /ooutfile1.txt");
   InOut.WriteLn;
   help := TRUE;
END Help;

PROCEDURE ReadCommandline;
VAR   len:  CARDINAL;
      arg:  ARRAY [0 .. 127] OF CHAR;
BEGIN
   GetArg(arg, len);
   WHILE arg[0]#0C DO
      CASE arg[0] OF
         '-','/':
         CASE arg[1] OF
         | 'c','C':
            Delete(arg, 0, 1);
            Upper(arg);
            Delete(arg, 0, 1);
            Assign(arg, cfgFilename);
         | 'd','D':
            Delete(arg, 0, 1);
            Upper(arg);
            IF CompareStr(arg, 'DEBUG')=0 THEN
               debug := TRUE;
            END;
            IF CompareStr(arg, 'DEBUGCFG')=0 THEN
               ConfigFile.SetDebugging(TRUE);
            END;
         | 'h','H','?':
            Help;
         | 'i','I':
            Delete(arg, 0, 2);
            Assign(arg, inFilename);
         | 'l','L':
            Delete(arg, 0, 1);
            Upper(arg);
            IF CompareStr(arg, 'LOGTOSTDOUT')=0 THEN
               logToStdOut := TRUE;
            END;
         | 'o','O':
            Delete(arg, 0, 2);
            Assign(arg, outFilename);
         | 'q','Q':
            quiet := TRUE;
         | 'v','V':
            Delete(arg, 0, 1);
            Upper(arg);
            IF CompareStr(arg, 'VERSION')=0 THEN
               ModReg.ListAll;
               help := TRUE;
            END;
         ELSE
            InOut.WriteString('Falsches Argument: ');
            InOut.WriteLine(arg);
         END;
      ELSE
         InOut.WriteString('Falsches Argument: ');
         InOut.WriteLine(arg);
      END;
      GetArg(arg, len);
   END;
END ReadCommandline;

PROCEDURE Terminate;
BEGIN
   IF NOT legalExit THEN
      InOut.WriteLine(" * Fataler Fehler: Programm abgebrochen!");
      InOut.WriteLine("                   schliee geffnete Dateien");
      Close(infile);
      Close(outfile);
      LogString(" schliee Logfile ");
      LogTime;
      Close(logfile);
      (* falls noch andere Files offen sind: *)
      CloseAll;
   END;
END Terminate;

BEGIN
   ModReg.Register('VoteDevil', 0, 0, ' ', 1997, 08, 16, Terminate);

   legalExit := FALSE;
   InOut.WriteString(COPYRIGHT);
   GetDate(date);
   DateToStr(date, DDMMYYYY, '.', dateStr);
   InOut.WriteString(dateStr);
   InOut.WriteString("  ");
   GetTime(time);
   TimeToStr(time, H4MMSS, ':', dateStr);
   InOut.WriteLine(dateStr);
   Randomize(LONG(time.h)*3600L+LONG(time.m*60)+LONG(time.s)+
             LONG(date.year-1900)*31536000+LONG(date.month)*2529000+
             LONG(date.day)*86400);
   SetDefaults;
   ReadCommandline;
   IF NOT help THEN
      ReadConfig;
      Main;
      ConfigFile.Dispose;
   END;
   legalExit := TRUE;

END VoteDevil.
