IMPLEMENTATION MODULE VoteFiles;

(*
 * 19.12.1996  -  aus VoteGlobals ausgegliedert
 * 04.01.1997  -  Infozeile fr Helpfiles
 * 05.01.1997  -  Infozeile fr Standard-Hilfetext ergnzt
 *         /2  -  bei der Suche nach einem AL wird CompareAddresses benutzt
 * 11.01.1997  -  DeleteHelpfile funktioniert
 * 12.01.1997  -  nach SetHelpInfo wird das helpChanged-Flag gesetzt und
 *                somit das VOTEHELP.CFG garantiert zurckgeschrieben
 * 24.01.1997  -  ALs werden auch ber den Gastsysop-Eintrag im EXP gefunden
 * 09.03.1997  -  in WriteHeader F-Zeile schreiben
 * 29.03.1997  -  an neues DAT-Format angepat
 * 09.04.1997  -  Sysops knnen _generell_ fr AL-Aufgaben berechtigt
 *                werden - einfach 'Sysop' als AL eintragen
 * 16.04.1997  -  Access- und Hidden-Attribute fr Helpfiles
 * 17.04.1997  -  FindHelpfile durch FindHelp ersetzt 
 * 16.08.1997  -  wird an SetHelpInfo eine leere Infozeile bergeben,
 *                wird die Infozeile nicht gendert
 * 18.08.1997  -  bei Help.X.Hidden wird korrekt TRUE geschrieben,
 *                statt 'TRUE' (Boolean statt String)
 *)

FROM     SYSTEM            IMPORT   ADDRESS, ADR;
FROM     System            IMPORT   Terminate;
FROM     Storage           IMPORT   ALLOCATE, DEALLOCATE;
IMPORT   InOut;
FROM     Strings           IMPORT   Append, Insert, Delete, Pos, Copy,
                                    CompareStr, Length;
FROM     Strings1          IMPORT   Assign, Trim, Upper;
FROM     NumberConversion  IMPORT   CardToString;
IMPORT   FileIO;
FROM     FileIO            IMPORT   File, PathName, AccessMode,
                                    CreateMode, Open, Create, Close, EOF, Write,
                                    WriteString, WriteLn, WriteLine,
                                    WriteBytes, Read, ReadLine, ReadBytes,
                                    Flush, Seek, Seek0, SeekMode, State, NOFILE;
IMPORT   Directories;
FROM     TimeNDate         IMPORT   TimeFormat, DateFormat,
                                    GetTime, GetDate, TimeToStr, DateToStr;
IMPORT   Lists;
FROM     Lists             IMPORT   List;
IMPORT   ConfigFile;
FROM     MausLibrary       IMPORT   String127;
IMPORT   ModReg;
IMPORT   void;
FROM     VoteGlobals       IMPORT   TOPICCHARS, MAXCFV, MAXVOTE, GRPNAMELEN,
                                    BLOCKSIZE, LINELEN, MAXCHEF, MINTIMEOUT,
                                    STDTIMEOUT, COMMANDLEN, HELP, HELPANSWER,
                                    COPYRIGHT, HELPINFO, VDMAGIC, DATVERSION,
                                    SYSOP, HACCWORLD, HACCMAUSNET, HACCSYSOPS,
                                    HACCCHEF,
                                    Cfv, HelpRec, Message, ChefType,
                                    AccessType, PtrHelpRec,
                                    helpList, helpPath,
                                    dataFilename, chefFilename, cfg2Filename,
                                    datafile, infile, line, buffer, debug,
                                    date, time, dateStr, cfv, mes,
                                    votes, index, votehigh, newID,
                                    signature, maxMsgSize, verticalSplitting,
                                    chefList, allowLocalCFVs, allowListALs,
                                    allowPreview,
                                    vVote, vTimeout, vErrcause, vAccess,
                                    vReceived,
                                    vReplyto, vCopyto, vBetreff, vAddress,
                                    grpCFO,
                                    LogTime, LogCopyright, LogString, LogLine,
                                    StringToDate, EtoDateTime,
                                    IstZahler, IsLocal, NextLocalID,
                                    IsMausNet, IsSysop, BeginsWith, UPos,
                                    NewMail, ClearMail, DumpMail,
                                    ClearAnswer, SetVAccess, ReplaceWildcards,
                                    CompareNames, CompareAddresses;


MODULE Helpfiles;

   IMPORT   HelpRec, Assign, Lists, helpList, String127, HELP, HELPANSWER,
            HELPINFO, ConfigFile, cfg2Filename, BuildVarName, void, File,
            CompareNames, WriteString, WriteLine, CardToString, Create,
            LogString, LogLine, debug, AccessType, PtrHelpRec, Upper,
            AccessMode, CreateMode, ADDRESS, Pos, Insert, Directories,
            PathName, COMMANDLEN, ALLOCATE, DEALLOCATE, ADR, Close, helpPath;
   EXPORT   AddHelpfile, ReadHelpfiles, WriteHelpfiles, DisposeHelpfiles,
            DisposeHelpRec, FindHelp, DeleteHelpfile, SetHelpInfo;

   VAR   helpcount:     CARDINAL;
         helpChanged:   BOOLEAN;

   PROCEDURE AddHelpfile(str:       ARRAY OF CHAR;
                         filename:  ARRAY OF CHAR): BOOLEAN;
   VAR   result:  BOOLEAN;
         help:    POINTER TO HelpRec;
   BEGIN
      result := FALSE;
      NEW(help);
      IF help#NIL THEN
         Assign(str, help^.command);
         help^.info[0] := 0C;
         Assign(filename, help^.file);
         IF NOT Lists.AppendEntry(helpList, help) THEN
            DISPOSE(help);
         ELSE
            result := TRUE;
         END;
      END;
      helpChanged := result;
      RETURN result;
   END AddHelpfile;

   PROCEDURE SetHelpInfo(str:       ARRAY OF CHAR;
                         info:      ARRAY OF CHAR;
                         access:    AccessType;
                         hidden:    BOOLEAN): BOOLEAN;
   VAR   result:  BOOLEAN;
         help:    POINTER TO HelpRec;
   BEGIN
      result := FALSE;
      Lists.ResetCursor(helpList);
      help := Lists.SearchEntry(helpList, Lists.lForward, CondHelpCommand, ADR(str));
      IF help#NIL THEN
         IF info[0]#0C THEN
            Assign(info, help^.info);
         END;
         help^.access := access;
         help^.hidden := hidden;
         result := TRUE;
      END;
      helpChanged := result;
      RETURN result;
   END SetHelpInfo;

   PROCEDURE ReadHelpfiles;
   VAR   i:          CARDINAL;
         file:       PathName;
         command,
         name:       String127;
         info:       ARRAY [0 .. 1024] OF CHAR;
         done:       BOOLEAN;
         accessStr:  ARRAY [0 .. 7] OF CHAR;
         access:     AccessType;
         hidden:     BOOLEAN;
   BEGIN
      (* Standard-Hilfetext *)
      void.boolean := AddHelpfile(HELP, HELPANSWER);
      IF ConfigFile.Read(cfg2Filename) THEN
         done := FALSE;
         i := 1;
         REPEAT
            BuildVarName(name, 'Help.', '.Command', i);
            IF ConfigFile.GetString(name, '', command, void.boolean) THEN
               BuildVarName(name, 'Help.', '.File', i);
               IF ConfigFile.GetString(name, '', file, void.boolean) THEN
                  BuildVarName(name, 'Help.', '.Info', i);
                  void.boolean := ConfigFile.GetString(name, '', info, void.boolean);
                  access := aWorld;
                  BuildVarName(name, 'Help.', '.Access', i);
                  void.boolean := ConfigFile.GetString(name, '', accessStr, void.boolean);
                  Upper(accessStr);
                  CASE accessStr[0] OF
                  | 'W' (*HACCWORLD[0]*):      access := aWorld;
                  | 'M' (*HACCMAUSNET[0]*):    access := aMausNet;
                  | 'S' (*HACCSYSOP[0]*):      access := aSysop;
                  | 'C' (*HACCCHEF[0]*):       access := aChef;
                  ELSE
                  END;
                  hidden := FALSE;
                  BuildVarName(name, 'Help.', '.Hidden', i);
                  void.boolean := ConfigFile.GetBoolean(name, FALSE, hidden);
                  void.boolean := AddHelpfile(command, file);
                  void.boolean := SetHelpInfo(command, info, access, hidden);
               END;
            ELSE
               done := TRUE;
            END;
            INC(i);
         UNTIL done;
      END;
      (* Infozeile fr den Standard-Hilfetext *)
      void.boolean := ConfigFile.GetString('HelpInfo', HELPINFO, info, void.boolean);
      void.boolean := SetHelpInfo(HELP, info, aWorld, FALSE);
      helpChanged := FALSE;
   END ReadHelpfiles;

   PROCEDURE WriteHelpLine(entry, parm: ADDRESS);
   VAR   help: POINTER TO HelpRec;
         file: POINTER TO File;
         i:    CARDINAL;
         str:  ARRAY [0 .. 7] OF CHAR;
   BEGIN
      help := entry;
      file := parm;
      (* Standard-Hilfetext nicht ins CFG schreiben *)
      IF CompareNames(help^.command, HELP)#0 THEN
         INC(helpcount);
         WriteString(file^, 'Help.');
         CardToString(helpcount, str, 1);
         WriteString(file^, str);
         WriteString(file^, ".Command := '");
         WriteString(file^, help^.command);
         WriteLine(file^, "';");
         IF help^.info[0]#0C THEN
            WriteString(file^, 'Help.');
            WriteString(file^, str);
            WriteString(file^, ".Info    := '");
            WriteString(file^, help^.info);
            WriteLine(file^, "';");
         END;
         IF help^.access#aWorld THEN
            WriteString(file^, 'Help.');
            WriteString(file^, str);
            WriteString(file^, ".Access  := '");
            CASE help^.access OF
            | aWorld:   WriteString(file^, "World");   (* ? *)
            | aMausNet: WriteString(file^, "MausNet");
            | aSysop:   WriteString(file^, "Sysop");
            | aChef:    WriteString(file^, "Chef");
            ELSE
            END;
            WriteLine(file^, "';");
         END;
         IF help^.hidden THEN
            WriteString(file^, 'Help.');
            WriteString(file^, str);
            WriteString(file^, ".Hidden  := ");
            WriteLine(file^, "TRUE;");
         END;
         WriteString(file^, 'Help.');
         WriteString(file^, str);
         WriteString(file^, ".File    := '");
         WriteString(file^, help^.file);
         WriteLine(file^, "';");
      END;
   END WriteHelpLine;

   PROCEDURE WriteHelpfiles;
   VAR   file:       File;
         helpcount:  CARDINAL;

   BEGIN
      IF helpChanged THEN
         IF NOT Create(file, cfg2Filename, aWrite, cClobber) THEN
            (* Fehler: Konnte Helpfile nicht neu anlegen *)
            LogString(" * (WriteHelpfiles): Konnte Datei '");
            LogString(cfg2Filename);
            LogLine("' nicht neu anlegen!");
         ELSE
            helpcount := 0;
            Lists.ScanList(helpList, Lists.lForward, Lists.Ever, NIL,
                           WriteHelpLine, ADR(file));
            Close(file);
         END;
      END;
   END WriteHelpfiles;

   PROCEDURE DisposeHelpfiles;
   (* nicht notwendig - die Liste lschen reicht *)
   BEGIN
   END DisposeHelpfiles;

   PROCEDURE DisposeHelpRec(entry: ADDRESS);
   VAR   help: POINTER TO HelpRec;
   BEGIN
      help := entry;
      DISPOSE(help);
   END DisposeHelpRec;

   PROCEDURE CondHelpCommand(entry, parm: ADDRESS): BOOLEAN;
   VAR   result:  BOOLEAN;
         help:    POINTER TO HelpRec;
         str:     POINTER TO ARRAY [0 .. COMMANDLEN] OF CHAR;
   BEGIN
      help := entry;
      str := parm;
      result := (CompareNames(help^.command, str^)=0);
      RETURN result;
   END CondHelpCommand;

   PROCEDURE FindHelp(    str:        ARRAY OF CHAR;
                      VAR help:       PtrHelpRec;
                      VAR filename:   ARRAY OF CHAR): BOOLEAN;
   VAR   result:  BOOLEAN;
   BEGIN
      result := FALSE;
      Lists.ResetCursor(helpList);
      help := Lists.SearchEntry(helpList, Lists.lForward, CondHelpCommand, ADR(str));
      IF help#NIL THEN
         Assign(help^.file, filename);
         (* Pfad davorsetzen, falls ntig *)
         IF Pos('\', filename)>HIGH(filename) THEN
            Insert(helpPath, filename, 0);
         END;
         result := TRUE;
      END;
      RETURN result;
   END FindHelp;

   PROCEDURE DeleteHelpfile(VAR str: ARRAY OF CHAR): BOOLEAN;
   VAR   result:     BOOLEAN;
         help:       POINTER TO HelpRec;
         filename:   PathName;
   BEGIN
      result := FALSE;
      Lists.ResetCursor(helpList);
      help := Lists.SearchEntry(helpList, Lists.lForward, CondHelpCommand, ADR(str));
      IF help#NIL THEN
         IF debug THEN
            LogString(" ' (DeleteHelpfile): Hilfetext ");
            LogString(str);
            LogLine(" gefunden");
         END;
         IF CompareNames(help^.command, HELP)#0 THEN
            Assign(help^.file, filename);
            (* Pfad davorsetzen, falls ntig *)
            IF Pos('\', filename)>HIGH(filename) THEN
               Insert(helpPath, filename, 0);
            END;
            Directories.Delete(filename);
            IF debug THEN
               LogString(" ' (DeleteHelpfile): Textfile ");
               LogString(help^.file);
               LogLine(" gelscht");
            END;
            result := Lists.RemoveEntry(helpList);
            (* DISPOSE(help); macht RemoveEntry schon! *)
            IF debug THEN
               LogLine(" ' (DeleteHelpfile): Hilfe entfernt");
            END;
         END;
      END;
      helpChanged := result;
      RETURN result;
   END DeleteHelpfile;

END Helpfiles;

MODULE WriteToInfile;

   IMPORT   infile, COPYRIGHT, date, time, dateStr, GetDate, DateToStr,
            GetTime, TimeToStr, TimeFormat, DateFormat, Flush, Pos,
            WriteLn, WriteLine, WriteString, Write, debug, Open, Close,
            File, PathName, AccessMode, LINELEN, Assign, Delete, EOF,
            NextLocalID, NewMail, ReadLine, signature, LogString, LogLine,
            Message, Length, CardToString, Append, DumpMail, maxMsgSize,
            verticalSplitting;
   EXPORT   InfileWriteHeader, InfileLn, InfileString, InfileLine,
            InfileEndmail, InfileTerminate;

   VAR   message:    Message;
         partStr,
         partStr1:   ARRAY [0 .. 3] OF CHAR;
         id,
         lastID:     ARRAY [0 .. 31] OF CHAR;
         part:       CARDINAL;
         buffer,
         line:       ARRAY [0 .. LINELEN] OF CHAR;
         written:    LONGCARD;      (* bisherige Lnge der aktuellen Mail *)

   PROCEDURE WriteBuffer;
   BEGIN
      IF ((written+LONG(Length(buffer)+2))>LONGCARD(maxMsgSize)) THEN
         SplitMail
      END;
      WriteLine(infile, buffer);
      INC(written, Length(buffer)+2);
      IF debug THEN Flush(infile) END;
      buffer[0] := ':';
      buffer[1] := 0C;
   END WriteBuffer;

   PROCEDURE InfileWriteHeader(    mes:   Message;
                               VAR id:    ARRAY OF CHAR);
   BEGIN
      (* keine Temp-ID als R-ID zulassen *)
      IF Pos('@', mes^.mausrid)>=HIGH(mes^.mausrid) THEN
         mes^.mausrid[0] := 0C;
      END;
      part := 1;
      NextLocalID(id);
      WriteHeader(mes, id);
      message^ := mes^;    (* Inhalt sichern *)
      Assign(id, lastID);
      written := 0L;
   END InfileWriteHeader;

   PROCEDURE SplitMail;
   BEGIN
      INC(part);
      IF verticalSplitting THEN
         Assign(lastID, message^.mausrid);
      END;
      NextLocalID(id);
      WriteHeader(message, id);
      lastID := id;
      written := 0L;
   END SplitMail;

   PROCEDURE WriteHeader(    mes:   Message;
                         VAR id:    ARRAY OF CHAR);
   BEGIN
      CardToString(part, partStr, 1);
      CardToString(part-1, partStr1, 1);
      Write(infile, '#');
      WriteLine(infile, id);
      LogString(" > ");
      LogString(id);
      LogString(': ');
      IF mes^.gruppe[0]#0C THEN
         LogString(mes^.von);
         LogString(' in ');
         LogString(mes^.gruppe);
      ELSE
         LogString(mes^.von);
         LogString(' an ');
         LogString(mes^.an);
      END;
      LogLine("");
      IF mes^.mausrid[0]#0C THEN
         Write(infile, '-');
         WriteLine(infile, mes^.mausrid);
      END;
      IF mes^.id[0]#0C THEN
         Write(infile, 'I');
         WriteString(infile, mes^.id);
         IF part>1 THEN
            Write(infile, ':');
            WriteString(infile, partStr);
         END;
         WriteLn(infile);
      END;
      IF mes^.rid[0]#0C THEN
         IF (part=1) OR NOT verticalSplitting  THEN
            Write(infile, 'R');
            (*
            IF part>1 THEN
               WriteString(infile, mes^.rid);
               IF part>2 THEN
                  Write(infile, ':');
                  WriteString(infile, partStr1);
               END;
               WriteLn(infile);
            ELSE
            *)
            WriteLine(infile, mes^.rid);
         END;
      END;
      IF mes^.von[0]#0C THEN
         Write(infile, 'V');
         WriteLine(infile, mes^.von);
      END;
      IF mes^.an[0]#0C THEN
         Write(infile, 'A');
         WriteLine(infile, mes^.an);
      END;
      IF mes^.betreff[0]#0C THEN
         Write(infile, 'W');
         WriteString(infile, mes^.betreff);
         IF part>1 THEN
            WriteString(infile, ' (');
            WriteString(infile, partStr);
            Write(infile, ')');
         END;
         WriteLn(infile);
      END;
      IF mes^.followup[0]#0C THEN
         Write(infile, 'F');
         WriteLine(infile, mes^.followup);
      END;
      IF mes^.organisation[0]#0C THEN
         Write(infile, 'O');
         WriteLine(infile, mes^.organisation);
      END;
      IF mes^.datum[0]#0C THEN
         Write(infile, 'E');
         WriteLine(infile, mes^.datum);
      END;
      IF mes^.gruppe[0]#0C THEN
         Write(infile, 'G');
         WriteLine(infile, mes^.gruppe);
         Write(infile, 'D');
         WriteLine(infile, mes^.distribution);
      END;
   END WriteHeader;

   PROCEDURE InfileLn;
   BEGIN
      WriteBuffer;
   END InfileLn;

   PROCEDURE InfileString(str: ARRAY OF CHAR);
   BEGIN
      Append(buffer, str);
   END InfileString;

   PROCEDURE InfileLine(str: ARRAY OF CHAR);
   BEGIN
      Append(buffer, str);
      WriteBuffer;
   END InfileLine;

   PROCEDURE InfileEndmail;
   VAR   file:       File;
         filename:   PathName;
   BEGIN
      InfileLn;
      IF signature[0]#0C THEN
         IF signature[0]='@' THEN
            (* File einfgen *)
            Assign(signature, filename);
            Delete(filename, 0, 1);
            IF NOT Open(file, filename, aRead) THEN
               (* Fehler: Signature-File *)
               LogString(" * Konnte Datei fr Signature '");
               LogString(filename);
               LogLine("' nicht ffnen!");
            ELSE
               WHILE NOT EOF(file) DO
                  ReadLine(file, line);
                  InfileLine(line);
               END;
               Close(file);
            END;
         ELSE
            InfileLine(signature);
         END;
      END;
      InfileString(COPYRIGHT);
      GetDate(date);
      DateToStr(date, DDMMYYYY, '.', dateStr);
      InfileString(dateStr);
      InfileString("  ");
      GetTime(time);
      TimeToStr(time, H4MMSS, ':', dateStr);
      InfileLine(dateStr);
   END InfileEndmail;

   PROCEDURE InfileTerminate;
   BEGIN
      DumpMail(message);
   END InfileTerminate;

BEGIN
   written := 0L;
   buffer[0] := ':';
   buffer[1] := 0C;
   message := NewMail();
END WriteToInfile;


PROCEDURE WriteDatafile;
VAR   i:       CARDINAL;
      written: CARDINAL;
BEGIN
   IF NOT Create(datafile, dataFilename, aWrite, cClobber) THEN
      (* Fehler: Konnte Datenfile nicht zum Schreiben ffnen *)
      LogString(" * (WriteDatafile): Konnte Datenfile '");
      LogString(dataFilename);
      LogLine("' nicht schreiben!");
      InOut.WriteLine(" * Fataler Fehler: Konnte Datenfile nicht schreiben!");
   ELSE
      IF debug THEN
         LogString(" ' (WriteDatafile): Datenfile '");
         LogString(dataFilename);
         LogLine("' angelegt");
      END;
      (* Header scheiben *)
      WriteString(datafile, VDMAGIC);
      WriteString(datafile, DATVERSION);
      i := 0;
      WHILE (i<MAXCFV) DO
         IF (cfv[i].name[0]#0C) THEN
            WriteBytes(datafile, ADR(cfv[i]), SIZE(Cfv), written);
            IF written#SIZE(Cfv) THEN
               (* Fehler beim Schreiben! *)
               i := MAXCFV;
            END;
         END;
         INC(i);
      END;
      Close(datafile);
      IF debug THEN
         LogLine(" ' (WriteDatafile): Datei geschlossen");
      END;
   END;
END WriteDatafile;

PROCEDURE ReadDatafile;
VAR   i:    CARDINAL;
      read: CARDINAL;

   PROCEDURE CheckHeader(): BOOLEAN;
   VAR   result:  BOOLEAN;
         magic:   ARRAY [0 .. 3] OF CHAR;
         datHigh,
         datLow,
         vdHigh,
         vdLow:   CARDINAL;
   BEGIN
      result := FALSE;
      (* Header vorhanden? *)
      ReadBytes(datafile, ADR(magic), 4, void.cardinal);
      IF CompareStr(magic, VDMAGIC)=0 THEN
         ReadBytes(datafile, ADR(magic), 4, void.cardinal);
         datHigh := ORD(magic[0])*10+ORD(magic[1]);
         datLow := ORD(magic[2])*10+ORD(magic[3]);
         Assign(DATVERSION, magic);
         vdHigh := ORD(magic[0])*10+ORD(magic[1]);
         vdLow := ORD(magic[2])*10+ORD(magic[3]);
         IF datHigh=vdHigh THEN
            result := TRUE;
         END;
      END;
      RETURN result;
   END CheckHeader;

BEGIN
   IF NOT Open(datafile, dataFilename, aRW) THEN
      (* Fehler: Konnte Datenfile nicht ffnen *)
      LogString(" * (ReadDatafile): Konnte Datenfile '");
      LogString(dataFilename);
      LogLine("' nicht lesen!");
      InOut.WriteLine(" * Fataler Fehler: Konnte Datenfile nicht lesen!");
   ELSE
      IF debug THEN
         LogString(" ' (ReadDatafile): Datenfile '");
         LogString(dataFilename);
         LogLine("' geffnet");
      END;
      IF NOT CheckHeader() THEN
         (* Fehler: Datenfile hat falsches Format *)
         LogString(" * (ReadDatafile): Das Datenfile '");
         LogString(dataFilename);
         LogLine("' hat ein falsches Format!");
         InOut.WriteLine(" * Fataler Fehler: Datenfile hat falsches Format!");
         Terminate(128);
      ELSE
         i := 0;
         WHILE (i<MAXCFV) AND (NOT EOF(datafile)) DO
            ReadBytes(datafile, ADR(cfv[i]), SIZE(Cfv), read);
            IF read#SIZE(Cfv) THEN
               (* Fehler beim Lesen! *)
               i := MAXCFV
            ELSE
               (* temporrer Patch fr zu lange Schlssel: *)
               cfv[i].key[30] := 0C;
            END;
            INC(i);
         END;
      END;
      Close(datafile);
      IF debug THEN
         LogLine(" ' (ReadDatafile): Datei geschlossen");
      END;
   END;
END ReadDatafile;


PROCEDURE BuildVarName(VAR name:    ARRAY OF CHAR;
                           prefix,
                           suffix:  ARRAY OF CHAR;
                           num:     CARDINAL);
BEGIN
   CardToString(num, name, 1);
   Insert(prefix, name, 0);
   Append(name, suffix);
END BuildVarName;

PROCEDURE ReadChefs;
VAR   i, j:    CARDINAL;
      var,
      val:     ARRAY [0 .. 79] OF CHAR;
      file:    File;
BEGIN
   j := 0;
   FOR i := 0 TO MAXCHEF-1 DO
      BuildVarName(var, 'AL.', '.Name', i);
      IF ConfigFile.GetString(var, '', val, void.boolean) THEN
         NEW(chefList[j].name);
         Assign(val, chefList[j].name^);
         chefList[j].type := cHard;
         INC(j);
      END;
   END;
   IF Open(file, chefFilename, aRead) THEN
      WHILE (j<MAXCHEF) AND NOT EOF(file) DO
         ReadLine(file, line);
         CASE line[0] OF
         | '+':
            Delete(line, 0, 2);
            Trim(line);
            NEW(chefList[j].name);
            Assign(line, chefList[j].name^);
            chefList[j].type := cSoft;
            INC(j);
         | '1':
            Delete(line, 0, 2);
            Trim(line);
            NEW(chefList[j].name);
            Assign(line, chefList[j].name^);
            chefList[j].type := cOnce;
            INC(j);
         ELSE
         END;
      END;
      Close(file);
   END;
END ReadChefs;

PROCEDURE WriteChefs;
VAR   i:       CARDINAL;
      file:    File;
      isOpen:  BOOLEAN;
BEGIN
   Directories.Delete(chefFilename);
   isOpen := FALSE;
   FOR i := 0 TO MAXCHEF-1 DO
      IF (chefList[i].name#NIL) AND (chefList[i].type#cHard) THEN
         IF NOT isOpen THEN
            IF NOT Create(file, chefFilename, aWrite, cClobber) THEN
               (* Fehler: Konnte Cheffile nicht neu anlegen *)
               LogString(" * (WriteChefs): Konnte Cheffile '");
               LogString(chefFilename);
               LogLine("' nicht neu anlegen!");
            ELSE
               isOpen := TRUE;
            END;
         END;
         CASE chefList[i].type OF
         | cSoft:
            WriteString(file, '+:');
         | cOnce:
            WriteString(file, '1:');
         ELSE
            WriteString(file, '?:');
         END;
         WriteLine(file, chefList[i].name^);
      END;
   END;
   IF isOpen THEN
      Close(file);
   END;
END WriteChefs;

PROCEDURE DisposeChefs;
VAR   i: CARDINAL;
BEGIN
   FOR i := 0 TO MAXCHEF-1 DO
      IF chefList[i].name#NIL THEN
         DISPOSE(chefList[i].name);
      END;
   END;
END DisposeChefs;

PROCEDURE FindChef(    str: ARRAY OF CHAR;
                   VAR index: CARDINAL): BOOLEAN;
VAR   result:     BOOLEAN;
      pos,
      i:          CARDINAL;
      box,
      vonBox:     ARRAY [0 .. 7] OF CHAR;
      gastName:   ARRAY [0 .. 49] OF CHAR;
BEGIN
   result := FALSE;
   gastName[0] := 0C;
   IF IsSysop(str, FALSE, box) THEN
      pos := Pos("@", str);
      Copy(str, pos+1, 8, vonBox);
      Trim(vonBox);     (* Box, von der aus geschrieben wurde *)
      IF CompareStr(box, vonBox)#0 THEN
         Copy(str, 0, pos, gastName);
         Trim(gastName);
         Append(gastName, ' @ ');
         Append(gastName, box);
      END;
   END;
   i := 0;
   WHILE (NOT result) AND (i<MAXCHEF) DO
      IF chefList[i].name#NIL THEN
         IF (CompareAddresses(str, chefList[i].name^)=0) OR
            (CompareAddresses(gastName, chefList[i].name^)=0) THEN
            index := i;
            result := TRUE;
         END;
      END;
      INC(i);
   END;
   (* Falls 'SYSOP' als Chef eingetragen ist, gelten _alle_ Sysops als Chef *)
   IF NOT result AND IsSysop(str, FALSE, box) THEN
      i := 0;
      WHILE (NOT result) AND (i<MAXCHEF) DO
         IF chefList[i].name#NIL THEN
            IF (CompareAddresses(SYSOP, chefList[i].name^)=0) THEN
               index := i;
               result := TRUE;
            END;
         END;
         INC(i);
      END;
   END;
   RETURN result;
END FindChef;

PROCEDURE DeleteChef(index: CARDINAL);
BEGIN
   IF chefList[index].name#NIL THEN
      DISPOSE(chefList[index].name);
      WHILE index<(MAXCHEF-1) DO
         chefList[index] := chefList[index+1];
         INC(index);
      END;
      chefList[index].name := NIL;
   END;
END DeleteChef;

PROCEDURE AddChef(name: ARRAY OF CHAR;
                  type: ChefType): BOOLEAN;
VAR   result:  BOOLEAN;
      i:       CARDINAL;
BEGIN
   result := FALSE;
   i := 0;
   WHILE NOT result AND (i<MAXCHEF) DO
      IF chefList[i].name=NIL THEN
         NEW(chefList[i].name);
         Assign(name, chefList[i].name^);
         chefList[i].type := type;
         result := TRUE;
      END;
      INC(i);
   END;
   RETURN result;
END AddChef;

PROCEDURE TerminateProc;
BEGIN
   InfileTerminate;
END TerminateProc;


BEGIN
   ModReg.Register('VoteFiles',0,0,' ',1997,08,18, TerminateProc);


END VoteFiles.
