IMPLEMENTATION MODULE VoteFunctions;

(*
 * 07.10.1996  -  aus VoteDevil ausgelagert
 * 11.10.1996  -  extra Formular fr 'CFV nicht gefunden'
 * 16.10.1996  -  benutzt ModReg.Register
 *         /2  -  DoTimeCfv implementiert
 * 17.10.1996  -  bei verschiedenen Antworten fehlte die Verkettung
 * 18.10.1996  -  DoChangeCfv implementiert
 * 20.10.1996  -  benutze UPos statt Pos
 *             -  ffentliche Kommentare zu einem CFV werden mit dem Aufruf
 *                verkettet
 * 26.10.1996  -  Bugfix in DoTimeCfv: Fehler bei Datumsvergleich
 * 27.10.1996  -  beim Einlesen des Schlssels auf maximal 32 Zeichen krzen
 *             -  Abstimmungsberechtigung und Datum werden nicht mehr aus der
 *                'Neuer CFV:'-Mail bernommen, sondern vom Programm in den
 *                CFV-Text geschrieben
 * 28.10.1996  -  'Reply to' durch 'Rckfragen an' ersetzt
 *             -  'Auswertung an' ergnzt
 * 29.10.1996  -  Schlssel darf jetzt maximal 30 Zeichen lang sein -
 *                damit mte auch das Vergleichen immer klappen
 * 31.10.1996  -  vor dem Krzen mssen natrlich die fhrenden Leerzeichen
 *                entfernt werden ...
 * 06.11.1996  -  VoteCfvFunctions aus VoteFunctions ausgegliedert
 *             -  DoHelp fr freie Hilfetexte erweitert
 * 11.11.1996  -  lokale Sysops knnen ALs hinzufgen oder lschen
 * 26.11.1996  -  CFOs werden untersttzt
 * 02.12.1996  -  Pfade fr Hilfetexte und Templates ergnzt
 * 04.12.1996  -  Kommando und Textzeile fr Hilfe-Liste konfigurierbar
 * 07.12.1996  -  beim Zustellen von Hilfetexten Maillimit beachten
 * 19.12.1996  -  Teile aus VoteGlobals bernommen
 * 21.12.1996  -  ReadHeader.ReadLog berarbeitet
 * 04.01.1997  -  Infozeile fr Helpfiles
 * 05.01.1997  -  Leerzeilen zwischen den einzelnen Helpfiles in der Liste
 *         /2  -  Adresse von ALs normalisieren, bevor sie in die Liste
 *                eingetragen oder daraus gelscht werden werden
 * 06.01.1997  -  und noch ein Bugfix in ReadHeader.ReadLog ...
 * 11.01.1997  -  in DoNewHelp und DoChangeHelp info initialisieren
 * 12.01.1997  -  ein paar Debugausgaben ergnzt
 * 19.01.1997  -  bei 'ndere Hilfe:' knnen Kurzinfo und Hilfetext
 *                unabhngig voneinander gendert werden - was nicht
 *                verndert werden soll, einfach nicht angeben
 *             -  Legende fr die Hilfe Liste
 * 23.01.1997  -  bei '?'-Zeilen im Log wurde das erste Zeichen des
 *                Textes abgeschnitten
 * 28.01.1997  -  Bugfix in DoNewAL: Einmal-ALs wurden nicht erkannt
 *             -  ReadXSubject ergnzt; wird von ReadHeader automatisch
 *                aufgerufen
 * 09.03.1997  -  ReadHead ergnzt
 * 26.03.1997  -  In ReadHead myName und ggf. followupTo setzen
 *             -  ReadXSubject und ReadHead korrigiert
 * 29.03.1997  -  an neues DAT-Format angepat
 * 17.04.1997  -  DoHelp und DoListHelp an Access- und Hidden-Attribute
 *                angepat
 * 16.06.1997  -  in DoListAll werden CFOs explizit als solche aufgefhrt
 * 21.06.1997  -  Bugfix: abgegebene Stimmen wurden falsch sortiert
 * 03.08.1997  -  Bugfix: war doch richtig sortiert - rckgngig gemacht
 * 16.08.1997  -  in DoNewHelp und DoChangeHelp knnen jetzt auch die
 *                Access- und Hidden-Attribute gesetzt werden
 * 18.08.1997  -  beim Anlegen bzw. ndern eines Hilfetextes *mu* der Text
 *                jetzt innerhalb des #TEXT-Blocks liegen
 *             -  Blockbezeichner sind jetzt nicht mehr casesensitiv
 *             -  bei DoChangeHelp wird das Tempfile im helpPath angelegt
 *)


FROM     SYSTEM            IMPORT   ADDRESS, ADR, BYTE, FLAT, PTR;
FROM     System            IMPORT   GetArg;
FROM     Storage           IMPORT   ALLOCATE, DEALLOCATE;
IMPORT   InOut;
FROM     ASCII             IMPORT   CR, LF;
FROM     Strings           IMPORT   Append, Insert, Delete, Copy, Pos, Length,
                                    CompareStr;
FROM     Strings1          IMPORT   Assign, Replace, Trim, Upper, Lower,
                                    P2MString, CorrectPath, Fill, ConvUmlaute,
                                    RemoveLeadingSpaces, RemoveTrailingSpaces;
FROM     NumberConversion  IMPORT   CardToString, StringToCard,
                                    LongCardToString;
FROM     RealConversions   IMPORT   RealToString;
IMPORT   FileIO;
FROM     FileIO            IMPORT   File, FileName, PathName, AccessMode,
                                    CreateMode, Open, Create, Close, EOF,
                                    Write, WriteString, WriteLn, WriteLine,
                                    CreateTmp, WriteBytes, Read, ReadLine,
                                    ReadBytes, Seek, Seek0, SeekMode, State,
                                    NOFILE;
IMPORT   Directories;
FROM     TimeNDate         IMPORT   Time, Date, TimeFormat, DateFormat,
                                    GetTime, GetDate, TimeToStr, DateToStr;
FROM     CDate             IMPORT   DaysGone, Legal;
FROM     RandomGen         IMPORT   Randomize, RandomCard;
IMPORT   Quicksort;
IMPORT   Lists;
FROM     Lists             IMPORT   List;
IMPORT   ConfigFile;
FROM     MausLibrary       IMPORT   TBenutzerprofil, TPromiState, GruppenStr,
                                    MausName, Boolean, String127, String255;
IMPORT   ModReg;
IMPORT   void;

FROM     VoteGlobals       IMPORT   MAXTOPIC, MAXCFV, MAXVOTE, LINELEN,
                                    MAXCHEF, CFGFILE, UNKANSWER, NIANSWER,
                                    NOALANSWER, EXCEEDANSWER, HELP, NEWHELP,
                                    DELETEHELP, CHANGEHELP, ONCEAL, KEY,
                                    TIMEOUT, GRUPPE, REPLYTO, VTYPE, TOMOV,
                                    TPERSON, VOTES, COPYTO, ACCESSSTR,
                                    ACCALLSTR, ACCMAUSNETSTR, ACCLOCALSTR,
                                    ACCSYSOPSTR, ACCBETREIBERSTR,
                                    NOSUBJECT, XSUBJECT,
                                    HACCWORLD, HACCMAUSNET, HACCSYSOPS,
                                    HACCCHEF, HACCESS, HHIDDEN,
                                    VoteType, VoteTypeSet, VoteAccess,
                                    CFVState, AccessType, PtrHelpRec,
                                    Message, HelpRec, DestRec, ChefType,
                                    helpPath, templatePath, tmpFilename,
                                    tmp2Filename, tmpPath, outfile, line,
                                    buffer, debug, date, time, cfv, cfvResult,
                                    mes, answer, lastpos, votes, index,
                                    votehigh, newID, chefList, destList,
                                    allowListALs, helpList, helpListText,
                                    helpListLegend, mailLimitLocal, mausResult,
                                    mailLimitMausNet, mailLimitNet,
                                    followupTo, myName, followupToPoster,
                                    LogString, LogLine, StringToDate,
                                    StringToTime, IsLocal, IsLocalSysop,
                                    IsMausNet, IsSysop, BeginsWith,
                                    ClearAnswer, ReplaceWildcards,
                                    CompareNames, NormalizeAddress, UPos;
FROM     VoteFiles         IMPORT   InfileLn, InfileString, InfileLine,
                                    InfileEndmail, InfileWriteHeader, ReadChefs,
                                    WriteChefs, DisposeChefs, FindChef,
                                    AddChef, DeleteChef, FindHelp,
                                    AddHelpfile, DeleteHelpfile, SetHelpInfo;

TYPE     HelpBlockType     =  (hbText, hbInfo, hbFlags);


PROCEDURE ReadXSubject(VAR mes: Message): BOOLEAN;
VAR   result:  BOOLEAN;
      loop:    BOOLEAN;
      textpos: LONGCARD;
      pos:     CARDINAL;
BEGIN
   result := FALSE;
   textpos := Seek(outfile, sBegin, lastpos);
   REPEAT
      loop := FALSE;
      ReadLine(outfile, buffer);
      IF buffer[0]=':' THEN
         loop := TRUE;
         Delete(buffer, 0, 1);
         Trim(buffer);
         IF BeginsWith(XSUBJECT, buffer, pos) THEN
            Delete(buffer, pos, Length(XSUBJECT));
            Trim(buffer);
            void.boolean := Replace(mes^.betreff, NOSUBJECT, buffer);
            result := TRUE;
         END;
      END;
   UNTIL result OR NOT loop OR EOF(outfile);
   lastpos := Seek(outfile, sBegin, textpos);
   RETURN result;
END ReadXSubject;

PROCEDURE ReadHeader(VAR mes: Message): BOOLEAN;
VAR   result:  BOOLEAN;
      done:    BOOLEAN;
      i,
      this,
      pos:     CARDINAL;
      tempID:  ARRAY [0 .. 31] OF CHAR;

   PROCEDURE ReadLog(): BOOLEAN;
   VAR   result:  BOOLEAN;
   BEGIN
      result := TRUE;
      lastpos := Seek0(outfile);
      ReadLine(outfile, buffer);
      WHILE (buffer[0]=':') AND NOT EOF(outfile) DO
         Delete(buffer, 0, 1);
         IF buffer[0]='#' THEN
            pos := Pos('@', buffer);
            IF pos>=HIGH(buffer) THEN
               (* temporre ID ersetzen *)
               Assign(buffer, tempID);
               Delete(buffer, 0, 1);
               this := MAXCFV;
               FOR i := 0 TO MAXCFV-1 DO
                  IF (cfv[i].name[0]#0C) AND (cfv[i].mausid[0]#0C) THEN
                     IF CompareStr(cfv[i].mausid, buffer)=0 THEN
                        this := i;
                     END;
                  END;
               END;
               REPEAT
                  lastpos := Seek0(outfile);
                  ReadLine(outfile, buffer);
                  IF buffer[0]=':' THEN
                     IF buffer[1]='=' THEN
                        Delete(buffer, 0, 2);
                        LogString(" : ");
                        LogString(tempID);
                        LogString(" = ");
                        LogLine(buffer);
                        IF this<MAXCFV THEN
                           Assign(buffer, cfv[this].mausid);
                        END;
                     ELSIF (buffer[1]='!') AND (buffer[2]='=') THEN
                        Delete(buffer, 0, 3);
                        LogString(" : ");
                        LogString(tempID);
                        LogString(" != ");
                        LogLine(buffer);
                        IF this<MAXCFV THEN
                           Assign(buffer, cfv[this].id);
                        END;
                     ELSIF buffer[1]='?' THEN
                        Delete(buffer, 0, 2);
                        LogString(" : ");
                        LogString(tempID);
                        LogString(" ? ");
                        LogLine(buffer);
                        (*
                        ErrorString(" Die MAUS hat die Nachricht ");
                        ErrorString(tempID);
                        ErrorLine(" abgewiesen!");
                        ErrorString("Begrndung: ");
                        ErrorLine(buffer);
                        *)
                        result := FALSE;
                     END;
                     buffer[0] := ':';
                  END;
               UNTIL (buffer[0]#':') OR (buffer[1]='#') OR EOF(outfile);
            END;
         END;
         (* das hier ist berflssig, wimni ...
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         *)
      END;
      RETURN result;
   END ReadLog;

   PROCEDURE ReadHead(): BOOLEAN;
   VAR   result:  BOOLEAN;
         uName,
         bName:   BOOLEAN;
         address: ARRAY [0 .. 255] OF CHAR;
   BEGIN
      result := FALSE;
      uName := FALSE;
      bName := FALSE;
      Assign(' @ ', address);
      lastpos := Seek0(outfile);
      ReadLine(outfile, buffer);
      WHILE (buffer[0]=':') AND NOT EOF(outfile) DO
         Delete(buffer, 0, 1);
         IF buffer[0]='U' THEN         (* Username *)
            Delete(buffer, 0, 1);
            Insert(buffer, address, 0);
            uName := TRUE;
         ELSIF buffer[0]='I' THEN      (* Boxname  *)
            Delete(buffer, 0, 1);
            Append(address, buffer);
            bName := TRUE;
         ELSE
         END;
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
      END;
      lastpos := Seek(outfile, sBegin, lastpos);
      IF uName AND bName THEN
         Assign(address, myName);
         IF NOT(followupToPoster) THEN
            Assign(address, followupTo);
         END;
         result := TRUE;
      END;
      RETURN result;
   END ReadHead;

BEGIN
   result := FALSE;
   (* Block-ID suchen *)
   lastpos := Seek(outfile, sBegin, lastpos);
   REPEAT
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
      UNTIL (buffer[0]='#') OR EOF(outfile);
      pos := Pos('@', buffer);
      IF pos>=HIGH(buffer) THEN
         IF CompareStr('#LOG', buffer)=0 THEN
            IF NOT ReadLog() THEN

            END;
         ELSIF CompareStr('#HEAD', buffer)=0 THEN
            IF NOT ReadHead() THEN

            END;
         END;
      END;
   UNTIL (pos<HIGH(buffer)) OR EOF(outfile);
   IF NOT(EOF(outfile)) THEN
      Copy(buffer, 1, Length(buffer)-1, mes^.mausid);
      done := FALSE;
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         CASE buffer[0] OF
         | '-':   (* MAUS-R-Id      *)
            Copy(buffer, 1, Length(buffer)-1, mes^.mausrid);
         | 'I':   (* lange Id   *)
            Copy(buffer, 1, Length(buffer)-1, mes^.id);
         | 'R':   (* lange R-Id *)
            Copy(buffer, 1, Length(buffer)-1, mes^.rid);
         | 'E':   (* Datum          *)
            Copy(buffer, 1, Length(buffer)-1, mes^.datum);
         | 'V':   (* Absender       *)
            Copy(buffer, 1, Length(buffer)-1, mes^.von);
         | 'A':   (* Empfnger      *)
            Copy(buffer, 1, Length(buffer)-1, mes^.an);
         | 'G':   (* Gruppe         *)
            Copy(buffer, 1, Length(buffer)-1, mes^.gruppe);
         | 'W':   (* Betreff        *)
            Copy(buffer, 1, Length(buffer)-1, mes^.betreff);
         | 'O':   (* Organisation   *)
            Copy(buffer, 1, Length(buffer)-1, mes^.organisation);
         | 'N':   (* Realname       *)
            Copy(buffer, 1, Length(buffer)-1, mes^.realname);
         | ':':   (* Textzeile      *)
            result := TRUE;
            done := TRUE;
         | '#':   (* nchster Block *)
            done := TRUE;
         ELSE
            (* unbekannte Zeilen-ID - ignorieren *)
         END; (* CASE *)
      UNTIL done OR EOF(outfile);
      (* Betreff ggf. aus dem Mailtext lesen *)
      IF NOT EOF(outfile) THEN
         Assign(mes^.betreff, buffer);
         IF UPos(NOSUBJECT, buffer, pos)<HIGH(buffer) THEN
            void.boolean := ReadXSubject(mes);
         END;
      END;
   END;
   RETURN result;
END ReadHeader;

PROCEDURE ClearVotes;
VAR   i: CARDINAL;
BEGIN
   FOR i := 0 TO MAXVOTE-1 DO
      index^[i] := i;
   END;
   cfvResult.votes := 0;
   cfvResult.illegal := 0;
   FOR i := 0 TO 25 DO
      cfvResult.vGruppe[i] := 0.0;
   END;
   FOR i := 0 TO 25 DO
      mausResult.vGruppe[i] := 0.0;
   END;
END ClearVotes;

PROCEDURE ReadVotes(this: CARDINAL);
VAR   file:    File;
      i:       CARDINAL;
      boxPos,
      pos:     CARDINAL;
      str:     ARRAY [0 .. 8] OF CHAR;
      getBox:  BOOLEAN;
BEGIN
   IF NOT Open(file, cfv[this].votefile, aRead) THEN
      (* Votefile konnte nicht geffnet werden *)
      LogString(" * (ReadVotes): Konnte Votefile '");
      LogString(cfv[this].votefile);
      LogLine("' nicht ffnen!");
   ELSE
      IF debug THEN
         LogString(" ' (ReadVotes): Votefile '");
         LogString(cfv[this].votefile);
         LogLine("' geffnet");
      END;
      getBox := ((cfv[this].access=vSysop) OR (cfv[this].access=vBetreiber));
      votehigh := 0;
      i := 0;
      WHILE (i<MAXVOTE) AND NOT EOF(file) DO
         ReadLine(file, line);
         IF NOT StringToDate(line, '.', date) THEN
            LogLine(" * (ReadVotes): fehlerhaftes Datum in Votefile!");
         ELSE
            pos := Pos(' ', line);
            IF pos<HIGH(line) THEN
               Delete(line, 0, pos+1);
               IF NOT StringToTime(line, ':', time) THEN
                  LogLine(" * (ReadVotes): fehlerhafte Uhrzeit in Votefile!");
                  time.s := 0;
                  time.m := 0;
                  time.h := 0;
               END;
            END;
            pos := Pos('|', line);
            IF NOT (pos<HIGH(line)) THEN
               (* Fehler *)
               IF debug THEN
                  InOut.WriteLine(" * (ReadVotes): erster Trennstrich fehlt!");
               END;
            ELSE
               Delete(line, 0, pos+1);
               pos := Pos('|', line);
               IF NOT (pos<HIGH(line)) THEN
                  (* Fehler *)
                  IF debug THEN
                     InOut.WriteLine(" * (ReadVotes): zweiter Trennstrich fehlt!");
                  END;
               ELSE
                  NEW(votes^[i]);
                  boxPos := Pos(':', line);  (* Box-Kennung bei Sysop-Abstimmungen *)
                  IF (boxPos<HIGH(line)) THEN
                     Copy(line, 0, boxPos, votes^[i]^.box);
                     Trim(votes^[i]^.box);
                     Delete(line, 0, boxPos+1);
                     DEC(pos, boxPos+1);
                  ELSE
                     votes^[i]^.box[0] := 0C;
                  END;
                  votes^[i]^.date := DaysGone(date);
                  votes^[i]^.time := LONG(time.h*3600)+LONG(time.m*60)+LONG(time.s);
                  IF votes^[i]=NIL THEN
                     (* Out Of Memory *)
                     LogLine(" * (ReadVotes): out of memory!");
                  ELSE
                     Copy(line, 0, pos, votes^[i]^.sender);
                     Trim(votes^[i]^.sender);
                     Delete(line, 0, pos+1);
                     Assign(line, votes^[i]^.vote);
                     Trim(votes^[i]^.vote);
                     IF getBox AND (votes^[i]^.box[0]=0C) THEN
                        void.boolean := IsSysop(votes^[i]^.sender, FALSE,
                                                votes^[i]^.box);
                     END;
                     (* debug
                     IF debug THEN
                        LogString(" ' (ReadVotes): Stimme ");
                        CardToString(i, str, 1);
                        LogString(str);
                        LogLine(" gelesen");
                     END;
                        debug *)
                     INC(i);
                     INC(votehigh);
                  END;
               END;
            END;
         END;
      END;
      Close(file);
      IF debug THEN
         LogString(" ' (ReadVotes): insgesamt ");
         CardToString(votehigh, str, 1);
         LogString(str);
         LogLine(" Stimmen gelesen");
         LogLine(" ' (ReadVotes): Datei geschlossen");
      END;
   END;
END ReadVotes;

PROCEDURE CompareVotes(address:  ADDRESS;
                       index1,
                       index2:   CARDINAL): BOOLEAN;
VAR   result:  BOOLEAN;
      comp:    INTEGER;
      str:     ARRAY [0 .. 8] OF CHAR;
BEGIN
   result := FALSE;
   IF votes^[index1]=NIL THEN
      IF debug THEN
         InOut.WriteLine(" ' votes^[index1]=NIL");
      END;
   ELSE
      IF votes^[index2]=NIL THEN
         IF debug THEN
            InOut.WriteLine(" ' votes^[index2]=NIL");
         END;
         result := TRUE;
      ELSE
         comp := CompareNames(votes^[index1]^.sender, votes^[index2]^.sender);
         IF comp=0 THEN
            (* Datum und Uhrzeit rckwrts sortieren - letzte Stimme zuerst *)
            IF (votes^[index1]^.date#votes^[index2]^.date) THEN
               result := (votes^[index1]^.date>votes^[index2]^.date);
            ELSE
               IF (votes^[index1]^.time#votes^[index2]^.time) THEN
                  result := (votes^[index1]^.time>votes^[index2]^.time);
               ELSE
                  result := (index1>index2);
               END;
            END;
         ELSIF comp<0 THEN
            result := TRUE;
         END;
      END;
   END;
   RETURN result;
END CompareVotes;

PROCEDURE CompareVotesOMOV(address:  ADDRESS;
                           index1,
                           index2:   CARDINAL): BOOLEAN;
VAR   result:  BOOLEAN;
      comp:    INTEGER;
      str:     ARRAY [0 .. 8] OF CHAR;
BEGIN
   result := FALSE;
   IF votes^[index1]=NIL THEN
      IF debug THEN
         InOut.WriteLine(" ' votes^[index1]=NIL");
      END;
   ELSE
      IF votes^[index2]=NIL THEN
         IF debug THEN
            InOut.WriteLine(" ' votes^[index2]=NIL");
         END;
         result := TRUE;
      ELSE
         comp := CompareStr(votes^[index1]^.box, votes^[index2]^.box);
         IF comp=0 THEN
            comp := CompareNames(votes^[index1]^.sender, votes^[index2]^.sender);
            IF comp=0 THEN
               (* Datum und Uhrzeit rckwrts sortieren - letzte Stimme zuerst *)
               IF (votes^[index1]^.date#votes^[index2]^.date) THEN
                  result := (votes^[index1]^.date>votes^[index2]^.date);
               ELSE
                  IF (votes^[index1]^.time#votes^[index2]^.time) THEN
                     result := (votes^[index1]^.time>votes^[index2]^.time);
                  ELSE
                     result := (index1>index2);
                  END;
               END;
            ELSIF comp<0 THEN
               result := TRUE;
            END;
         ELSIF comp<0 THEN
            result := TRUE;
         END;
      END;
   END;
   RETURN result;
END CompareVotesOMOV;

PROCEDURE SortVotes(omov: BOOLEAN);
(* debug *)
VAR   str:  ARRAY [0 .. 8] OF CHAR;
      i:    CARDINAL;
(* debug *)
BEGIN
   IF votehigh>0 THEN
      IF omov THEN
         Quicksort.Sort(NIL, index^, 0, votehigh-1, CompareVotesOMOV);
      ELSE
         Quicksort.Sort(NIL, index^, 0, votehigh-1, CompareVotes);
      END;
      (* debug *)
      FOR i := 0 TO votehigh-1 DO
         IF debug THEN
            LongCardToString(votes^[index^[i]]^.date, str, 7);
            LogString(str);
            LogString(" ");
            LongCardToString(votes^[index^[i]]^.time, str, 7);
            LogString(str);
            LogString(" - ");
            LogLine(votes^[index^[i]]^.sender);
         END;
      END;
      (* debug *)
   END;
END SortVotes;

PROCEDURE CountVotes(this: CARDINAL);
VAR   votefile,
      omovfile:   File;
      i, j:       CARDINAL;
      pos:        CARDINAL;
      outLine:    ARRAY [0 .. LINELEN] OF CHAR;
      buffer:     ARRAY [0 .. 3] OF CHAR;
      name1,
      name2:      String127;
      omov:       BOOLEAN;
      str,
      box:        ARRAY [0 .. 7] OF CHAR;

   PROCEDURE CountMaus;
   (* Endergebnis fr aktuelle Box errechnen und auswerten *)
   BEGIN
      IF box[0]#0C THEN
         WriteString(omovfile, " --- ");
         WriteString(omovfile, box);
         WriteLine(omovfile, " --- ");
         j := 0;
         WHILE (j<MAXTOPIC) AND (cfv[this].vote[j].short[0]#0C) DO
            (* Summe fr einen Punkt durch Anzahl der abgegebenen
               Stimmen fr den entsprechenden Block dividieren *)
            IF mausResult.vGruppe[ORD(cfv[this].vote[j].short[0])-ORD('A')]#0.0 THEN
               mausResult.vote[j].count := mausResult.vote[j].count/mausResult.vGruppe[ORD(cfv[this].vote[j].short[0])-ORD('A')];
               (* Ergebnis fr diesen Punkt zum Gesamtergebnis addieren *)
               cfv[this].vote[j].count := cfv[this].vote[j].count+mausResult.vote[j].count;
               cfvResult.vGruppe[ORD(cfv[this].vote[j].short[0])-ORD('A')] :=
                  cfvResult.vGruppe[ORD(cfv[this].vote[j].short[0])-ORD('A')]
                  +mausResult.vote[j].count;
            END;
            (* Nullwerte nicht ausgeben *)
            IF mausResult.vote[j].count#0.0 THEN
               (* Ergebnis in Temp-File ausgeben *)
               Assign(cfv[this].vote[j].short, outLine);
               Fill(outLine, 10, ' ');
               RealToString(mausResult.vote[j].count, 2, 5, str, void.boolean);
               Append(outLine, str);
               WriteLine(omovfile, outLine);
            END;
            (* Summe fr nchste MAUS auf Null setzen *)
            mausResult.vote[j].count := 0.0;
            INC(j);
         END;
         FOR j := 0 TO 25 DO
            mausResult.vGruppe[j] := 0.0;
         END;
      END;
   END CountMaus;

   PROCEDURE CountVote;
   BEGIN
      (* in temporres File schreiben *)
      IF omov THEN
         Assign(votes^[index^[i]]^.box, outLine);
         Append(outLine, ': ');
         Fill(outLine, 10, ' ');
      ELSE
         outLine[0] := 0C;
      END;
      Append(outLine, votes^[index^[i]]^.sender);
      Fill(outLine, 50, ' ');
      WriteString(votefile, outLine);
      WriteLine(votefile, votes^[index^[i]]^.vote);
      (* zhlen *)
      INC(cfvResult.votes);
      IF votes^[index^[i]]^.vote[0]='*' THEN
         (* ungltig *)
         INC(cfvResult.illegal);
      ELSE
         (* zhlen *)
         buffer[0] := 0C;
         Assign(votes^[index^[i]]^.vote, line);
         WHILE line[0]#0C DO
            pos := Pos(',', line);
            IF pos<HIGH(line) THEN
               Copy(line, 0, pos, buffer);
               Delete(line, 0, pos+1);
               RemoveLeadingSpaces(line);
            ELSE
               Assign(line, buffer);
               line[0] := 0C;
            END;
            Trim(buffer);
            (* debug *
            InOut.WriteLine(buffer);
             *       *)
            IF omov THEN
               IF (CompareStr(box, votes^[index^[i]]^.box)#0) THEN
                  (* nchste MAUS *)
                  CountMaus;
                  Assign(votes^[index^[i]]^.box, box);
               END;
               j := 0;
               WHILE (j<MAXTOPIC) AND (CompareStr(buffer, cfv[this].vote[j].short)#0) DO
                  INC(j);
               END;
               IF j<MAXTOPIC THEN
                  mausResult.vGruppe[ORD(buffer[0])-ORD('A')] := mausResult.vGruppe[ORD(buffer[0])-ORD('A')]+1.0;
                  mausResult.vote[j].count := mausResult.vote[j].count+1.0;
               END;
            ELSE
               j := 0;
               WHILE (j<MAXTOPIC) AND (CompareStr(buffer, cfv[this].vote[j].short)#0) DO
                  INC(j);
               END;
               IF j<MAXTOPIC THEN
                  cfvResult.vGruppe[ORD(buffer[0])-ORD('A')] := cfvResult.vGruppe[ORD(buffer[0])-ORD('A')]+1.0;
                  cfv[this].vote[j].count := cfv[this].vote[j].count+1.0;
               END;
            END;
         END;
      END;
   END CountVote;

BEGIN
   omov := (vOMOV IN cfv[this].type);
   box[0] := 0C;
   name1[0] := 0C;
   name2[0] := 0C;
   Assign(tmpPath, tmpFilename);
   Assign(tmpPath, tmp2Filename);
   IF NOT CreateTmp(votefile, tmpFilename, aWrite) THEN
      (* temporre Datei konnte nicht angelegt werden *)
      LogLine(" * (CountVotes): temporre Datei 1 konnte nicht angelegt werden!");
   ELSE
      IF debug THEN
         LogString(" ' (CountVotes): temporre Datei 1 '");
         LogString(tmpFilename);
         LogLine("' angelegt");
      END;
      FOR j := 0 TO MAXTOPIC-1 DO
         cfv[this].vote[j].count := 0.0;
      END;
      ClearVotes;
      SortVotes(omov);
      IF votes^[index^[0]]=NIL THEN
         IF debug THEN
            LogLine(" ' (CountVotes): keine Stimmen zu zhlen");
         END;
      ELSE
         IF omov THEN
            (*
            Assign('TMPFILE2', tmp2Filename);
            IF NOT Create(omovfile, tmp2Filename, aWrite, cClobber) THEN
            *)
            IF NOT CreateTmp(omovfile, tmp2Filename, aWrite) THEN
               (* temporre Datei konnte nicht angelegt werden *)
               LogLine(" * (CountVotes): temporre Datei 2 konnte nicht angelegt werden!");
            ELSE
              IF debug THEN
                  LogString(" ' (CountVotes): temporre Datei 2 '");
                  LogString(tmp2Filename);
                  LogLine("' angelegt");
               END;
               FOR j := 0 TO MAXTOPIC-1 DO
                  mausResult.vote[j].count := 0.0;
               END;
               i := 0;
               (*
               IF debug THEN
                  InOut.WriteString(votes^[index^[i]]^.sender);
                  InOut.WriteString("   ");
                  InOut.WriteLine(votes^[index^[i]]^.vote);
               END;
               *)
               CountVote;
               pos := Pos('@', votes^[index^[i]]^.sender);
               IF pos<128 THEN
                  Copy(votes^[index^[i]]^.sender, 0, pos, name1);
                  RemoveTrailingSpaces(name1);
               END;
               INC(i);
               WHILE (i<MAXVOTE) AND (votes^[index^[i]]#NIL) DO
                  (*
                  IF debug THEN
                     InOut.WriteString(votes^[index^[i]]^.sender);
                     InOut.WriteString("   ");
                     InOut.WriteLine(votes^[index^[i]]^.vote);
                  END;
                  *)
                  pos := Pos('@', votes^[index^[i]]^.sender);
                  IF pos<128 THEN
                     Copy(votes^[index^[i]]^.sender, 0, pos, name2);
                     RemoveTrailingSpaces(name2);
                  END;
                  IF (CompareStr(votes^[index^[i]]^.box, votes^[index^[i-1]]^.box)#0) OR
                    (CompareNames(name1, name2)#0) THEN
                     CountVote;
                  END;
                  Assign(name2, name1);
                  INC(i);
               END;
               (* Auswertung fr die letzte Box *)
               CountMaus;
               Close(omovfile);
               IF debug THEN
                  LogLine(" ' (CountVotes): temporre Datei 2 geschlossen");
               END;
            END;
         ELSE  (* kein OMOV *)
            i := 0;
            CountVote;
            INC(i);
            WHILE (i<MAXVOTE) AND (votes^[index^[i]]#NIL) DO
               IF CompareNames(votes^[index^[i]]^.sender, votes^[index^[i-1]]^.sender)#0 THEN
                  CountVote;
               END;
               INC(i);
            END;
         END;
         FOR i := 0 TO MAXVOTE-1 DO
            IF votes^[i]#NIL THEN
               DISPOSE(votes^[i]);
               votes^[i] := NIL;
            END;
         END;
      END;
      Close(votefile);
      IF debug THEN
         LogLine(" ' (CountVotes): temporre Datei 1 geschlossen");
      END;
   END;
END CountVotes;

PROCEDURE ListResult(this: CARDINAL);
(* gibt das Ergebnis des zuletzt gezhlten CFV ins Infile aus *)
VAR   str:  ARRAY [0 .. 8] OF CHAR;
      n,
      i:    CARDINAL;
      last: CHAR;
BEGIN
   InfileString("Abgegebene Stimmen gesamt:");
   CardToString(cfvResult.votes, str, 7);
   InfileLine(str);
   InfileString("davon ungltig:           ");
   CardToString(cfvResult.illegal, str, 7);
   InfileLine(str);
   InfileLn;
   IF (vOMOV IN cfv[this].type) THEN
      n := 2;
      InfileLine("Ergebnis der Abstimmung");
   ELSE
      n := 0;
      InfileLine("Von den gltigen Stimmen entfielen auf");
   END;
   (* Punkte nach Anzahl der Stimmen sortieren wre nicht schlecht *)
   last := 0C;
   i := 0;
   WHILE (i<MAXTOPIC) AND (cfv[this].vote[i].short[0]#0C) DO
      (* Leerzeile zwischen den Blcken *)
      IF cfv[this].vote[i].short[0]#last THEN
         last := cfv[this].vote[i].short[0];
         InfileLn;
      END;
      (* Abstimmungspunkt *)
      InfileString(cfv[this].vote[i].short);
      (* Zahl der Stimmen *)
      RealToString(cfv[this].vote[i].count, n, 7, str, void.boolean);
      IF str[Length(str)-1]='.' THEN
         str[Length(str)-1] := 0C;
      END;
      InfileString(str);
      IF cfv[this].vote[i].count=1.0 THEN
         InfileString(" Stimme  (");
      ELSE
         InfileString(" Stimmen (");
      END;
      (* in Prozent *)
      IF cfvResult.vGruppe[ORD(cfv[this].vote[i].short[0])-ORD('A')]#0.0 THEN
         RealToString((cfv[this].vote[i].count*100.0)
                      /cfvResult.vGruppe[ORD(cfv[this].vote[i].short[0])-ORD('A')],
                      1, 6, str, void.boolean);
      ELSE
         RealToString(0.0, 1, 6, str, void.boolean);
      END;
      InfileString(str);
      InfileLine("%)");
      INC(i);
   END;
END ListResult;


PROCEDURE DoAnswerForm(message:    Message;
                       filename:   ARRAY OF CHAR);
(*
 * die Datei filename wird eingelesen, die Platzhalter ersetzt und
 * der Text als Mailtext ins Infile geschrieben
 *)
VAR   file:       File;
      pathname:   PathName;
BEGIN
   Assign(filename, pathname);
   (* Pfad davorsetzen, falls ntig *)
   IF Pos('\', pathname)>HIGH(pathname) THEN
      Insert(templatePath, pathname, 0);
   END;
   IF NOT Open(file, pathname, aRead) THEN
      (* Fehler *)
      LogString(" * (DoAnswerForm): Formulartext ");
      LogString(pathname);
      LogLine(" konnte nicht geffnet werden!");
   ELSE
      IF debug THEN
         LogString(" ' (DoAnswerForm): Formulartext '");
         LogString(pathname);
         LogLine("' geffnet");
      END;
      IF message#NIL THEN
         answer^.mausrid := message^.mausid;
         answer^.rid := message^.id;
      END;
      InfileWriteHeader(answer, newID);
      WHILE NOT EOF(file) DO
         ReadLine(file, line);
         ReplaceWildcards(line);
         InfileLine(line);
      END;
      InfileEndmail;
      Close(file);
      IF debug THEN
         LogLine(" ' (DoAnswerForm): Datei geschlossen");
      END;
   END;
END DoAnswerForm;

PROCEDURE DoUnknownError(message: Message);
(*
 * unbekanntes Kommando
 *)
BEGIN
   ClearAnswer(message);
   DoAnswerForm(message, UNKANSWER);
   LogLine("   Fehlermeldung zugestellt");
END DoUnknownError;

PROCEDURE IsAddress(entry, parm: ADDRESS): BOOLEAN;
VAR   dest:   POINTER TO DestRec;
      name:    POINTER TO ARRAY [0 .. 255] OF CHAR;
BEGIN
   dest := entry;
   name := parm;
   RETURN (CompareNames(dest^.address, name^)=0);
END IsAddress;

PROCEDURE DoHelp(message:  Message;
                 help:     PtrHelpRec;
                 filename: ARRAY OF CHAR);
(*
 * Hilfe angefordert
 *)

VAR   access:  AccessType;
      str:     ARRAY [0 .. 15] OF CHAR;

   PROCEDURE ExceedLimit(address, filename: ARRAY OF CHAR): BOOLEAN;
   VAR   result:     BOOLEAN;
         fileSize:   LONGCARD;
         file:       File;
         destRec:    POINTER TO DestRec;
         limit:      LONGCARD;
   BEGIN
      result := FALSE;
      (* Dateigre ermitteln *)
      IF NOT Open(file, filename, aRead) THEN
         (* Fehler *)
         LogString(" * (DoHelp.ExceedLimit): Hilfetext ");
         LogString(filename);
         LogLine(" konnte nicht geffnet werden!");
      ELSE
         IF debug THEN
            LogString(" ' (DoHelp.ExceedLimit): Hilfetext '");
            LogString(filename);
            LogLine("' geffnt");
         END;
         fileSize := Seek(file, sEnd, 0L);
         Close(file);
         IF debug THEN
            LogLine(" ' (DoHelp.ExceedLimit): Datei geschlossen");
         END;
      END;
      (* Adresse suchen *)
      Lists.ResetCursor(destList);
      destRec := Lists.SearchEntry(destList, Lists.lForward, IsAddress, ADR(address));
      IF destRec=NIL THEN
         (* eintragen *)
         NEW(destRec);
         Assign(address, destRec^.address);
         destRec^.received := 0L;
         void.boolean := Lists.AppendEntry(destList, destRec);
      END;
      IF destRec#NIL THEN
         (* passendes Limit suchen *)
         IF IsLocal(address) THEN
            limit := mailLimitLocal;
         ELSIF IsMausNet(address) THEN
            limit := mailLimitMausNet;
         ELSE
            limit := mailLimitNet;
         END;
         (* Limit prfen, ggf. Dateigre addieren *)
         IF (limit>0L) AND ((destRec^.received+fileSize)>limit) THEN
            result := TRUE;
         ELSE
            destRec^.received := destRec^.received+fileSize;
         END;
      END;
      RETURN result;
   END ExceedLimit;

BEGIN
   access := aWorld;
   IF FindChef(message^.von, void.cardinal) THEN
      access := aChef;
   ELSIF IsSysop(message^.von, FALSE, str) THEN
      access := aSysop;
   ELSIF IsMausNet(message^.von) THEN
      access := aMausNet;
   END;
   ClearAnswer(message);
   IF (help^.access > access) THEN
      DoAnswerForm(message, NOALANSWER);
      LogLine(" ! nicht berechtigt - Hilfetext nicht zugestellt");
   ELSIF ExceedLimit(message^.von, filename) THEN
      DoAnswerForm(message, EXCEEDANSWER);
      LogLine(" ! Mail-Limit erreicht - Hilfetext nicht zugestellt");
   ELSE
      DoAnswerForm(message, filename);
      LogLine("   Hilfetext zugestellt");
   END;
END DoHelp;

PROCEDURE DoListAll(message: Message);
VAR   chef:    CARDINAL;
      local:   BOOLEAN;
      i:       CARDINAL;
      str:     ARRAY [0 .. 11] OF CHAR;
BEGIN
   ClearAnswer(message);
   (* Berechtigung prfen *)
   chef := MAXCHEF;
   IF NOT FindChef(message^.von, chef) THEN
      DoAnswerForm(message, NOALANSWER);
      LogLine("   Absender ist kein AL");
   ELSE
      local := IsLocal(chefList[chef].name^);
      InfileWriteHeader(answer, newID);
      FOR i := 0 TO MAXCFV-1 DO
         IF cfv[i].name[0]#0C THEN
            IF local OR (cfv[i].access#vLocal) THEN
               IF (vCFO IN cfv[i].type) THEN
                  InfileString("Name des CFO: ");
               ELSE
                  InfileString("Name des CFV: ");
               END;
               InfileLine(cfv[i].name);
               InfileString(ACCESSSTR);
               CASE cfv[i].access OF
               | vWorld:
                  InfileLine(ACCALLSTR);
               | vMausNet:
                  InfileLine(ACCMAUSNETSTR);
               | vLocal:
                  InfileString(ACCLOCALSTR);
                  InfileLine(MausName);
               | vSysop:
                  InfileLine(ACCSYSOPSTR);
               | vBetreiber:
                  InfileLine(ACCBETREIBERSTR);
               ELSE
                  (* kann gar nicht sein ... *)
               END;
               InfileString(VTYPE);
               IF (vOMOV IN cfv[i].type) THEN
                  InfileString(' ');
                  InfileString(TOMOV);
               END;
               IF (vPerson IN cfv[i].type) THEN
                  InfileString(' ');
                  InfileString(TPERSON);
               END;
               IF (cfv[i].type=VoteTypeSet{}) THEN
                  InfileString(' Normal');
               END;
               InfileLn;
               IF cfv[i].voteMax<MAX(CARDINAL) THEN
                  InfileString(VOTES);
                  InfileString(' maximal ');
                  CardToString(cfv[i].voteMax, str, 1);
                  InfileLine(str);
               END;
               InfileString(TIMEOUT);
               DateToStr(cfv[i].timeout, DDMMYYYY, '.', str);
               InfileString(' ');
               InfileLine(str);
               InfileString(GRUPPE);
               InfileString(' ');
               InfileLine(cfv[i].gruppe);
               InfileString('Initiator: ');
               InfileLine(cfv[i].sender);
               InfileString(REPLYTO);
               InfileString(' ');
               InfileLine(cfv[i].replyTo);
               InfileString(COPYTO);
               InfileString(' ');
               InfileLine(cfv[i].copyTo);
               InfileString(KEY);
               InfileString(' ');
               InfileLine(cfv[i].key);
               CASE cfv[i].state OF
                 csNew:
                  InfileLine("o Der CFV/CFO luft noch nicht.");
               | csRunning:
                  InfileLine("+ Der CFV/CFO luft zur Zeit.");
               | csStopped:
                  InfileLine("- Der CFV/CFO wurde gestoppt.");
               | csEnded:
                  InfileLine("= Der CFV/CFO ist beendet.");
               END;
               InfileLn;
            END;
         END;
      END;
      InfileEndmail;
      IF local THEN
         LogLine("   Liste aller CFVs zugestellt");
      ELSE
         LogLine("   Liste der nicht-lokalen CFVs zugestellt");
      END;
   END;
END DoListAll;

PROCEDURE DoNotImplemented(message: Message);
BEGIN
   ClearAnswer(message);
   DoAnswerForm(message, NIANSWER);
   LogLine("   Kommando nicht implementiert");
END DoNotImplemented;

PROCEDURE DoNewAL(message: Message);
(*
 * neuen AL eintragen
 *)
VAR   chef:    CARDINAL;
      pos,
      i,
      count:   CARDINAL;
      done,
      err:     BOOLEAN;
BEGIN
   ClearAnswer(message);
   (* Berechtigung prfen *)
   chef := MAXCHEF;
   IF FindChef(message^.von, chef) OR IsLocalSysop(message^.von) THEN
      InfileWriteHeader(answer, newID);
      count := 0;
      (* Mailtext lesen *)
      lastpos := Seek(outfile, sBegin, lastpos);
      done := FALSE;
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            Delete(buffer, 0, 1);
            Trim(buffer);
            IF Pos('@', buffer)<HIGH(buffer) THEN
               IF BeginsWith(ONCEAL, buffer, pos) THEN
                  Delete(buffer, pos, Length(ONCEAL));
                  Trim(buffer);
                  RemoveLeadingSpaces(buffer);
                  void.boolean := NormalizeAddress(buffer);
                  IF FindChef(buffer, i) THEN
                     InfileString(buffer);
                     InfileLine(" ist bereits eingetragen!");
                  ELSE
                     void.boolean := AddChef(buffer, cOnce);
                     InfileString(buffer);
                     InfileLine(" fr einen CFV eingetragen");
                     INC(count);
                     LogString("   ");
                     LogString(buffer);
                     LogLine(" fr einen CFV eingetragen");
                  END;
               ELSE
                  err := FALSE;
                  void.boolean := NormalizeAddress(buffer);
                  IF FindChef(buffer, i) THEN
                     IF chefList[i].type#cOnce THEN
                        InfileString(buffer);
                        InfileLine(" ist bereits eingetragen!");
                        err := TRUE;
                     ELSE
                        DeleteChef(i);
                     END;
                  END;
                  IF NOT err THEN
                     void.boolean := AddChef(buffer, cSoft);
                     InfileString(buffer);
                     InfileLine(" als AL eingetragen");
                     INC(count);
                     LogString("   ");
                     LogString(buffer);
                     LogLine(" als AL eingetragen");
                  END;
               END;
            ELSE
               InfileLine(" '@' fehlt");
               LogLine(" ! '@' fehlt");
            END;
         END;
      UNTIL done OR EOF(outfile);
      IF count=0 THEN
         InfileLn;
         InfileLine("Keine neue Adresse eingetragen!");
         InfileLn;
         LogLine("   keine neue Adresse eingetragen");
      END;
      InfileEndmail;
   ELSE
      DoAnswerForm(message, NOALANSWER);
      LogLine("   Absender ist kein AL");
   END;
END DoNewAL;

PROCEDURE DoDeleteAL(message: Message);
(*
 * AL lschen
 *)
VAR   chef:    CARDINAL;
      i,
      count:   CARDINAL;
      done,
      err:     BOOLEAN;
BEGIN
   ClearAnswer(message);
   (* Berechtigung prfen *)
   chef := MAXCHEF;
   IF FindChef(message^.von, chef) OR IsLocalSysop(message^.von) THEN
      InfileWriteHeader(answer, newID);
      count := 0;
      (* Mailtext lesen *)
      lastpos := Seek(outfile, sBegin, lastpos);
      done := FALSE;
      REPEAT
         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         IF buffer[0]#':' THEN
            done := TRUE;
         ELSE
            Delete(buffer, 0, 1);
            Trim(buffer);
            void.boolean := NormalizeAddress(buffer);
            IF Pos('@', buffer)<HIGH(buffer) THEN
               err := FALSE;
               IF FindChef(buffer, i) THEN
                  IF chefList[i].type=cHard THEN
                     InfileString(buffer);
                     InfileLine(" kann nicht per Mail gelscht werden!");
                     InfileLn;
                     InfileString("Der Eintrag mu manuell aus dem ");
                     InfileString(CFGFILE);
                     InfileString(" entfernt werden.");
                     InfileLn;
                     err := TRUE;
                  ELSE
                     DeleteChef(i);
                     InfileString(buffer);
                     InfileLine(" wurde gelscht.");
                     INC(count);
                     LogString("   ");
                     LogString(buffer);
                     LogLine("   aus AL-Liste gelscht");
                  END;
               ELSE
                  InfileString(buffer);
                  InfileLine(" ist nicht als AL eingetragen.");
               END;
            END;
         END;
      UNTIL done OR EOF(outfile);
      IF count=0 THEN
         InfileLn;
         InfileLine("Es wurde keine Adresse gelscht!");
         InfileLn;
         LogLine("   keine Adresse gelscht");
      END;
      InfileEndmail;
   ELSE
      DoAnswerForm(message, NOALANSWER);
      LogLine("   Absender ist kein AL");
   END;
END DoDeleteAL;

PROCEDURE DoListALs(message: Message);
(*
 * ALs auflisten
 *)
VAR   chef:    CARDINAL;
      i:       CARDINAL;
      err:     BOOLEAN;
BEGIN
   ClearAnswer(message);
   (* Berechtigung prfen *)
   chef := MAXCHEF;
   IF allowListALs OR FindChef(message^.von, chef) OR
      IsLocalSysop(message^.von) THEN
      InfileWriteHeader(answer, newID);
      FOR i := 0 TO MAXCHEF-1 DO
         IF chefList[i].name#NIL THEN
            IF (chefList[i].type#cOnce) OR (chef#MAXCHEF) THEN
               InfileString(chefList[i].name^);
               IF chefList[i].type=cOnce THEN
                  InfileString(" (fr einen CFV)");
               END;
               InfileLn;
            END;
         END;
      END;
      InfileEndmail;
      LogLine("   AL-Liste zugestellt");
   ELSE
      DoAnswerForm(message, NOALANSWER);
      LogLine("   Absender ist kein AL");
   END;
END DoListALs;

PROCEDURE ReadHelpInfo(VAR info: ARRAY OF CHAR): BOOLEAN;
VAR   result:  BOOLEAN;
      done:    BOOLEAN;
BEGIN
   result := FALSE;
   done := FALSE;
   REPEAT
      lastpos := Seek0(outfile);
      ReadLine(outfile, buffer);
      IF buffer[0]#':' THEN
         done := TRUE;
      ELSIF buffer[1]='#' THEN
         done := TRUE;
      ELSE
         Delete(buffer, 0, 1);
         IF info[0]#0C THEN
            Append(info, '\n');
         END;
         Append(info, buffer);
         result := TRUE;
      END;
   UNTIL done OR EOF(outfile);
   IF done THEN
      lastpos := Seek(outfile, sBegin, lastpos);
   END;
   RETURN result;
END ReadHelpInfo;

PROCEDURE ReadHelpText(file: File): BOOLEAN;
VAR   result:  BOOLEAN;
      done:    BOOLEAN;
BEGIN
   result := FALSE;
   done := FALSE;
   REPEAT
      lastpos := Seek0(outfile);
      ReadLine(outfile, buffer);
      IF buffer[0]#':' THEN
         done := TRUE;
      ELSIF buffer[1]='#' THEN
         done := TRUE;
      ELSE
         Delete(buffer, 0, 1);
         WriteLine(file, buffer);
         result := TRUE;
      END;
   UNTIL done OR EOF(outfile);
   IF done THEN
      lastpos := Seek(outfile, sBegin, lastpos);
   END;
   RETURN result;
END ReadHelpText;

PROCEDURE ReadHelpFlags(VAR access: AccessType; VAR hidden: BOOLEAN): BOOLEAN;
VAR   result:  BOOLEAN;
      done:    BOOLEAN;
      pos:     CARDINAL;
BEGIN
   result := FALSE;
   access := aWorld;
   hidden := FALSE;
   done := FALSE;
   REPEAT
      lastpos := Seek0(outfile);
      ReadLine(outfile, buffer);
      IF buffer[0]#':' THEN
         done := TRUE;
      ELSIF buffer[1]='#' THEN
         done := TRUE;
      ELSE
         Delete(buffer, 0, 1);
         IF BeginsWith(HACCESS, buffer, pos) THEN
            Delete(buffer, pos, Length(HACCESS));
            Trim(buffer);
            CASE buffer[0] OF
            | 'W' (*HACCWORLD[0]*):      access := aWorld;
            | 'M' (*HACCMAUSNET[0]*):    access := aMausNet;
            | 'S' (*HACCSYSOP[0]*):      access := aSysop;
            | 'C' (*HACCCHEF[0]*):       access := aChef;
            ELSE
            END;
            result := TRUE;
         ELSIF BeginsWith(HHIDDEN, buffer, pos) THEN
            Delete(buffer, pos, Length(HHIDDEN));
            Trim(buffer);
            IF buffer[0]='T' THEN
               hidden := TRUE;
            END;
            result := TRUE;
         END;
      END;
   UNTIL done OR EOF(outfile);
   IF done THEN
      lastpos := Seek(outfile, sBegin, lastpos);
   END;
   RETURN result;
END ReadHelpFlags;

PROCEDURE DoNewHelp(message: Message);
VAR   name,
      path:       PathName;
      rnd:        CARDINAL;
      done:       BOOLEAN;
      file:       File;
      info:       ARRAY [0 .. 1024] OF CHAR;
      help:       PtrHelpRec;
      access:     AccessType;
      hidden:     BOOLEAN;
BEGIN
   ClearAnswer(message);
   IF NOT FindChef(message^.von, void.cardinal) THEN
      DoAnswerForm(message, NOALANSWER);
      LogLine("   Absender ist kein AL");
   ELSE
      Delete(message^.betreff, 0, Length(NEWHELP));
      Trim(message^.betreff);
      IF FindHelp(message^.betreff, help, path) THEN
         InfileWriteHeader(answer, newID);
         InfileLine("Es existiert bereits ein Hilfetext dieses Namens.");
         InfileEndmail;
         LogLine("   Hilfetext existiert bereits");
      ELSE
         (* Hilfetext lesen und in File schreiben *)
         REPEAT
            rnd := RandomCard(0, 9999);
            CardToString(rnd, name, 1);
            WHILE Length(name)<4 DO
               Insert('0', name, 0);
            END;
            Insert('HELP', name, 0);
            Append(name, '.TXT');
            Assign(name, path);
            Insert(helpPath, path, 0);
         UNTIL Create(file, path, aWrite, cNew);
         IF debug THEN
            LogString(" ' (DoNewHelp): Hilfetext '");
            LogString(path);
            LogLine("' angelegt");
         END;
         IF NOT AddHelpfile(message^.betreff, name) THEN
            IF debug THEN
               LogLine(" ' (DoNewHelp): AddHelpfile() fehlgeschlagen!");
            END;
            Close(file);
            Directories.Delete(path);
            IF debug THEN
               LogString(" ' (DoNewHelp): Hilfetext '");
               LogString(path);
               LogLine("' geschlossen und gelscht");
            END;
            InfileWriteHeader(answer, newID);
            InfileLine("Fehler beim Hinzufgen des Hilfetextes!");
            InfileEndmail;
            LogLine(" * (DoNewHelp): Fehler beim Hinzufgen des Hilfetextes!");
            LogLine("   Hilfetext nicht angelegt");
         ELSE
            (* Hilfetext einlesen *)
            access := aWorld;
            hidden := FALSE;
            lastpos := Seek(outfile, sBegin, lastpos);
            info[0] := 0C;

            lastpos := Seek0(outfile);
            ReadLine(outfile, buffer);
            WHILE buffer[0]=':' DO
               IF (CompareNames(buffer, ':#INFO')=0) THEN
                  void.boolean := ReadHelpInfo(info);
               ELSIF (CompareNames(buffer, ':#FLAGS')=0) THEN
                  void.boolean := ReadHelpFlags(access, hidden);
               ELSIF (CompareNames(buffer, ':#TEXT')=0) THEN
                  (* bei leerem Text sollte eine Fehlermeldung erfolgen *)
                  void.boolean := ReadHelpText(file);
               (*
               ELSIF buffer[1]#'#' THEN
                  lastpos := Seek(outfile, sBegin, lastpos);
                  void.boolean := ReadHelpText(file);
               *)
               ELSE
               END;
               lastpos := Seek0(outfile);
               ReadLine(outfile, buffer);
            END;
            lastpos := Seek(outfile, sBegin, lastpos);
            
            Close(file);
            IF debug THEN
               LogString(" ' (DoNewHelp): Hilfetext '");
               LogString(path);
               LogLine("' geschlossen");
            END;
            void.boolean := SetHelpInfo(message^.betreff,
                                        info, access, hidden);
            InfileWriteHeader(answer, newID);
            InfileLine("OK, der Hilfetext wurde hinzugefgt.");
            InfileEndmail;
            LogLine("   Hilfetext angelegt");
         END;
      END;
   END;
END DoNewHelp;

PROCEDURE DoDeleteHelp(message: Message);
VAR   str:  PathName;
      help: PtrHelpRec;
BEGIN
   ClearAnswer(message);
   IF NOT FindChef(message^.von, void.cardinal) THEN
      DoAnswerForm(message, NOALANSWER);
      LogLine("   Absender ist kein AL");
   ELSE
      Delete(message^.betreff, 0, Length(DELETEHELP));
      Trim(message^.betreff);
      IF NOT FindHelp(message^.betreff, help, str) THEN
         InfileWriteHeader(answer, newID);
         InfileLine("Es existiert kein Hilfetext dieses Namens.");
         InfileEndmail;
         LogLine("   Hilfetext nicht gefunden");
      ELSE
         (* Hilfetext lschen *)
         IF NOT DeleteHelpfile(message^.betreff) THEN
            InfileWriteHeader(answer, newID);
            InfileLine("Fehler beim Entfernen des Hilfetextes!");
            InfileEndmail;
            LogLine(" * (DoNewHelp): Fehler beim Entfernen des Hilfetextes!");
            LogLine("   Hilfetext nicht gelscht");
         ELSE
            Directories.Delete(str);
            InfileWriteHeader(answer, newID);
            InfileLine("OK, der Hilfetext wurde gelscht.");
            InfileEndmail;
            LogLine("   Hilfetext gelscht");
         END;
      END;
   END;
END DoDeleteHelp;

PROCEDURE DoChangeHelp(message: Message);
VAR   str:     PathName;
      file:    File;
      done:    BOOLEAN;
      info:    ARRAY [0 .. 1024] OF CHAR;
      chInfo,
      chFlags,
      chText:  BOOLEAN;
      help:    PtrHelpRec;
      access:  AccessType;
      hidden:  BOOLEAN;

   PROCEDURE ChangeHelpText;
   BEGIN
      Assign(helpPath, tmpFilename);
      IF NOT CreateTmp(file, tmpFilename, aWrite) THEN
         InfileWriteHeader(answer, newID);
         InfileLine("Fehler beim Anlegen des Tempfiles fr den Hilfetext!");
         InfileEndmail;
         LogLine(" * (DoChangeHelp): Fehler beim Anlegen des Tempfiles fr den Hilfetext!");
         LogLine("   Hilfetext nicht gendert");
      ELSE
         IF debug THEN
            LogString(" ' (DoChangeHelp): Tempfile '");
            LogString(tmpFilename);
            LogLine("' neu angelegt");
         END;
         chText := ReadHelpText(file);
         Close(file);
         IF debug THEN
            LogString(" ' (DoChangeHelp): Tempfile '");
            LogString(tmpFilename);
            LogLine("' geschlossen");
         END;
         IF chText THEN
            Directories.Delete(str);
            Directories.Rename(tmpFilename, str);
            IF debug THEN
               LogString(" ' (DoChangeHelp): alten Hilfetext '");
               LogString(str);
               LogLine("' gelscht");
               LogString(" ' (DoChangeHelp): '");
               LogString(tmpFilename);
               LogString("' in '");
               LogString(str);
               LogLine("' umbenannt");
            END;
         ELSE
            Directories.Delete(tmpFilename);
            IF debug THEN
               LogString(" ' (DoChangeHelp): Tempfile '");
               LogString(tmpFilename);
               LogLine("' gelscht");
            END;
         END;
      END;
   END ChangeHelpText;

BEGIN
   chInfo := FALSE;
   chFlags := FALSE;
   chText := FALSE;
   ClearAnswer(message);
   IF NOT FindChef(message^.von, void.cardinal) THEN
      DoAnswerForm(message, NOALANSWER);
      LogLine("   Absender ist kein AL");
   ELSE
      Delete(message^.betreff, 0, Length(CHANGEHELP));
      Trim(message^.betreff);
      IF NOT FindHelp(message^.betreff, help, str) THEN
         InfileWriteHeader(answer, newID);
         InfileLine("Es existiert kein Hilfetext dieses Namens.");
         InfileEndmail;
         LogLine("   Hilfetext nicht gefunden");
      ELSE
         (* Hilfetext einlesen *)
         lastpos := Seek(outfile, sBegin, lastpos);
         info[0] := 0C;
         done := FALSE;

         lastpos := Seek0(outfile);
         ReadLine(outfile, buffer);
         WHILE buffer[0]=':' DO
            IF (CompareNames(buffer, ':#INFO')=0) THEN
               chInfo := ReadHelpInfo(info);
            ELSIF (CompareNames(buffer, ':#FLAGS')=0) THEN
               chFlags := ReadHelpFlags(access, hidden);
            ELSIF (CompareNames(buffer, ':#TEXT')=0) THEN
               ChangeHelpText;
            (*
            ELSIF buffer[1]#'#' THEN
               lastpos := Seek(outfile, sBegin, lastpos);
               ChangeHelpText;
            *)
            ELSE
            END;
            lastpos := Seek0(outfile);
            ReadLine(outfile, buffer);
         END;
         lastpos := Seek(outfile, sBegin, lastpos);

         IF chInfo OR chFlags THEN
            IF debug THEN
               LogLine(" ' (DoChangeHelp): ndere Info/Flags");
            END;
            (* ist info[0]=0C, wird help^.info nicht verndert *)
            done := SetHelpInfo(message^.betreff, info, access, hidden);
            IF debug THEN
               IF done THEN
                  LogLine(" ' (DoChangeHelp): Info/Flags gendert");
               ELSE
                  LogLine(" ! (DoChangeHelp): Fehler beim ndern der Hilfe!");
                  chInfo := FALSE;
                  chFlags := FALSE;
               END;
            END;
         END;

         InfileWriteHeader(answer, newID);
         IF chInfo THEN
            InfileString("Kurzinfo gendert. ");
         END;
         IF chFlags THEN
            InfileString("Flags gendert.");
         END;
         IF chText THEN
            InfileString("Hilfetext gendert.");
         END;
         IF chInfo OR chFlags OR chText THEN
            InfileLn;
            LogLine("   Hilfe gendert");
         ELSE
            InfileLine("Nichts gendert - irgendwas ist schiefgegangen!");
            LogLine("   Fehler beim ndern der Hilfe");
         END;
         InfileEndmail;
      END;
   END;
END DoChangeHelp;

PROCEDURE InfileHelpLine(entry, parm: ADDRESS);
VAR   help:    POINTER TO HelpRec;
      str:     ARRAY [0 .. 7] OF CHAR;
      pos:     CARDINAL;
      info:    ARRAY [0 .. 1024] OF CHAR;
      line:    ARRAY [0 .. 80] OF CHAR;
      access:  AccessType;
BEGIN
   CASE SHORT(FLAT(parm)) OF
   | 1: access := aMausNet;
   | 2: access := aSysop;
   | 3: access := aChef;
   ELSE
      access := aWorld;
   END;
   help := entry;
   IF NOT (help^.hidden AND (help^.access > access)) THEN
      InfileString("   ");
      InfileLine(help^.command);
      Assign(help^.info, info);
      WHILE info[0]#0C DO
         pos := Pos('\n', info);
         IF pos<HIGH(info) THEN
            Copy(info, 0, pos, line);
            Delete(info, 0, pos+2);
         ELSE
            Assign(info, line);
            info[0] := 0C;
         END;
         InfileString("    ");
         InfileLine(line);
      END;
      IF help^.access#aWorld THEN
         CASE help^.access OF
         | aMausNet: InfileLine("    <nur fr Benutzer des MausNet>");
         | aSysop:   InfileLine("    <nur fr Sysops>");
         | aChef:    InfileLine("    <nur fr Mitglieder des AL-Teams>");
         END;
      END;
      InfileLn;
   END;
END InfileHelpLine;

PROCEDURE DoListHelp(message: Message);
VAR   str:     ARRAY [0 .. 255] OF CHAR;
      file:    File;
      pos:     CARDINAL;
      access:  AccessType;
BEGIN
   access := aWorld;
   IF FindChef(message^.von, void.cardinal) THEN
      access := aChef;
   ELSIF IsSysop(message^.von, FALSE, str) THEN
      access := aSysop;
   ELSIF IsMausNet(message^.von) THEN
      access := aMausNet;
   END;
   ClearAnswer(message);
   InfileWriteHeader(answer, newID);
   InfileLn;
   InfileLine(helpListText);
   InfileLn;
   Lists.ScanList(helpList, Lists.lForward, Lists.Ever, NIL,
                  InfileHelpLine, ADDRESS(PTR(LONG(ORD(access)))));
   InfileLn;
   (* Legende anhngen *)
   Assign(helpListLegend, str);
   IF str[0]='@' THEN
      Delete(str, 0, 1);
      IF NOT Open(file, str, aRead) THEN
         (* Fehler *)
         LogString(" * (DoListHelp): Legende-Datei ");
         LogString(str);
         LogLine(" konnte nicht geffnet werden!");
      ELSE
         IF debug THEN
            LogString(" ' (DoListHelp): Legende-Datei '");
            LogString(str);
            LogLine("' geffnet");
         END;
         WHILE NOT EOF(file) DO
            ReadLine(file, line);
            ReplaceWildcards(line);
            InfileLine(line);
         END;
         Close(file);
         IF debug THEN
            LogLine(" ' (DoListHelp): Legende-Datei geschlossen");
         END;
      END;
   ELSE
      WHILE str[0]#0C DO
         pos := Pos('\n', str);
         IF pos<HIGH(str) THEN
            Copy(str, 0, pos, line);
            Delete(str, 0, pos+2);
         ELSE
            Assign(str, line);
            str[0] := 0C;
         END;
         InfileLine(line);
      END;
   END;
   InfileEndmail;
END DoListHelp;


BEGIN
   ModReg.Register('VoteFunctions',0,0,' ', 1997,08,16, PROC(NIL));


END VoteFunctions.
