IMPLEMENTATION MODULE VoteGlobals;

(*
 * 06.10.1996  -  endlose Rekursion in IsSysop verhindert
 *             -  Gastsysops werden jetzt erkannt
 * 13.10.1996  -  vor Vergleichen Umlaute in Namen konvertieren
 *             -  Prozentangabe bei OMOV
 * 16.10.1996  -  benutzt ModReg.Register
 *             -  Bei Ausgabe der Stimmen pro Box (OMOV) keine Punkte auflisten,
 *                die keine Stimmen bekommen haben
 * 20.10.1996  -  Stimmen aus Doppelmusen werden erkannt und fr die Hauptmaus
 *                gezhlt
 *             -  die Msg-IDs von Abstimmungsaufrufen werden gespeichert
 *             -  Datum und Uhrzeit werden in die temporre ID integriert
 *             -  Bei Ausgabe der Stimmen pro Box (OMOV) _wirklich_ keine Punkte
 *                auflisten, die keine Stimmen bekommen haben
 * 27.10.1996  -  Bugfix in StringToDate: Nach dem Jahr wurde ein Leerzeichen
 *                erwartet
 * 29.10.1996  -  Schlssel beim Lesen des Datenfiles auf 30 Zeichen krzen
 *                (in einer spteren Version wieder rauswerfen)
 * 06.11.1996  -  freie Hilfetexte ergnzt
 *             -  Namensvergleiche caseinsensitiv
 *             -  beim Einlesen von IDs CFVs ohne Temp-ID ignorieren
 * 09.11.1996  -  Signature ergnzt
 * 11.11.1996  -  IsLocalSysop hinzugefgt
 * 12.11.1996  -  muserFilename war nicht gesetzt
 *             -  Bugfixes in IstZahler und IsLocalSysop
 * 26.11.1996  -  CFOs werden untersttzt
 * 27.11.1996  -  Bugfix: 100.0 Stimmanteil wird richtig ausgegeben
 * 28.11.1996  -  Bugfix: #ADDRESS wurde von ReplaceWildcards nicht
 *                eingesetzt
 *             -  Variablen fr Default-Gruppennamen angelegt
 * 01.12.1996  -  Bugfix: hat sich immer nur das letzte Helpfile gemerkt
 *             -  Messagesplitting eingebaut
 * 02.12.1996  -  Pfade fr Hilfetexte und Templates ergnzt
 * 03.12.1996  -  Kommando und Textzeile fr Hilfe-Liste konfigurierbar
 * 04.12.1996  -  Bugfix: Folgeteile von gesplitteten Mails bekommen keine
 *                R-Zeile mehr
 * 07.12.1996  -  Temp-IDs jetzt mit Nummer
 *             -  bei neuen Mails wird nie eine Temp-ID als R-ID geschrieben
 *             -  vertikale Verkettung von gesplitteten PMs (die MAUS
 *                scheint das nicht zu untersttzen) nur, wenn die
 *                CFG-Variable VerticalSplitting TRUE ist (Default: FALSE)
 * 18.12.1996  -  *wirklich* keine Mails mehr auf eine Temp-ID verketten ...
 * 19.12.1996  -  Bugfix: #LOG-Block sollte jetzt richtig gelesen werden
 *             -  #ZIELADRESSE (Copyto) ergnzt
 *             -  Fehler im #LOG-Block werden im Logfile festgehalten
 *             -  Teile des Moduls nach VoteFiles ausgelagert
 *             -  Teile des Moduls nach VoteFunctions ausgelagert
 * 04.01.1997  -  Infozeile fr Helpfiles
 * 05.01.1997  -  ReadConfig aus VoteDevil bernommen
 *         /2  -  NormalizeAddress und CompareAddresses implementiert
 * 12.01.1997  -  Laufzeit-Angabe fr CFV/O
 * 19.01.1997  -  Legende fr die Hilfe Liste
 * 28.01.1997  -  NOSUBJECT und XSUBJECT ergnzt
 * 08.03.1997  -  IsDemon ergnzt
 * 09.03.1997  -  MessageRec um followup erweitert, followupTo ergnzt
 * 26.03.1997  -  myName und followupToPoster ergnzt (nur 'Poster' einsetzen)
 * 29.03.1997  -  bis zu 32 Abstimmungspunkte pro CFV
 *             -  CFV-Status eingefhrt (CFVState - cfv.state statt cfv.runs)
 *             -  Header fr DAT-File eingefhrt
 *             -  Versionsnummer 0.92
 * 09.04.1997  -  -q (quiet) implementiert
 * 16.04.1997  -  HelpRec um 'access' und 'hidden' erweitert
 * 16.08.1997  -  copyToALL ... copyToCFO hinzugefgt
 *
 * to do:      -  bei Fehler im #LOG Mail an Admin
 *)

FROM     SYSTEM            IMPORT   ADDRESS, ADR;
FROM     System            IMPORT   GetEnv;
FROM     Storage           IMPORT   ALLOCATE, DEALLOCATE;
IMPORT   InOut;
FROM     Strings           IMPORT   Append, Delete, Copy, Pos, Length,
                                    Insert, CompareStr;
FROM     Strings1          IMPORT   Assign, Replace, Trim, Upper, Lower,
                                    Capital, P2MString, ConvUmlaute,
                                    CorrectPath;
FROM     NumberConversion  IMPORT   StringToCard;
IMPORT   FileIO;
FROM     FileIO            IMPORT   File, PathName, AccessMode,
                                    CreateMode, Open, Create, Close, EOF, Write,
                                    WriteString, WriteLn, WriteLine, CreateTmp,
                                    WriteBytes, Read, ReadLine, ReadBytes,
                                    Flush, Seek, Seek0, SeekMode, State, NOFILE;
FROM     TimeNDate         IMPORT   Time, Date, TimeFormat, DateFormat,
                                    GetTime, GetDate, TimeToStr, DateToStr;
FROM     CDate             IMPORT   DaysGone, Legal;
FROM     RandomGen         IMPORT   RandomCard;
FROM     MausLibrary       IMPORT   TBenutzerprofil, TPromiState, MausName;
IMPORT   ConfigFile;
IMPORT   ModReg;
IMPORT   void;


PROCEDURE LogTime;
BEGIN
   IF State(logfile)#NOFILE THEN
      GetDate(date);
      DateToStr(date, DDMMYYYY, '.', dateStr);
      WriteString(logfile, dateStr);
      WriteString(logfile, "  ");
      IF logToStdOut THEN
         InOut.WriteString(dateStr);
         InOut.WriteString("  ");
      END;
      GetTime(time);
      TimeToStr(time, H4MMSS, ':', dateStr);
      WriteLine(logfile, dateStr);
      IF debug THEN
         Flush(logfile);
      END;
      IF logToStdOut THEN
         InOut.WriteLine(dateStr);
      END;
   END;
END LogTime;

PROCEDURE LogCopyright;
BEGIN
   IF State(logfile)#NOFILE THEN
      GetDate(date);
      DateToStr(date, DDMMYYYY, '.', dateStr);
      WriteString(logfile, dateStr);
      WriteString(logfile, "  ");
      IF logToStdOut THEN
         InOut.WriteString(dateStr);
         InOut.WriteString("  ");
      END;
      GetTime(time);
      TimeToStr(time, H4MMSS, ':', dateStr);
      WriteString(logfile, dateStr);
      WriteLine(logfile, COPYRIGHT);
      IF debug THEN
         Flush(logfile);
      END;
      IF logToStdOut THEN
         InOut.WriteString(dateStr);
         InOut.WriteLine(COPYRIGHT);
      END;
   END;
END LogCopyright;

PROCEDURE LogString(str: ARRAY OF CHAR);
BEGIN
   IF State(logfile)#NOFILE THEN
      WriteString(logfile, str);
      IF debug THEN
         Flush(logfile);
      END;
      IF logToStdOut THEN
         InOut.WriteString(str);
      END;
   END;
END LogString;

PROCEDURE LogLine(str: ARRAY OF CHAR);
BEGIN
   IF State(logfile)#NOFILE THEN
      WriteLine(logfile, str);
      IF debug THEN
         Flush(logfile);
      END;
      IF logToStdOut THEN
         InOut.WriteLine(str);
      END;
   END;
END LogLine;

PROCEDURE NormalizeAddress(VAR adr: ARRAY OF CHAR): BOOLEAN;
(* TRUE, wenn es sich um eine MausNet-Adresse handelt *)
VAR   result:  BOOLEAN;
      pos:     CARDINAL;
      name,
      domain:  ARRAY [0 .. 127] OF CHAR;
BEGIN
   result := FALSE;
   pos := Pos('@', adr);
   IF pos<HIGH(adr) THEN
      Copy(adr, 0, pos, name);
      Delete(adr, 0, pos+1);
      Assign(adr, domain);
   ELSE
      Assign(adr, name);
      domain[0] := 0C;
   END;
   Trim(name);
   Trim(domain);
   IF Pos(' ', domain)<HIGH(domain) THEN
      (* Fido-Adresse *)
      Capital(name);
      Capital(domain);
   ELSIF Pos('.', domain)<HIGH(domain) THEN
      (* Usenet-Adresse *)
      Lower(domain);
   ELSE
      (* MausNet-Adresse *)
      Capital(name);
      Upper(domain);
      result := TRUE;
   END;
   Assign(name, adr);
   IF domain[0]#0C THEN
      Append(adr, ' @ ');
      Append(adr, domain);
   END;
   RETURN result;
END NormalizeAddress;

PROCEDURE CompareAddresses(adr1, adr2: ARRAY OF CHAR): INTEGER;
VAR   str1,
      str2:    ARRAY [0 .. 127] OF CHAR;
BEGIN
   Assign(adr1, str1);
   Assign(adr2, str2);
   IF NormalizeAddress(str1) AND NormalizeAddress(str2) THEN
      ConvUmlaute(str1);
      ConvUmlaute(str2);
   END;
   RETURN CompareStr(str1, str2);
END CompareAddresses;

PROCEDURE CompareNames(name1, name2: ARRAY OF CHAR): INTEGER;
VAR   str1,
      str2:    ARRAY [0 .. 49] OF CHAR;
BEGIN
   Assign(name1, str1);
   Assign(name2, str2);
   ConvUmlaute(str1);
   ConvUmlaute(str2);
   Upper(str1);
   Upper(str2);
   RETURN CompareStr(str1, str2);
END CompareNames;

PROCEDURE EtoDateTime(VAR e:     ARRAY OF CHAR;
                      VAR date:  Date;
                      VAR time:  Time);
VAR   str:  ARRAY [0 .. 3] OF CHAR;
BEGIN
   IF e[0]#0C THEN
      Copy(e, 6, 2, str);       (* DD *)
      StringToCard(str, date.day, void.boolean);
      Copy(e, 4, 2, str);       (* MM *)
      StringToCard(str, date.month, void.boolean);
      Copy(e, 0, 4, str);       (* YYYY *)
      StringToCard(str, date.year, void.boolean);
      Copy(e, 8, 2, str);       (* HH *)
      StringToCard(str, time.h, void.boolean);
      Copy(e, 10, 2, str);      (* MM *)
      StringToCard(str, time.m, void.boolean);
      IF e[12]#0C THEN
         Copy(e, 12, 2, str);   (* SS *)
         StringToCard(str, time.s, void.boolean);
      END;
   END;
END EtoDateTime;

PROCEDURE StringToDate(    str:        ARRAY OF CHAR;
                           seperator:  CHAR;
                       VAR date:       Date): BOOLEAN;
VAR   result:  BOOLEAN;
      pos:     CARDINAL;
      s:       ARRAY [0 .. 7] OF CHAR;
BEGIN
   result := FALSE;
   date.day := 0;
   date.month := 0;
   date.year := 0;
   Trim(str);
   pos := Pos(seperator, str);
   IF pos<HIGH(str) THEN
      Copy(str, 0, pos, s);
      Delete(str, 0, pos+1);
      StringToCard(s, date.day, result);
      IF result THEN
         pos := Pos(seperator, str);
         IF pos<HIGH(str) THEN
            Copy(str, 0, pos, s);
            Delete(str, 0, pos+1);
            StringToCard(s, date.month, result);
            IF result THEN
               pos := Pos(' ', str);
               IF pos<HIGH(str) THEN
                  str[pos] := 0C;
               END;
               StringToCard(str, date.year, result);
               IF date.year<100 THEN
                  IF date.year>80 THEN
                     INC(date.year, 1900);
                  ELSE
                     INC(date.year, 2000);
                  END;
               END;
               result := Legal(date);
            END;
         END;
      END;
   END;
   RETURN result;
END StringToDate;

PROCEDURE StringToTime(    str:        ARRAY OF CHAR;
                           seperator:  CHAR;
                       VAR time:       Time): BOOLEAN;
VAR   result:  BOOLEAN;
      pos:     CARDINAL;
      s:       ARRAY [0 .. 7] OF CHAR;
BEGIN
   result := FALSE;
   Trim(str);
   pos := Pos(seperator, str);
   IF pos<HIGH(str) THEN
      Copy(str, 0, pos, s);
      Delete(str, 0, pos+1);
      StringToCard(s, time.h, result);
      IF result THEN
         pos := Pos(seperator, str);
         IF pos<HIGH(str) THEN
            Copy(str, 0, pos, s);
            Delete(str, 0, pos+1);
            StringToCard(s, time.m, result);
            IF result THEN
               pos := Pos(' ', str);
               IF pos<HIGH(str) THEN
                  str[pos] := 0C;
                  StringToCard(str, time.s, result);
                  result := ((time.s<60) AND (time.m<60) AND (time.h<24));
               END;
            END;
         END;
      END;
   END;
   RETURN result;
END StringToTime;


PROCEDURE IstZahler(name: ARRAY OF CHAR): BOOLEAN;
(*
 * mgliche Optimierung: Beim ersten Durchlauf alle Zahler merken,
 * spter diese Liste zur Prfung nutzen
 *)
VAR   result:  BOOLEAN;
      file:    File;
      read:    CARDINAL;
      user:    TBenutzerprofil;
      buffer,
      uname:   ARRAY [0 .. 49] OF CHAR;
BEGIN
   result := FALSE;
   IF NOT Open(file, muserFilename, aRead) THEN
      LogString(" * (IstZahler): Fehler beim ffnen des Userfiles '");
      LogString(muserFilename);
      LogLine("' - kann nicht auf Zahlerstatus prfen!");
   ELSE
      IF debug THEN
         LogString(" ' (IstZahler): Userfile '");
         LogString(muserFilename);
         LogLine("' geffnet");
      END;
      REPEAT
         ReadBytes(file, ADR(user), 1024 (*SIZE(user)*), read);
         IF read=1024 (*SIZE(user)*) THEN
            IF user.Status # 'X' THEN
               uname[0] := 0C;
               P2MString(user.Vorname, uname);
               Append(uname, ' ');
               buffer[0] := 0C;
               P2MString(user.Name, buffer);
               Append(uname, buffer);
               IF CompareNames(name, uname)=0 THEN
                  result := ((CHAR(user.paid)#0C) OR (user.promi=PromiZahler));
               END;
            END;
         END;
      UNTIL result OR EOF(file);
      Close(file);
      IF debug THEN
         LogLine(" ' (IstZahler): Datei geschlossen");
      END;
   END;
   RETURN result;
END IstZahler;

PROCEDURE IsLocalSysop(name: ARRAY OF CHAR): BOOLEAN;
VAR   result:  BOOLEAN;
      file:    File;
      pos,
      read:    CARDINAL;
      user:    TBenutzerprofil;
      buffer,
      uname:   ARRAY [0 .. 49] OF CHAR;
BEGIN
   result := FALSE;
   IF IsLocal(name) THEN
      IF NOT Open(file, muserFilename, aRead) THEN
         LogString(" * (IsLocalSysop): Fehler beim ffnen des Userfiles '");
         LogString(muserFilename);
         LogLine("' - kann nicht auf Sysopstatus prfen!");
      ELSE
         IF debug THEN
            LogString(" ' (IsLocalSysop): Userfile '");
            LogString(muserFilename);
            LogLine("' geffnet");
         END;
         pos := Pos("@", name);
         IF pos<HIGH(name) THEN
            name[pos] := 0C;
            Trim(name);
         END;
         REPEAT
            ReadBytes(file, ADR(user), 1024 (*SIZE(user)*), read);
            IF read=1024 (*SIZE(user)*) THEN
               IF user.Status = 'S' THEN
                  uname[0] := 0C;
                  P2MString(user.Vorname, uname);
                  Append(uname, ' ');
                  buffer[0] := 0C;
                  P2MString(user.Name, buffer);
                  Append(uname, buffer);
                  result := (CompareNames(name, uname)=0);
               END;
            END;
         UNTIL result OR EOF(file);
         Close(file);
         IF debug THEN
            LogLine(" ' (IsLocalSysop): Datei geschlossen");
         END;
      END;
   END;
   RETURN result;
END IsLocalSysop;

PROCEDURE IsLocal(str: ARRAY OF CHAR): BOOLEAN;
VAR   result:  BOOLEAN;
      pos:     CARDINAL;
BEGIN
   result := FALSE;
   pos := Pos("@", str);
   IF pos<HIGH(str) THEN
      Delete(str, 0, pos+1);
      Trim(str);
      result := (CompareStr(str, MausName)=0);
   END;
   RETURN result;
END IsLocal;

PROCEDURE IsMausNet(str: ARRAY OF CHAR): BOOLEAN;
VAR   result:  BOOLEAN;
      pos:     CARDINAL;
BEGIN
   result := FALSE;
   pos := Pos("@", str);
   IF pos<HIGH(str) THEN
      Delete(str, 0, pos+1);
      Trim(str);
      result := ((Pos(' ', str)>=HIGH(str)) AND (Pos('.', str)>=HIGH(str)));
   END;
   RETURN result;
END IsMausNet;

PROCEDURE IsDemon(str: ARRAY OF CHAR): BOOLEAN;
(* TRUE, wenn die angegebene Adresse ein Dmon ist, d.h. wenn der Name *)
(* eines der Wrter aus  demonNames  enthlt *)
VAR   result:  BOOLEAN;
      search,
      word:    ARRAY [0 .. 79] OF CHAR;
      pos, len,
      i:       CARDINAL;
BEGIN
   result := FALSE;
   len := Length(demonNames);
   pos := 0;
   i := 0;
   WHILE NOT result AND (pos<len) DO
      WHILE (i<len) AND (demonNames[i]#' ') DO
         INC(i);
      END;
      Copy(demonNames, pos, i-pos, search);
      Trim(search);
      pos := i;
      INC(i);
      result := (UPos(search, str, void.cardinal)<HIGH(str));
   END;
   RETURN result;
END IsDemon;

PROCEDURE UPos(    pat,
                   str: ARRAY OF CHAR;
               VAR pos: CARDINAL): CARDINAL;
(*
 * pos ist nach dem Aufruf identisch mit dem Funktionswert
 *)
BEGIN
   Upper(pat);
   Upper(str);
   pos := Pos(pat, str);
   RETURN pos;
END UPos;

PROCEDURE BeginsWith(    pat,
                         str: ARRAY OF CHAR;
                     VAR pos: CARDINAL): BOOLEAN;
VAR result: BOOLEAN;
BEGIN
   result := FALSE;
   Upper(pat);
   Upper(str);
   pos := Pos(pat, str);
   IF pos<HIGH(str) THEN
      str[pos] := 0C;
      Trim(str);
      result := (str[0]=0C);
   END;
   RETURN result;
END BeginsWith;

PROCEDURE NextLocalID(VAR id: ARRAY OF CHAR);
BEGIN
   id[0] := 'V';
   id[1] := 'D';
   id[2] := CHR(ORD('A')+SHORT((tempIDhigh MOD 308915776) DIV 11881376));
   id[3] := CHR(ORD('A')+SHORT((tempIDhigh MOD 11881376) DIV 456976));
   id[4] := CHR(ORD('A')+SHORT((tempIDhigh MOD 456976) DIV 17576L));
   id[5] := CHR(ORD('A')+SHORT((tempIDhigh MOD 17576L) DIV 676L));
   id[6] := CHR(ORD('A')+SHORT((tempIDhigh MOD 676L) DIV 26L));
   id[7] := CHR(ORD('A')+SHORT(tempIDhigh MOD 26L));
   id[8] := CHR(ORD('0')+(tempIDlow DIV 10));
   id[9] := CHR(ORD('0')+(tempIDlow MOD 10));
   id[10] := 0C;
   INC(tempIDlow);
   IF tempIDlow>99 THEN
      INC(tempIDhigh);
      tempIDlow := 0;
   END;
END NextLocalID;

PROCEDURE DumpMail(mes: Message);
(*
 * Speicher wieder komplett freigeben
 *)
BEGIN
   DISPOSE(mes);
END DumpMail;

PROCEDURE NewMail(): Message;
(*
 * Neue Mail anlegen
 *)
VAR   result: Message;
BEGIN
   NEW(result);
   IF result#NIL THEN
      WITH result^ DO
         mausid[0] := 0C;
         mausrid[0] := 0C;
         id[0] := 0C;
         rid[0] := 0C;
         von[0] := 0C;
         an[0] := 0C;
         betreff[0] := 0C;
         followup[0] := 0C;
         organisation[0] := 0C;
         datum[0] := 0C;
         gruppe[0] := 0C;
         realname[0] := 0C;
         distribution := 'N';
      END;
   END;
   RETURN result;
END NewMail;

PROCEDURE ClearMail(mes: Message);
(*
 * Mail lschen
 *)
BEGIN
   WITH mes^ DO
      mausid[0] := 0C;
      mausrid[0] := 0C;
      id[0] := 0C;
      rid[0] := 0C;
      von[0] := 0C;
      an[0] := 0C;
      betreff[0] := 0C;
      followup[0] := 0C;
      organisation[0] := 0C;
      datum[0] := 0C;
      gruppe[0] := 0C;
      realname[0] := 0C;
      distribution := 'N';
   END;
   vVote[0] := 0C;
   vTimeout[0] := 0C;
   vErrcause[0] := 0C;
   vAccess[0] := 0C;
   vCopyto[0] := 0C;
   vReplyto[0] := 0C;
   vAddress[0] := 0C;
   vBetreff[0] := 0C;
   vReceived[0] := 0C;
END ClearMail;

PROCEDURE ClearAnswer(mes: Message);
BEGIN
   WITH answer^ DO
      mausid[0] := 0C;
      mausrid := mes^.mausid;
      id[0] := 0C;
      rid := mes^.id;
      von[0] := 0C;
      an := mes^.von;
      betreff := mes^.betreff;
      followup[0] := 0C;
      organisation[0] := 0C;
      datum[0] := 0C;
      gruppe[0] := 0C;
      Assign(PROGNAME, realname);
      distribution := 'N';
   END;
   vVote[0] := 0C;
   vTimeout[0] := 0C;
   vErrcause[0] := 0C;
   vAccess[0] := 0C;
   vReplyto[0] := 0C;
   vCopyto[0] := 0C;
   Assign(mes^.von, vAddress);
   Assign(mes^.betreff, vBetreff);
   GetDate(date);
   DateToStr(date, DDMMYYYY, '.', dateStr);
   Assign(dateStr, vReceived);
END ClearAnswer;

MODULE FindeSysops;
   IMPORT   PathName, File, IsMausNet, Pos, Copy, Trim, Assign, Append,
            Open, LogString, LogLine, confPath, EOF, ReadLine, Delete,
            CompareStr, CompareNames, Close, AccessMode, debug, line, void;
   EXPORT   IsSysop;
   VAR   recDepth:   CARDINAL;      (* Tiefe der Rekursion *)

   PROCEDURE IsSysop(    str:          ARRAY OF CHAR;
                         nurBetreiber: BOOLEAN;
                     VAR box:          ARRAY OF CHAR): BOOLEAN;
   BEGIN
      recDepth := 0;
      RETURN DoIsSysop(str, nurBetreiber, box);
   END IsSysop;

   PROCEDURE IsDoppelmaus(VAR box: ARRAY OF CHAR): BOOLEAN;
   (* ersetzt das Krzel einer Doppelmaus durch das der Hauptmaus *)
   VAR   result:  BOOLEAN;
         done:    BOOLEAN;
         file:       File;
         confname:   PathName;
   BEGIN
      result := FALSE;
      Assign(confPath, confname);
      Append(confname, box);
      Append(confname, '.EXP');
      IF NOT Open(file, confname, aRead) THEN
         LogString(" * (IsDoppelmaus): EXP-File '");
         LogString(confname);
         LogLine("' konnte nicht geffnet werden!");
      ELSE
         IF debug THEN
            LogString(" ' (IsDoppelmaus): EXP-File '");
            LogString(confname);
            LogLine("' geffnet");
         END;
         line[0] := 0C;
         WHILE NOT result AND NOT EOF(file) DO
            ReadLine(file, line);
            IF line[0]='%' THEN
               IF (line[1]='d') OR (line[1]='D') THEN
                  Delete(line, 0, 2);
                  Trim(line);
                  IF line[0]#0C THEN
                     Assign(line, box);
                     result := TRUE;
                  END;
               END;
            END;
         END;
         Close(file);
         IF debug THEN
            LogLine(" ' (IsDoppelmaus): Datei geschlossen");
         END;
      END;
      RETURN result;
   END IsDoppelmaus;

   PROCEDURE DoIsSysop(    str:          ARRAY OF CHAR;
                           nurBetreiber: BOOLEAN;
                       VAR box:          ARRAY OF CHAR): BOOLEAN;
   VAR   result:     BOOLEAN;
         pos:        CARDINAL;
         vonBox:     ARRAY [0 .. 7] OF CHAR;
         suchName,
         gastName:   ARRAY [0 .. 49] OF CHAR;
         file:       File;
         confname:   PathName;
   BEGIN
      INC(recDepth);
      result := FALSE;
      box[0] := 0C;
      IF IsMausNet(str) THEN
         pos := Pos("@", str);
         Copy(str, pos+1, 8, vonBox);
         Trim(vonBox);     (* Box, von der aus abgestimmt wurde *)
         Copy(str, 0, pos, suchName);
         Trim(suchName);
         str[pos] := 0C;
         Trim(str);
         Assign(confPath, confname);
         Append(confname, vonBox);
         Append(confname, '.EXP');
         IF NOT Open(file, confname, aRead) THEN
            LogString(" * (IsSysop): EXP-File '");
            LogString(confname);
            LogLine("' konnte nicht geffnet werden!");
         ELSE
            IF debug THEN
               LogString(" ' (IsSysop): EXP-File '");
               LogString(confname);
               LogLine("' geffnet");
            END;
            line[0] := 0C;
            WHILE NOT result AND NOT EOF(file) DO
               ReadLine(file, line);
               IF line[0]='%' THEN
                  IF (line[1]='b') OR (line[1]='B') OR
                     (NOT(nurBetreiber) AND ((line[1]='s') OR (line[1]='S'))) THEN
                     pos := Pos(' ', line);
                     IF pos<HIGH(line) THEN
                        Delete(line, 0, pos+1);
                        pos := Pos(';', line);
                        IF pos<HIGH(line) THEN
                           line[pos] := 0C;
                        END;
                        Trim(line);
                        IF (CompareNames(line, str)=0) THEN
                           result := TRUE;
                           Assign(vonBox, box); (* Box, fr die die Stimme zhlt *)
                        END;
                     END;
                  ELSIF (recDepth<3) AND ((line[1]='g') OR (line[1]='G')) THEN
                     pos := Pos(' ', line);
                     IF pos<HIGH(line) THEN
                        Delete(line, 0, pos+1);
                        pos := Pos(';', line);
                        IF pos<HIGH(line) THEN
                           line[pos] := 0C;
                        END;
                        Trim(line);
                        pos := Pos("@", line);
                        IF pos<HIGH(line) THEN
                           Copy(line, pos+1, 8, box);
                           Trim(box);
                           Copy(line, 0, pos, gastName);
                           Trim(gastName);
                           IF (CompareNames(gastName, suchName)=0) THEN
                              result := DoIsSysop(line, nurBetreiber, box);
                           ELSE
                              box[0] := 0C;
                           END;
                        END;
                     END;
                  END;
               END;
            END;
            Close(file);
            IF debug THEN
               LogLine(" ' (IsSysop): Datei geschlossen");
            END;
            IF result THEN
               void.boolean := IsDoppelmaus(box);
            END;
         END;
      END;
      RETURN result;
   END DoIsSysop;

END FindeSysops;

PROCEDURE MausDomain(VAR str: ARRAY OF CHAR): BOOLEAN;
(*
 * TRUE genau dann, wenn es sich um eine MAUS handelt
 *)
VAR   result:  BOOLEAN;
BEGIN
   result := FALSE;
   Lower(str);
   IF Pos('.', str)>HIGH(str) THEN     (* keine Subdomain: MAUS oder Fido *)
      IF Pos(' ', str)<=HIGH(str) THEN (* Space in Domain: Fido-Adresse   *)
      ELSE                             (* kein Space:      MAUS-Adresse   *)
         result := TRUE;
      END;
   END;
   RETURN result;
END MausDomain;

PROCEDURE SetVAccess(this: CARDINAL);
BEGIN
   CASE cfv[this].access OF
   | vWorld:
      Assign("Abstimmungsberechtigt ist jeder, der eine PM an den Dmon schicken kann.",
             vAccess);
   | vMausNet:
      Assign("Abstimmungsberechtigt sind alle zahlenden User des MausNet.",
             vAccess);
   | vLocal:
      Assign("Abstimmungsberechtigt sind alle zahlenden User der lokalen MAUS.",
             vAccess);
   | vSysop:
      Assign("Abstimmungsberechtigt sind alle im ISB aufgefhrten Sysops des MausNet.",
             vAccess);
   | vBetreiber:
      Assign("Abstimmungsberechtigt sind alle im ISB aufgefhrten Betreiber des MausNet.",
             vAccess);
   ELSE
      (* kann gar nicht sein ... *)
   END;
END SetVAccess;

PROCEDURE ReplaceWildcards(VAR str:    ARRAY OF CHAR);
BEGIN
   IF vAddress[0]#0C THEN
      void.boolean := Replace(str, VADDRESS, vAddress);
   END;
   IF vVote[0]#0C THEN
      void.boolean := Replace(str, VVOTE, vVote);
   END;
   IF vTimeout[0]#0C THEN
      void.boolean := Replace(str, VTIMEOUT, vTimeout);
   END;
   IF vErrcause[0]#0C THEN
      void.boolean := Replace(str, VERRCAUSE, vErrcause);
   END;
   IF vAccess[0]#0C THEN
      void.boolean := Replace(str, VACCESS, vAccess);
   END;
   IF vReceived[0]#0C THEN
      void.boolean := Replace(str, VRECEIVED, vReceived);
   END;
   IF vReplyto[0]#0C THEN
      void.boolean := Replace(str, VREPLYTO, vReplyto);
   END;
   IF vCopyto[0]#0C THEN
      void.boolean := Replace(str, VCOPYTO, vCopyto);
   END;
   IF vBetreff[0]#0C THEN
      void.boolean := Replace(str, VBETREFF, vBetreff);
   END;
END ReplaceWildcards;


PROCEDURE DisposeDestRec(entry: ADDRESS);
VAR   dest: POINTER TO DestRec;
BEGIN
   dest := entry;
   DISPOSE(dest);
END DisposeDestRec;

PROCEDURE SetDefaults;
VAR   i: CARDINAL;
BEGIN
   quiet := FALSE;
   help := FALSE;
   debug := FALSE;
   logToStdOut := FALSE;
   Assign(CFGFILE, cfgFilename);
   Assign(CFG2FILE, cfg2Filename);
   Assign(LOGFILE, logFilename);
   Assign(CHEFFILE, chefFilename);
   Assign(VOTEFILE, dataFilename);
   Assign(INFILE, inFilename);
   Assign(OUTFILE, outFilename);
   Assign(FOLLOWUPTO, followupTo);
   Assign('', myName);
   FOR i := 0 TO MAXCFV-1 DO
      cfv[i].name[0] := 0C;
   END;
END SetDefaults;

PROCEDURE ReadConfig;
VAR   varname,
      value:   ARRAY [0 .. 80] OF CHAR;
      i:       CARDINAL;
      umlaute: CHAR;
BEGIN
   GetEnv('TMP', tmpPath);
   CorrectPath(tmpPath);
   IF ConfigFile.Read(cfgFilename) THEN
      void.boolean := ConfigFile.GetLongint('MaxMessageSize', MAXMSGSIZE, maxMsgSize);
      void.boolean := ConfigFile.GetLongint('MailLimitNet', MAILLIMIT, mailLimitNet);
      void.boolean := ConfigFile.GetLongint('MailLimitMausNet', MAILLIMIT, mailLimitMausNet);
      void.boolean := ConfigFile.GetLongint('MailLimitLocal', MAILLIMIT, mailLimitLocal);
      void.boolean := ConfigFile.GetBoolean('VerticalSplitting', FALSE, verticalSplitting);
      void.boolean := ConfigFile.GetBoolean('EnableVoteFunctions', TRUE, voteFunctions);
      void.boolean := ConfigFile.GetBoolean('AllowRemoteAccess', TRUE, remoteAccess);
      void.boolean := ConfigFile.GetBoolean('AllowLocalCFVs', FALSE, allowLocalCFVs);
      void.boolean := ConfigFile.GetBoolean('AllowListALs', FALSE, allowListALs);
      void.boolean := ConfigFile.GetBoolean('AllowPreview', FALSE, allowPreview);
      void.boolean := ConfigFile.GetBoolean('FollowupToPoster', TRUE, followupToPoster);
      void.boolean := ConfigFile.GetString('Signature', SIGNATURE,
                                           signature, void.boolean);
      void.boolean := ConfigFile.GetString('HelpListCommand', HELPLISTCMD,
                                           helpListCmd, void.boolean);
      void.boolean := ConfigFile.GetString('HelpListText', HELPLISTTEXT,
                                           helpListText, void.boolean);
      void.boolean := ConfigFile.GetCardinal('DefaultTimeoutCFV', STDTIMEOUT, timeoutCFV);
      void.boolean := ConfigFile.GetCardinal('DefaultTimeoutCFO', STDTIMEOUT, timeoutCFO);
      void.boolean := ConfigFile.GetString('DefaultGrpAlle', GRPALL,
                                           grpALL, void.boolean);
      void.boolean := ConfigFile.GetString('DefaultGrpMausNet', GRPMAUSNET,
                                           grpMAUSNET, void.boolean);
      void.boolean := ConfigFile.GetString('DefaultGrpLokal', GRPLOCAL,
                                           grpLOCAL, void.boolean);
      void.boolean := ConfigFile.GetString('DefaultGrpSysops', GRPSYSOP,
                                           grpSYSOP, void.boolean);
      void.boolean := ConfigFile.GetString('DefaultGrpBetreiber', GRPBETREIBER,
                                           grpBETREIBER, void.boolean);
      void.boolean := ConfigFile.GetString('DefaultGrpCFOs', GRPCFO,
                                           grpCFO, void.boolean);
      void.boolean := ConfigFile.GetString('CopyToAlle', '',
                                           copyToALL, void.boolean);
      void.boolean := ConfigFile.GetString('CopyToMausNet', '',
                                           copyToMAUSNET, void.boolean);
      void.boolean := ConfigFile.GetString('CopyToLokal', '',
                                           copyToLOCAL, void.boolean);
      void.boolean := ConfigFile.GetString('CopyToSysops', '',
                                           copyToSYSOP, void.boolean);
      void.boolean := ConfigFile.GetString('CopyToBetreiber', '',
                                           copyToBETREIBER, void.boolean);
      void.boolean := ConfigFile.GetString('CopyToCFOs', '',
                                           copyToCFO, void.boolean);
      void.boolean := ConfigFile.GetString('AdminAddress', DEFAULTADMIN,
                                           adminAddress, void.boolean);
      void.boolean := ConfigFile.GetString('HelpListLegend', '',
                                           helpListLegend, void.boolean);
      void.boolean := ConfigFile.GetString('DemonNames', DEMONNAMES,
                                           demonNames, void.boolean);
      void.boolean := ConfigFile.GetPath('LogPath', '', logPath);
      CorrectPath(logPath);
      Assign(logPath, logFilename);
      Append(logFilename, LOGFILE);
      void.boolean := ConfigFile.GetPath('ConfPath', '', confPath);
      CorrectPath(confPath);
      void.boolean := ConfigFile.GetPath('UserPath', '', userPath);
      CorrectPath(userPath);
      Assign(userPath, muserFilename);
      Append(muserFilename, MUSERFILE);
      void.boolean := ConfigFile.GetPath('TmpPath', tmpPath, tmpPath);
      CorrectPath(tmpPath);
      void.boolean := ConfigFile.GetPath('HelpPath', HELPPATH, helpPath);
      CorrectPath(helpPath);
      Insert(helpPath, cfg2Filename, 0);
      void.boolean := ConfigFile.GetPath('TemplatePath', TEMPLATEPATH, templatePath);
      CorrectPath(templatePath);
      IF NOT ConfigFile.GetCardinal('FileBuffer', fileBuffer DIV 1024,
                                    fileBuffer) THEN
         void.boolean := ConfigFile.GetCardinal('ReadBuffer', fileBuffer DIV 1024,
                                                fileBuffer);
      END;
      IF fileBuffer<1 THEN
         fileBuffer := 1;
      ELSIF fileBuffer>63 THEN
         fileBuffer := 63;
      END;
      fileBuffer := fileBuffer*1024;
   END;
END ReadConfig;


BEGIN
   ModReg.Register('VoteGlobals',0,0,' ',1997,08,16, PROC(NIL));

   GetDate(date);
   GetTime(time);
   tempIDhigh := ((DaysGone(date)*24L+LONG(time.h))*60L+LONG(time.m))*60L+LONG(time.s);
   tempIDlow := 0;


END VoteGlobals.
